; helloworld.asm - A simple "Hello, World!" program in GoAsm assembly 64-bit coding
;
; in a cmd window
; assemble using> goasm /x64 helloworld64.asm
; link using> golink /console helloworld64.obj kernel32.dll
; run it from the command line prompt > helloworld64
;
; note: open the file in xsed, then choose > File > Command Prompt 
; which will open a command window in the correct directory. 
; Don't try to compile the file in xsed.

DATA
ALIGN 8
		message_len dq 0 						    ; length of message string
		std_output_handle dq -11				; STD_OUTPUT_HANDLE (DWORD) -11
    message  db "Hello, World!", 0  ; String to print, including newline

CODE

START:

		; get length of message
		mov rax, addr message		;address pointer to message string
		call strlen							;call strlen
		mov [message_len], rax	;assign output to message_len
		mov rdx, [message_len]	;copy to rdx

    ; Get a handle to the standard output handle
;    push [std_output_handle]
;    call GetStdHandle
;    or use just INVOKE
;		INVOKE GetStdHandle, [std_output_handle] ;use INVOKE instead of push...call
		
		;64-bit
		ARG [std_output_handle]  ;return in rax, handle TO active screen buffer
		INVOKE GetStdHandle
		
    ; Write the message to the console
;    push 0
;    push 0
;    push edx 							;message_len (13d)
;    push addr message  		;message string
;    push eax 							;handle returned from GetStdHandle
;    call WriteConsoleA			;call function in kernel32.dll
;		 or use just INVOKE
;		INVOKE WriteConsoleA, eax, addr message, edx, 0, 0
		
		; 64-bit
		ARG 0, 0, rdx, addr message, rax
		INVOKE WriteConsoleA

    ; Exit the process
;    push 0
;    call ExitProcess
;		INVOKE ExitProcess, 0

		; 64-bit
		ARG 0
		INVOKE ExitProcess

; Function to calculate the length of a string
; Takes the string pointer in RAX

strlen:
    mov rcx, 0  ; Initialize counter to 0

loop:
    cmp b [rax], 0  	; Check if current byte is null terminator
    je >> end  				; If null, jump to end
    inc rax  					; Move pointer to next character
    inc rcx  					; Increment counter
    jmp << loop  			; Continue loop

end:
    mov rax, rcx  		; Return the calculated length
    ret