
' plot hilbert space filling curve
PROGRAM "hilbert"
VERSION "0.0001"
CONSOLE

'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xio"				' Console input/ouput library
  IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "msvcrt"		  ' msvcrt.dll

DECLARE FUNCTION Entry ()
DECLARE FUNCTION hilbert (x, y, m)

FUNCTION Entry ()

	RECT r

	hStdOut = XioGetStdOut ()
	XioSetConsoleBufferSize (hStdOut, 90, 100)
	hCon = XioGetConsoleWindow ()
	GetWindowRect(hCon, &r)
	MoveWindow(hCon, r.left, r.top, 800, 500, 1)

	N = 31   ' grid size = 2^n - 1

	FOR z = N*N - 1 TO 0 STEP -1
		hilbert (z MOD N, z/N, N/2)
		IF z MOD N THEN
			putchar (' ')
		ELSE
			putchar ('\n')
		END IF
	NEXT z
	?
	?
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION hilbert (x, y, m)

	x = m-ABS(m-x)
  IF (x==m || y==m) THEN
		IF x==0 || y==m+1 THEN
			putchar('@')
		ELSE
			putchar(' ')
		ENDIF
  ELSE
    IF (y > m) THEN
			hilbert (x, y & m, m/2)
    ELSE
			hilbert (y, x, m/2)
		END IF
  END IF

END FUNCTION
END PROGRAM