' 	IconService.x : Defines the entry point for the console application.
'	Original C++ version by Bruno Vais.

'	XBlite port by Michael McElligott



PROGRAM "IconService"
VERSION "0.002"
CONSOLE

	IMPORT "kernel32"
	IMPORT "advapi32"
	IMPORT "gdi32"
	IMPORT "user32"
	IMPORT "shell32"
	IMPORT "version"
	IMPORT "xio"

$$WM_ICON_NOTIFY = 1025
$$IDS_HELLO = 1
$$IDD_DIALOG1 = 101
$$IDR_POPUP = 101
$$IDI_STANDBY = 103
$$ID_POPUP_CLOSE = 40002


DECLARE FUNCTION main ()
DECLARE FUNCTION service_ctrl (dwCtrlCode)
DECLARE FUNCTION service_main (dwArgc, lpszArgv)
DECLARE FUNCTION CmdInstallService()
DECLARE FUNCTION CmdRemoveService()
DECLARE FUNCTION DialogProc(HWND_hwndDlg,UINT_uMsg,WPARAM_wParam,LPARAM_lParam)
DECLARE FUNCTION ServiceStart(dwArgc, lpszArgv)
DECLARE FUNCTION ServiceStop()
DECLARE FUNCTION ReportStatusToSCMgr(dwCurrentState, dwWin32ExitCode, dwWaitHint)
DECLARE FUNCTION Thread (var)
DECLARE FUNCTION SetServDescription (hService,STRING text)

FUNCTION main ()
	SERVICE_TABLE_ENTRY DT[] ' dispatchTable[]
	STRING cl


	#SERVICE_ALL_ACCESS = $$STANDARD_RIGHTS_REQUIRED | $$SERVICE_PAUSE_CONTINUE | $$SERVICE_QUERY_CONFIG | $$SERVICE_CHANGE_CONFIG | $$SERVICE_QUERY_STATUS | $$SERVICE_ENUMERATE_DEPENDENTS | $$SERVICE_START | $$SERVICE_STOP  | $$SERVICE_INTERROGATE | $$SERVICE_USER_DEFINED_CONTROL

	cl = CSTRING$(GetCommandLineA ())
	IF INSTRI(cl,"-install") THEN
		CmdInstallService()
	ELSE
		IF INSTRI(cl,"-remove") THEN
			CmdRemoveService()
		ELSE
			'	XioCreateConsole ("iconservice", 50)
			DIM DT[1]
			DT[0].lpServiceName = &"IconService"
			DT[0].lpServiceProc = &service_main()
			DT[1].lpServiceName = 0
			DT[1].lpServiceProc = 0

			StartServiceCtrlDispatcherA(&DT[])
			'	XioFreeConsole ()
		END IF
	END IF

	RETURN 0
END FUNCTION

FUNCTION Thread (lpParameter)
	STATIC dhwnd

	dhwnd = CreateDialogParamA (0,$$IDD_DIALOG1,0,0,0)
	DialogBoxParamA (NULL,$$IDD_DIALOG1,dhwnd,&DialogProc(),0)

	RETURN 0
END FUNCTION


FUNCTION service_main (dwArgc, lpszArgv)
	SHARED SERVICE_STATUS ssStatus        '   current status of the service
	SHARED SERVICE_STATUS_HANDLE sshStatusHandle


     '   register our service control handler:
	sshStatusHandle = RegisterServiceCtrlHandlerA( &"IconService", &service_ctrl())


     '   SERVICE_STATUS members that don't change in example
    ssStatus.dwServiceType = $$SERVICE_WIN32_OWN_PROCESS | $$SERVICE_INTERACTIVE_PROCESS
    ssStatus.dwServiceSpecificExitCode = 0


     '   report the status to the service control manager.
    dwErr = 0
    IF (!ReportStatusToSCMgr($$SERVICE_START_PENDING,$$NO_ERROR,3000)) THEN
		IF (sshStatusHandle) THEN
			ReportStatusToSCMgr($$SERVICE_STOPPED,dwErr,0)
			RETURN
		END IF
	END IF

	ServiceStart(dwArgc, lpszArgv)

     '   try to report the stopped status to the service control manager.
    IF (sshStatusHandle) THEN
        ReportStatusToSCMgr($$SERVICE_STOPPED,dwErr,0)
	END IF

END FUNCTION


FUNCTION service_ctrl (dwCtrlCode)
	SHARED SERVICE_STATUS ssStatus

     '   Handle the requested control code.
    SELECT CASE dwCtrlCode

         '   Stop the service.
         '
         '   SERVICE_STOP_PENDING should be reported before
         '   setting the Stop Event - hServerStopEvent - in
         '   ServiceStop().  This avoids a race condition
         '   which may result in a 1053 - The Service did not respond...
         '   error.
        CASE $$SERVICE_CONTROL_STOP:
            ReportStatusToSCMgr($$SERVICE_STOP_PENDING, $$NO_ERROR, 0)
            ServiceStop()
            RETURN

         '   Update the service status.
        CASE $$SERVICE_CONTROL_INTERROGATE:
         '   invalid control code
		END SELECT

    ReportStatusToSCMgr(ssStatus.dwCurrentState, $$NO_ERROR, 0)

END FUNCTION


 '
 '    FUNCTION: ReportStatusToSCMgr()
 '
 '    PURPOSE: Sets the current status of the service and
 '             reports it to the Service Control Manager
FUNCTION ReportStatusToSCMgr (dwCurrentState,dwWin32ExitCode, dwWaitHint)
	SHARED SERVICE_STATUS ssStatus        '   current status of the service
	SHARED SERVICE_STATUS_HANDLE sshStatusHandle
	STATIC dwCheckPoint


    fResult = 1
	dwCheckPoint = 1

    IF ( 1 )  THEN '   when debugging we don't report to the SCM

        IF (dwCurrentState == $$SERVICE_START_PENDING) THEN
            ssStatus.dwControlsAccepted = 0
        ELSE
            ssStatus.dwControlsAccepted = $$SERVICE_ACCEPT_STOP
        END IF

        ssStatus.dwCurrentState = dwCurrentState
        ssStatus.dwWin32ExitCode = dwWin32ExitCode
        ssStatus.dwWaitHint = dwWaitHint

        IF ( ( dwCurrentState == $$SERVICE_RUNNING ) || ( dwCurrentState == $$SERVICE_STOPPED ) )
            ssStatus.dwCheckPoint = 0
        ELSE
        	dwCheckPoint = dwCheckPoint + 1
            ssStatus.dwCheckPoint =  dwCheckPoint
        END IF

		' Report the status of the service to the service control manager.
		fResult = SetServiceStatus(sshStatusHandle, &ssStatus)
	END IF

    RETURN fResult
END FUNCTION

 '
 '    FUNCTION: CmdInstallService()
 '
 '    PURPOSE: Installs the service
FUNCTION CmdInstallService()
    SC_HANDLE   schService
    SC_HANDLE   schSCManager
    STRING szPath


    szPath = NULL$(520)
	IF ( GetModuleFileNameA( 0, &szPath, 512 ) == 0 ) THEN
        PRINT"Unable to install IconService\n"
        RETURN
    END IF

    schSCManager = OpenSCManagerA (0,0, $$SC_MANAGER_ALL_ACCESS )

    IF ( schSCManager )
        schService = CreateServiceA (schSCManager,&"IconService",&"Icon Service",#SERVICE_ALL_ACCESS,$$SERVICE_WIN32_OWN_PROCESS | $$SERVICE_INTERACTIVE_PROCESS, $$SERVICE_DEMAND_START, $$SERVICE_ERROR_NORMAL,&szPath, 0, 0, 0, 0, 0)

        IF ( schService ) THEN
        	SetServDescription (schService,"Example of a service application using XBlite.")
            CloseServiceHandle(schService)

			PRINT"IconService installed.\n"
        ELSE
            PRINT"CreateService failed"
        END IF
        CloseServiceHandle(schSCManager)
    ELSE
        PRINT"OpenSCManager failed"
	END IF

END FUNCTION

FUNCTION SetServDescription (hService,STRING text)
	FUNCADDR CSD(XLONG,XLONG,XLONG)
	STATIC hadvapi32Lib
	SERVICE_DESCRIPTION sd



	'IFZ hadvapi32Lib THEN
		hadvapi32Lib = LoadLibraryA (&"advapi32.dll")
		IFZ hadvapi32Lib THEN
			PRINT "unable to load advapi32.dll"
			RETURN 0
		END IF

		CSD = GetProcAddress (hadvapi32Lib, &"ChangeServiceConfig2A")
		IFZ CSD THEN
			PRINT "function not found ChangeServiceConfig2A"
			FreeLibrary (hadvapi32Lib)
			hadvapi32Lib = 0
			RETURN 0
		END IF

		sd.lpDescription = &text
		@CSD (hService,$$SERVICE_CONFIG_DESCRIPTION,&sd)
	'END IF


	IF hadvapi32Lib THEN
		FreeLibrary (hadvapi32Lib)
		hadvapi32Lib = 0
	END IF

	RETURN 1
END FUNCTION


 '
 '    FUNCTION: CmdRemoveService()
 '
 '    PURPOSE: Stops and removes the service
 '

FUNCTION CmdRemoveService()
	SHARED SERVICE_STATUS ssStatus
    SC_HANDLE   schService
    SC_HANDLE   schSCManager


    schSCManager = OpenSCManagerA (0, 0,$$SC_MANAGER_ALL_ACCESS )
    IF ( schSCManager ) THEN

        schService = OpenServiceA (schSCManager, &"IconService", #SERVICE_ALL_ACCESS)
        IF (schService) THEN
             '   try to stop the service
            IF ( ControlService( schService, $$SERVICE_CONTROL_STOP, &ssStatus ) ) THEN

                PRINT "Stopping IconService."
                Sleep( 1000 )
                DO
                    IF ( ssStatus.dwCurrentState == $$SERVICE_STOP_PENDING )
                        PRINT(".")
                        Sleep( 1000 )
                    ELSE
                        EXIT DO
                    END IF

                LOOP WHILE( QueryServiceStatus( schService, &ssStatus ) )

                IF ( ssStatus.dwCurrentState == $$SERVICE_STOPPED )
                    PRINT("\nIconService stopped.\n")
                ELSE
                    PRINT("\nFailed to stop IconService.\n")
                END IF

            END IF

             '   now remove the service
            IF( DeleteService(schService) ) THEN
				PRINT("IconService removed.\n")
			ELSE
				PRINT("DeleteService failed.\n")
				CloseServiceHandle(schService)
			END IF

        ELSE
            PRINT("OpenService failed.\n")
        END IF

        CloseServiceHandle(schSCManager)
    ELSE
        PRINT("OpenSCManager failed.\n")
    END IF

END FUNCTION


 '
 '    FUNCTION: ServiceStart
 '    PURPOSE: Actual code of the servicebthat does the work.

FUNCTION ServiceStart (dwArgc, lpszArgv)
    SHARED hServerStopEvent

     '   create the event object. The control handler function signals
     '   this event when it receives the "stop" control code.
    hServerStopEvent = CreateEventA ( 0,1,0,0)    '   no name

     '   report the status to the service control manager.
    IF (!ReportStatusToSCMgr($$SERVICE_RUNNING,$$NO_ERROR,0)) THEN
 		IF (hServerStopEvent) THEN
			CloseHandle(hServerStopEvent)
		END IF
		RETURN
	END IF

    CreateThread(NULL,0,&Thread(),NULL,0,NULL)
    WaitForSingleObject( hServerStopEvent,$$INFINITE )

   '  cleanup:
    IF (hServerStopEvent) THEN
        CloseHandle(hServerStopEvent)
    END IF

END FUNCTION



 '    FUNCTION: ServiceStop
 '    PURPOSE: Stops the service

FUNCTION ServiceStop()
	SHARED hServerStopEvent
	NOTIFYICONDATA ndata
	SHARED hwnd

    IF ( hServerStopEvent ) THEN
        SetEvent(hServerStopEvent)
    END IF

	ndata.hWnd=hwnd
	ndata.uID=2000

	Shell_NotifyIconA ($$NIM_DELETE,&ndata)
END FUNCTION

FUNCTION DialogProc(hwndDlg,uMsg,wParam,lParam)
	SHARED NOTIFYICONDATA ndata
	SHARED hwnd
	USER32_POINT pt


	SELECT CASE uMsg

	CASE $$WM_INITDIALOG:
		hwnd = hwndDlg

		ndata.cbSize = SIZE(NOTIFYICONDATA)
		ndata.hWnd = hwndDlg
		ndata.uID = 2000
		ndata.uFlags = $$NIF_ICON | $$NIF_MESSAGE | $$NIF_TIP
		ndata.uCallbackMessage = $$WM_ICON_NOTIFY
		ndata.hIcon = LoadIconA (GetModuleHandleA(0),&"IDI_STANDBY")
		ndata.szTip = "Hello!\nRight click then 'Stop' to Exit"

		Shell_NotifyIconA($$NIM_ADD,&ndata)
		SetWindowPos(hwndDlg,NULL,-10,-10,0,0,$$SWP_NOZORDER | $$SWP_NOMOVE)

	CASE $$WM_ICON_NOTIFY:

		IF (lParam == $$WM_RBUTTONDOWN) THEN
			menu = LoadMenuA (GetModuleHandleA (0),$$IDR_POPUP)
			smenu = GetSubMenu(menu, 0)
			GetCursorPos(&pt)
			TrackPopupMenu (smenu,$$TPM_LEFTALIGN,pt.x,pt.y,0,hwndDlg,0)
		END IF

	CASE $$WM_COMMAND:
		IF (wParam == $$ID_POPUP_CLOSE) THEN ServiceStop()
	END SELECT

	RETURN 0
END FUNCTION

END PROGRAM
