# Note: the next six lines are modified by the makefile-generator in xcowlite.x.
APP       = installed_ram
LIBS      = goxbl.dll xsx.dll
OBJS      = $(APP).obj
START     = START /W
XBLITE    = xblite -conoff -go
SUBSYSTEM = console

.SUFFIXES: .x .xl .xbl

# The linker
LD          = golink

# Flags for the linker
LDFLAGS     = /entry:WinMain /mix /files /$(SUBSYSTEM)

# Needed resources
RESOURCES   = $(APP)_rc.obj

# The resource compiler
RC          = gorc

# The assembler
AS          = goasm

# The main directory for \xblite
DIR         = $(XBLDIR)

# All needed standard libraries.
STDLIBS     = kernel32.dll user32.dll gdi32.dll comdlg32.dll comctl32.dll msvcrt.dll

ICON  			= xblite_icon.ico


# Default rules to compile a XBLite files into assembly files.
.x.asm:
	$(XBLITE) $?

.xl.asm:
	$(XBLITE) $?

.xbl.asm:
	$(XBLITE) $?


all: $(APP).exe

$(APP).exe: $(APP).obj $(RESOURCES)
	$(LD) $(LDFLAGS) $(OBJS) $(RESOURCES) $(LIBS) $(STDLIBS)

$(APP)_rc.obj: $(APP).rc $(ICON)
	$(RC) -fo $(APP)_rc.obj $(APP).rc

$(APP).obj: $(APP).asm
	$(AS) $(APP).asm

$(ICON):
	COPY /B $(DIR)\images\$(ICON) /B $(ICON) /Y


clean:
	IF EXIST $(APP)_rc.obj DEL $(APP)_rc.obj
	IF EXIST $(APP).def DEL $(APP).def
	IF EXIST $(APP).obj DEL $(APP).obj
	IF EXIST $(APP).asm DEL $(APP).asm
	IF EXIST $(ICON) DEL $(ICON)
	IF EXIST $(DIR)\programs\$(APP).exe DEL $(DIR)\programs\$(APP).exe
	COPY $(APP).exe $(DIR)\programs\$(APP).exe
	START $(DIR)\programs\$(APP).exe
