'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' This program demonstrates the use of the docksplitter.dll
' custom control.
'
PROGRAM	"docksplittest2"
VERSION	"0.0001"
'
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT	"xsx"
	IMPORT  "xio"
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll"
	IMPORT  "shell32"		' shell32.dll"
	IMPORT  "docksplitter"
'
DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hwnd, msg, wParam, lParam)
DECLARE FUNCTION  InitGui ()
DECLARE FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)
DECLARE FUNCTION  CreateWindows ()
DECLARE FUNCTION  NewWindow (className$, title$, style, x, y, w, h, exStyle)
DECLARE FUNCTION  MessageLoop ()
DECLARE FUNCTION  CleanUp ()
DECLARE FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

'Control IDs

$$Edit3    = 122
$$Edit4    = 123

$$Splitter3 = 142

$$SPLITTERCONSTANT = 125
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	STATIC	entry
'
	IF entry THEN RETURN					' enter once
	entry =  $$TRUE								' enter occured

	XioCreateConsole (title$, 150)	' create console, if console is not wanted, comment out this line
	InitGui ()										' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create main windows and other child controls
	MessageLoop ()								' the message loop
	CleanUp ()										' unregister all window classes
	XioFreeConsole ()							' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION  WndProc (hWnd, msg, wParam, lParam)

	NMSPLITTER nms
	RECT rc

	SELECT CASE msg

		CASE $$WM_SIZE :
			width = LOWORD(lParam)
			height = HIWORD(lParam)
			MoveWindow (#hSplitter3, 0, 0, width, height, 1)
'			pos = SendMessageA (#hSplitter3, $$WM_GET_SPLITTER_POSITION, 0, 0)
			' try to maintain a constant size for bottom child window
'			SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_POSITION, 0, height - $$SPLITTERCONSTANT)


		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE $$WM_NOTIFY :
			idCtrl = wParam
			RtlMoveMemory (&nms, lParam, SIZE (nms))
			PRINT "***** WM_NOTIFY message *****"
			PRINT "control id :"; idCtrl
			PRINT "hwndFrom   :"; nms.hdr.hwndFrom
			PRINT "code       :"; nms.hdr.code
			PRINT "x position :"; nms.x
			PRINT "y position :"; nms.y
			PRINT
			GetClientRect (#winMain, &rc)
'			SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_POSITION, 0, rc.bottom - $$SPLITTERCONSTANT)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT
END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION  InitGui ()

	SHARED hInst
	hInst = GetModuleHandleA (0)	' get current instance handle
	IFZ hInst THEN QUIT(0)
	InitCommonControls()					' initialize comctl32.dll library

END FUNCTION
'
'
' #################################
' #####  RegisterWinClass ()  #####
' #################################
'
FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION  CreateWindows ()

	SHARED className$, hInst
	RECT rc

' register window class
	className$  = "DockSplitterDemo"
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	IF RegisterWinClass (@className$, addrWndProc, @icon$, @menu$) THEN RETURN ($$TRUE)

' create main window
	title$  		= "DockSplitter Control Demo."
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 640
	h 					= 550
	exStyle			= 0
	#winMain = NewWindow (className$, title$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)
' create vertical splitter control

' create vertical splitter control

	GetClientRect (#winMain, &rc)

	#hSplitter3 = NewChild ($$DOCKSPLITTERCLASSNAME, "", 0, 0, 0, rc.right, rc.bottom, #winMain, $$Splitter3, 0)

' create edit control
	text$ = "This is a vertical splitter with two child edit controls"
	#hEdit3 = NewChild ($$EDIT, text$, $$ES_MULTILINE | $$ES_AUTOVSCROLL | $$WS_VSCROLL | $$ES_LEFT, 0, 0, 0, 0, #winMain, $$Edit3, $$WS_EX_CLIENTEDGE)

	text$ = "The default vertical splitter will dock to the bottom."
	#hEdit4 = NewChild ($$EDIT, text$, $$ES_MULTILINE | $$ES_AUTOVSCROLL | $$WS_VSCROLL | $$ES_LEFT, 0, 0, 0, 0, #winMain, $$Edit4, $$WS_EX_CLIENTEDGE)

' set splitter panel window handles
	SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_PANEL_HWND, #hEdit3, #hEdit4)

' set splitter control style (default is $$SS_HORZ - horizontal)
	SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_STYLE, 0, $$SS_VERT)

' set initial position of splitter panel
	SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_POSITION, 0, rc.bottom - $$SPLITTERCONSTANT)

' set button style
	SendMessageA (#hSplitter3, $$WM_SET_SPLITTER_BUTTON_STYLE, 0, $$BS_WINXP)


	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION  NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION  MessageLoop ()

	STATIC MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN			' main program executes message loop

	DO
		ret = GetMessageA (&msg, 0, 0, 0)

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam
			CASE -1 : RETURN $$TRUE
			CASE ELSE:
        hwnd = GetActiveWindow ()
        IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN
  				TranslateMessage (&msg)
  				DispatchMessageA (&msg)
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION  CleanUp ()

	SHARED hInst, className$
	UnregisterClassA(&className$, hInst)

END FUNCTION
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

' create child control
	style = style | $$WS_CHILD | $$WS_VISIBLE
	hwnd = CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)
	RETURN hwnd

END FUNCTION
END PROGRAM
