
VERSION	"0.0001"

'IMPORT	"xst_s" 
'IMPORT  "xsx_s"
IMPORT	"xst" 
IMPORT  "xsx"
IMPORT	"gdi32"     ' gdi32.dll
IMPORT  "user32"    ' user32.dll
IMPORT  "kernel32"  ' kernel32.dll
IMPORT  "comctl32"	' comctl32.dll"

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hwnd, msg, wParam, lParam)
DECLARE FUNCTION  InitGui ()
DECLARE FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)
DECLARE FUNCTION  CreateWindows ()
DECLARE FUNCTION  NewWindow (className$, title$, style, x, y, w, h, exStyle)
DECLARE FUNCTION  MessageLoop ()
DECLARE FUNCTION  Circle (hWnd, x, y, r, color, fill, hdc)

FUNCTION  Entry ()
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create main windows and other child controls
	MessageLoop ()										' the message loop
END FUNCTION

FUNCTION WndProc (hWnd, msg, wParam, lParam)

	SHARED hInst
	SHARED ma[]
	PAINTSTRUCT ps
	STATIC count

	SELECT CASE msg

		CASE $$WM_CREATE :
			GOSUB Init
			ret = MessageBoxA (hWnd, &"You have 28 moves with the left mouse-click to turn the 9 circles black or red. \r\nThe game is won when the center circle is black and all of the other 8 circles are red.   \r\nHowever, each selected circle will alter it's neighbors status.   \r\nGood Luck!", &"Game Rules", $$MB_ICONINFORMATION | $$MB_OK)

		CASE $$WM_DESTROY :
			PostQuitMessage (0)

		CASE $$WM_PAINT :

			hdc = BeginPaint (hWnd, &ps)

			FOR a = 0 TO 2
				FOR b = 0 TO 2
					IFZ ma[a, b] THEN
						color = RGB (10, 10, 10)
					ELSE
						color = RGB (170, 15, 35)
					END IF
					Circle (hWnd, a * 125 + 75, b * 125 + 75, 55, color, 1, hdc)
				NEXT b
			NEXT a
			EndPaint (hWnd, &ps)

		CASE $$WM_LBUTTONDOWN :
			x = LOWORD (lParam)
			y = HIWORD (lParam)

			IF x < 130 && y < 130 THEN bo = 1
			IF x > 130 && x < 260 && y < 130 THEN bo = 2
			IF x > 270 && y < 130 THEN bo = 3
			IF x < 130 && y > 130 && y < 260 THEN bo = 4
			IF x > 130 && x < 260 && y > 130 && y < 260 THEN bo = 5
			IF x > 270 && y > 130 && y < 260 THEN bo = 6
			IF x < 130 && y > 270 THEN bo = 7
			IF x > 130 && x < 260 && y > 270 THEN bo = 8
			IF x > 270 && y > 270 THEN bo = 9

			INC count
			txt$ = "Circle Game - click count is " + STRING$(count)
			SetWindowTextA (hWnd, &txt$)
			IF count > 28 THEN
				ret = MessageBoxA (hWnd, &"Game Over!   Play Again?     ", &"Game Over", $$MB_ICONQUESTION | $$MB_YESNO | $$MB_DEFBUTTON2)
				IF ret = $$IDNO THEN
					PostQuitMessage (0)
				END IF
				count = 0
			END IF

			SELECT CASE bo
				CASE 1 : GOSUB po1
				CASE 2 : GOSUB po2
				CASE 3 : GOSUB po3
				CASE 4 : GOSUB po4
				CASE 5 : GOSUB po5
				CASE 6 : GOSUB po6
				CASE 7 : GOSUB po7
				CASE 8 : GOSUB po8
				CASE 9 : GOSUB po9
			END SELECT

			' have we won?
			h = 0
			FOR a = 0 TO 2
				FOR b = 0 TO 2
					h = h + ma[a, b]
				NEXT b
			NEXT a
			IF ma[1, 1] = 0 && h = 8 THEN
				ret = MessageBoxA (hWnd, &"You Won!  Play Again?     ", &"Winner", $$MB_ICONQUESTION | $$MB_YESNO | $$MB_DEFBUTTON2)
				IF ret = $$IDNO THEN
					PostQuitMessage (0)
				ELSE
					GOSUB Init
					InvalidateRect (hWnd, NULL, 1)
				END IF
			END IF

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

SUB Init
	DIM ma[2, 2]
	FOR a = 0 TO 2
		FOR b = 0 TO 2
			ma[a, b] = XstRandomRange (0, 1)
		NEXT b
	NEXT a
END SUB

SUB po1
	IF ma[0, 0] = 1 THEN ma[0, 0] = 0 ELSE ma[0, 0] = 1
	IF ma[0, 1] = 0 THEN ma[0, 1] = 1 ELSE ma[0, 1] = 0
	IF ma[1, 0] = 0 THEN ma[1, 0] = 1 ELSE ma[1, 0] = 0
	IF ma[1, 1] = 0 THEN ma[1, 1] = 1 ELSE ma[1, 1] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po2
	IF ma[1, 0] = 1 THEN ma[1, 0] = 0 ELSE ma[1, 0] = 1
	IF ma[0, 0] = 0 THEN ma[0, 0] = 1 ELSE ma[0, 0] = 0
	IF ma[2, 0] = 0 THEN ma[2, 0] = 1 ELSE ma[2, 0] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po3
	IF ma[2, 0] = 1 THEN ma[2, 0] = 0 ELSE ma[2, 0] = 1
	IF ma[1, 0] = 0 THEN ma[1, 0] = 1 ELSE ma[1, 0] = 0
	IF ma[2, 1] = 0 THEN ma[2, 1] = 1 ELSE ma[2, 1] = 0
	IF ma[1, 1] = 0 THEN ma[1, 1] = 1 ELSE ma[1, 1] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po4
	IF ma[0, 1] = 1 THEN ma[0, 1] = 0 ELSE ma[0, 1] = 1
	IF ma[0, 0] = 0 THEN ma[0, 0] = 1 ELSE ma[0, 0] = 0
	IF ma[0, 2] = 0 THEN ma[0, 2] = 1 ELSE ma[0, 2] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po5
	IF ma[1, 1] = 1 THEN ma[1, 1] = 0 ELSE ma[1, 1] = 1
	IF ma[0, 1] = 0 THEN ma[0, 1] = 1 ELSE ma[0, 1] = 0
	IF ma[1, 0] = 0 THEN ma[1, 0] = 1 ELSE ma[1, 0] = 0
	IF ma[2, 1] = 0 THEN ma[2, 1] = 1 ELSE ma[2, 1] = 0
	IF ma[1, 2] = 0 THEN ma[1, 2] = 1 ELSE ma[1, 2] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po6
	IF ma[2, 1] = 1 THEN ma[2, 1] = 0 ELSE ma[2, 1] = 1
	IF ma[2, 0] = 0 THEN ma[2, 0] = 1 ELSE ma[2, 0] = 0
	IF ma[2, 2] = 0 THEN ma[2, 2] = 1 ELSE ma[2, 2] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po7
	IF ma[0, 2] = 1 THEN ma[0, 2] = 0 ELSE ma[0, 2] = 1
	IF ma[0, 1] = 0 THEN ma[0, 1] = 1 ELSE ma[0, 1] = 0
	IF ma[1, 2] = 0 THEN ma[1, 2] = 1 ELSE ma[1, 2] = 0
	IF ma[1, 1] = 0 THEN ma[1, 1] = 1 ELSE ma[1, 1] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po8
	IF ma[1, 2] = 1 THEN ma[1, 2] = 0 ELSE ma[1, 2] = 1
	IF ma[0, 2] = 0 THEN ma[0, 2] = 1 ELSE ma[0, 2] = 0
	IF ma[2, 2] = 0 THEN ma[2, 2] = 1 ELSE ma[2, 2] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

SUB po9
	IF ma[2, 2] = 1 THEN ma[2, 2] = 0 ELSE ma[2, 2] = 1
	IF ma[1, 2] = 0 THEN ma[1, 2] = 1 ELSE ma[1, 2] = 0
	IF ma[2, 1] = 0 THEN ma[2, 1] = 1 ELSE ma[2, 1] = 0
	IF ma[1, 1] = 0 THEN ma[1, 1] = 1 ELSE ma[1, 1] = 0
	InvalidateRect (hWnd, NULL, 1)
END SUB

END FUNCTION


FUNCTION  InitGui ()
	SHARED hInst
	hInst = GetModuleHandleA (0)	' get current instance handle
	IFZ hInst THEN QUIT(0)
	InitCommonControls()					' initialize comctl32.dll library
END FUNCTION


FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_DBLCLKS | $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH)
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$
	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)
END FUNCTION


FUNCTION  CreateWindows ()

	SHARED hInst, className$

' register window class
	className$  = "Circlegamedemo"
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	IF RegisterWinClass (@className$, addrWndProc, @icon$, @menu$) THEN RETURN ($$TRUE)

' create main window
	title$  		= "Circle Game Demo."
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 400
	h 					= 400 + GetSystemMetrics ($$SM_CYSIZE) ' add titlebar height
	exStyle			= 0
	#winMain = NewWindow (className$, title$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)
	
	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION


FUNCTION  NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION


FUNCTION  MessageLoop ()

	STATIC MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN			' main program executes message loop

	DO
		ret = GetMessageA (&msg, 0, 0, 0)

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam
			CASE -1 : RETURN $$TRUE
			CASE ELSE:
        hwnd = GetActiveWindow ()
        IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN
  				TranslateMessage (&msg)
  				DispatchMessageA (&msg)
				END IF
		END SELECT
	LOOP

END FUNCTION


FUNCTION Circle (hWnd, x, y, r, color, fill, hdc)

	IFZ hdc THEN
		hdc = GetDC (hWnd)
		b=1
	END IF
	
	hNPen = CreatePen ($$PS_SOLID, 1, color)
	hOPen = SelectObject (hdc, hNPen)
	
	IF (fill) THEN
		hNewBrush = CreateSolidBrush (color)
		hOldBrush = SelectObject (hdc, hNewBrush)
	ELSE
		hNewBrush = GetStockObject ($$NULL_BRUSH)
		hOldBrush = SelectObject (hdc, hNewBrush)
	END IF
	
	ret = Ellipse (hdc, x-r, y+r, x+r, y-r)
	DeleteObject (SelectObject(hdc, hOPen))
	DeleteObject (SelectObject(hdc, hOldBrush))
	IF (b) THEN ReleaseDC (hWnd, hdc)
	RETURN ret

END FUNCTION
END PROGRAM
