'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A gdiplus demo which loads and displays 
' BMP, DIB, RLE, JPG, JPEG, JPE, JFIF,
' EXIF, GIF, PNG, TIFF, TIF, WMF, EMF,
' and ICO files. It can save files as
' BMP, GIF, JPG, PNG, and TIF formats.
'
PROGRAM	"viewer"
VERSION	"0.0001"
'
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
  IMPORT  "comdlg32"	' comdlg32.dll			: common dialog library
	IMPORT  "gdiplus"
	IMPORT  "xbm"
	IMPORT  "canvas"
	
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION RegisterWinClass (className$, addrWndProc, icon$, menu$)
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (className$, titleBar$, style, x, y, w, h, exStyle)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION CleanUp          ()
DECLARE FUNCTION ARGB             (UBYTE alpha, UBYTE r, UBYTE g, UBYTE b)
DECLARE FUNCTION gdipLoadImage    (file$)
DECLARE FUNCTION GUIDAPI DEFINE_GUID (guid$)
DECLARE FUNCTION gdipGetEncoderCLSID  (format$, GUIDAPI classID)
DECLARE FUNCTION CompareMemory 		(addr1, addr2, length)
DECLARE FUNCTION gdipSaveAsBMP 		(image, file$)
DECLARE FUNCTION gdipSaveAsPNG 		(image, file$)
DECLARE FUNCTION gdipSaveAsTIF 		(image, file$)
DECLARE FUNCTION gdipSaveAsGIF 		(image, file$)
DECLARE FUNCTION gdipSaveAsJPG 		(image, file$, quality)
DECLARE FUNCTION ShowOpenFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)
DECLARE FUNCTION ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)
DECLARE FUNCTION gdipGetImage     (image, UBYTE image[])
'
' Control IDs
'
$$CC_CANVAS1 = 100
'
' Menu IDs
'
$$CM_FILE_OPEN = 101
$$CM_FILE_CLOSE = 102
$$CM_FILE_SAVEAS = 103
$$CM_FILE_EXIT = 104
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 500)		' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
	CleanUp ()												' unregister all window classes
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	SHARED hInst
	RECT rect
	STATIC UBYTE image[], destImage[]
	STATIC selectedFile$, currentPath$, hImage, bpp, hCanvas1
	STATIC imageWidth, imageHeight
	STATIC image
'
	SELECT CASE msg
'
		CASE $$WM_CREATE :
			GetClientRect (hWnd, &rect)
			hCanvas1 = NewChild ($$CANVASCLASSNAME, "", style, 0, 0, rect.right, rect.bottom, hWnd, $$CC_CANVAS1, 0)

		CASE $$WM_DESTROY :
			XbmDeleteMemBitmap (hImage)
			PostQuitMessage(0)

		CASE $$WM_SIZE :
			width = LOWORD(lParam)
			height = HIWORD (lParam)
			SetWindowPos (hCanvas1, 0, 0, 0, width, height, $$SWP_NOZORDER)
			
		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			SELECT CASE id
				CASE $$CM_FILE_OPEN 				:	filter$ = "Image Files (*.bmp, *.jpg, *.gif, *.png, *.tif, *.wmf, *.ico)" + CHR$(0) + "*.bmp;*.jpg;*.gif;*.png;*.tif;*.wmf;*.ico" + CHR$(0)
																			filter$ = filter$ + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
																			IF ShowOpenFileDialog (hWnd, @file$, filter$, currentPath$, "Open an Image File") THEN
																				IF file$ THEN
																					currentPath$ = LEFT$ (file$, RINSTR (file$, "\\"))
																					selectedFile$ = file$
																				GOSUB LoadImage
																				END IF
																			END IF

				CASE $$CM_FILE_CLOSE 				:	DIM image[]
																			XbmDeleteMemBitmap (hImage)
																			hImage = 0
																			SendMessageA (hCanvas1, $$WM_CLEAR_CANVAS_IMAGE, 0, 0)
																			selectedFile$ = ""
																			currentPath$ = ""
																			IF image THEN GdipDisposeImage (image)	
																			image = 0
																			GetClientRect (hWnd, &rect)
																			InvalidateRect (hWnd, &rect, 1)

				CASE $$CM_FILE_SAVEAS 			: IFZ image THEN RETURN
																			filter$ = "Image Files (*.bmp, *.jpg, *.gif, *.png, *.tif)" + CHR$(0) + "*.bmp;*.jpg;*.gif;*.png;*.tif" + CHR$(0) + CHR$(0)
																			file$ = ""
																			IF ShowSaveFileDialog (hWnd, @file$, filter$, currentPath$, "Save File As Image File") THEN
																				chk$ = RIGHT$(UCASE$(file$),4)
																				SELECT CASE chk$
																					CASE ".BMP" : gdipSaveAsBMP (image, file$)
																					CASE ".JPG" : gdipSaveAsJPG (image, file$, 0)
																					CASE ".GIF" : gdipSaveAsGIF (image, file$)  
																					CASE ".PNG" : gdipSaveAsPNG (image, file$)  
																					CASE ".TIF" : gdipSaveAsTIF (image, file$)  
																					CASE ELSE   : RETURN
																				END SELECT
																			END IF

				CASE $$CM_FILE_EXIT 				:	DestroyWindow (hWnd)
			END SELECT

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT


' ***** LoadImage *****
SUB LoadImage
	IFZ selectedFile$ THEN EXIT SUB
	DIM image[]
	
	IF image THEN GdipDisposeImage (image)	
  image = gdipLoadImage (selectedFile$)
	IFZ image THEN XstAlert ("Unable to load image.") : EXIT SUB
	
	error = gdipGetImage (image, @image[])
	IFZ image[] THEN XstAlert ("Unable to load image.") : EXIT SUB

	text$ = "gdi+ viewer [" + selectedFile$ + "]"
	SetWindowTextA (hWnd, &text$)
	GOSUB DisplayImage
END SUB
'
' ***** SUB DisplayImage *****
SUB DisplayImage

' display image in hCanvas1
	IF hImage THEN XbmDeleteMemBitmap (hImage)										' delete last memory bitmap
	XbmGetImageArrayInfo (@image[], @bpp, @imageWidth, @imageHeight)
	IF bpp < 8 THEN MessageBoxA (hWnd, &"Currently loaded image bitsperpixel is < 8.\nTransformations and filters not available.\nPlease load an 8-bit or 24-bit image.", &"Warning", $$MB_OK | $$MB_ICONEXCLAMATION)
	IFZ imageWidth * imageHeight THEN EXIT SUB
	IF bpp = 8 THEN XbmDIBto24Bit (@image[])											' convert to 24bpp (1-bit and 4-bit conversions not currently working in XbmDIBto24Bit)
	XbmCreateMemBitmap (hWnd, imageWidth, imageHeight, @hImage)		' create memory bitmap
	XbmSetImage (hImage, @image[])																' set image array into memory bitmap
	SendMessageA (hCanvas1, $$WM_SET_CANVAS_IMAGE, 0, hImage)			' display memory bitmap in canvas control

END SUB
END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	SHARED gdiPlusToken
	GdiplusStartupInput gsi
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
	' initialize gdiplus
	gsi.GdiplusVersion = 1
	err = GdiplusStartup (&gdiPlusToken, &gsi, NULL) 
	IF err THEN
		err$ = "GdiplusStartup error: " + STRING(err)
		MessageBoxA (0, &err$, &"Gdiplus error", $$MB_OK | $$MB_ICONWARNING)
		QUIT (0)
	END IF 	  

END FUNCTION
'
'
' #################################
' #####  RegisterWinClass ()  #####
' #################################
'
FUNCTION RegisterWinClass (className$, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH) ' $$COLOR_BTNFACE + 1 
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

' register window class
	className$  = "GdiPlusFileFormatDemo"
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= "menu"
	IF RegisterWinClass (@className$, addrWndProc, @icon$, @menu$) THEN RETURN ($$TRUE)

' create main window
	titleBar$ = "Gdiplus Image Format Demo"
	style 		= $$WS_OVERLAPPEDWINDOW
	w 				= 640
	h 				= 480
	exStyle		= 0
	#winMain = NewWindow (@className$, @titleBar$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

' create child control
	style = style | $$WS_CHILD | $$WS_VISIBLE
	hwnd = CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)
	RETURN hwnd

END FUNCTION
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION CleanUp ()

	SHARED hInst, className$
	SHARED gdiPlusToken

	UnregisterClassA (&className$, hInst)
	GdiplusShutdown (gdiplusToken)

END FUNCTION
'
' ##################
' #####  ARGB  #####
' ##################
'
' Return 32-bit color value form argb values
'
FUNCTION ARGB (UBYTE alpha, UBYTE r, UBYTE g, UBYTE b)

	RETURN alpha << 24 + r << 16 + g << 8 + b 

END FUNCTION
'
' ###########################
' #####  gdipLoadImage  #####
' ###########################
'
' Load image file into bitmap format
' Return value is handle to bitmap image object
'
FUNCTION gdipLoadImage (file$)

	IFZ file$ THEN RETURN
  fileWSize = (LEN (file$) * 2) + 2
  lpFileW = GlobalAlloc ($$GMEM_FIXED, fileWSize)
  MultiByteToWideChar ($$CP_ACP, 0, &file$, -1, lpFileW, fileWSize)
  GdipCreateBitmapFromFile (lpFileW, &bitmap)
  GlobalFree (lpFileW)
  IF bitmap THEN RETURN bitmap

END FUNCTION
'
' #########################
' #####  DEFINE_GUID  #####
' #########################
'
' convert a GUID string to GUIDAPI type
'
FUNCTION GUIDAPI DEFINE_GUID (guid$)

	GUIDAPI guid

	IFZ guid$ THEN RETURN guid
	
	guid.Data1    = ULONG ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data2    = USHORT ("0x" + XstNextItem$ (guid$, @index, @term, @done))
	guid.Data3    = USHORT ("0x" + XstNextItem$ (guid$, @index, @term, @done))
	guid.Data4[0] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[1] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[2] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[3] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[4] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[5] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[6] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	guid.Data4[7] = UBYTE ("0x" + XstNextItem$ (guid$, @index, @term, @done)) 
	
	RETURN guid
END FUNCTION
'
' #############################
' #####  GetEncoderCLSID  #####
' #############################
'
' Get GUID for image type from MIME string format, eg, "image/png".
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0.
'
FUNCTION gdipGetEncoderCLSID (format$, GUIDAPI classID)

	ImageCodecInfo ici

	IFZ format$ THEN RETURN

	result = 0
  num = 0
  size = 0
  formatSizeW = (LEN (format$) * 2) + 2
  lpFormatW = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, formatSizeW)
  IF lpFormatW THEN
    IF MultiByteToWideChar ($$CP_ACP, 0, &format$, -1, lpFormatW, LEN(format$)+1) THEN
      GdipGetImageEncodersSize (&num, &size)
      IF size THEN
        lpImageCodecInfoArray = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, size)
        IF lpImageCodecInfoArray THEN
          IFZ GdipGetImageEncoders (num, size, lpImageCodecInfoArray) THEN
						FOR j = 0 TO num - 1
							RtlMoveMemory (&ici, lpImageCodecInfoArray + (SIZE (ici) * j), SIZE(ici))
							IF CompareMemory (ici.MimeType, lpFormatW, formatSizeW) THEN
								classID = ici.ClassID
								result = $$TRUE
							END IF
						NEXT j
					END IF
        END IF
        GlobalFree (lpImageCodecInfoArray)
      END IF
    END IF
		GlobalFree (lpFormatW)
  END IF
  RETURN result

END FUNCTION
'
' ###########################
' #####  CompareMemory  #####
' ###########################
'
' Compare two memory areas and returns -1 if its equal
' or 0 if it doesn't match. length is number of bytes to compare.
'
FUNCTION CompareMemory (addr1, addr2, length)

	IFZ addr1 THEN RETURN 
	IFZ addr2 THEN RETURN
	IFZ length THEN RETURN
	
	FOR i = 0 TO length-1
		IF UBYTEAT(addr1 + i) <> UBYTEAT(addr2 + i) THEN RETURN 
	NEXT i 
	RETURN ($$TRUE)

END FUNCTION
'
' ###########################
' #####  gdipSaveAsBMP  #####
' ###########################
'
' Save image object to file in BMP format.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0. 
'
FUNCTION gdipSaveAsBMP (image, file$)

	UBYTE image[]

	IFZ file$ THEN RETURN
	IFZ image THEN RETURN

  GdipGetImageWidth (image, &w)
  GdipGetImageHeight (image, &h)
	IFZ w THEN RETURN
	IFZ h THEN RETURN

	hWnd      = GetDesktopWindow()	
	wndDC 		= GetDC (hWnd)
	hDC 			= CreateCompatibleDC (wndDC)

	IF hDC THEN
		hGraphic = CreateCompatibleBitmap (wndDC, w, h)
		ReleaseDC (hWnd, wndDC)
		
		IF hGraphic THEN
			lastObj = SelectObject (hDC, hGraphic)

			GdipCreateFromHDC (hDC, &GraphicObject1)
			
			IF GraphicObject1 THEN
'				IFZ GdipDrawImageI (GraphicObject1, image, 0, 0) THEN
				IFZ GdipDrawImageRectI (GraphicObject1, image, 0, 0, w, h) THEN
					IF XbmGetImage (hGraphic, @image[]) THEN
						IF XbmSaveImage (file$, @image[]) THEN ret = $$TRUE
					END IF
				END IF
				GdipDeleteGraphics (GraphicObject1)
			END IF

			SelectObject (hDC, lastObj)
			ReleaseDC (hGraphic, hDC) 
			DeleteObject (hGraphic)
		END IF
	END IF 
	
	RETURN ret
	
END FUNCTION
'
' ###########################
' #####  gdipSaveAsPNG  #####
' ###########################
'
' Save image object to file in PNG format.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0.  
'
FUNCTION gdipSaveAsPNG (image, file$)

	GUIDAPI encoderClsid 

	IFZ file$ THEN RETURN
	IFZ image THEN RETURN

' for now, assume extension is .png

  fileSizeW = LEN(file$)*2 + 2
  lpFileW = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, fileSizeW)
  MultiByteToWideChar ($$CP_ACP, 0, &file$, -1, lpFileW, fileSizeW)
  IF gdipGetEncoderCLSID ("image/png", @encoderClsid) THEN
    IFZ GdipSaveImageToFile (image, lpFileW, &encoderClsid, 0) THEN ret = $$TRUE
  END IF
  GlobalFree (lpFileW)
  RETURN ret

END FUNCTION
'
' ###########################
' #####  GdipSaveAsTIF  #####
' ###########################
'
' Save image object to file in TIF format.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0.  
'
FUNCTION gdipSaveAsTIF (image, file$)

	GUIDAPI encoderClsid 

	IFZ file$ THEN RETURN
	IFZ image THEN RETURN

' for now, assume extension is .tif

  fileSizeW = LEN(file$)*2 + 2
  lpFileW = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, fileSizeW)
  MultiByteToWideChar ($$CP_ACP, 0, &file$, -1, lpFileW, fileSizeW)
  IF gdipGetEncoderCLSID ("image/tiff", @encoderClsid) THEN 
    IFZ GdipSaveImageToFile (image, lpFileW, &encoderClsid, 0) THEN ret = $$TRUE  
  END IF
  GlobalFree (lpFileW)
  RETURN ret

END FUNCTION
'
' ###########################
' #####  GdipSaveAsGIF  #####
' ###########################
'
' Save image object to file in GIF format.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0.  
'
FUNCTION gdipSaveAsGIF (image, file$)

	GUIDAPI encoderClsid 

	IFZ file$ THEN RETURN
	IFZ image THEN RETURN

' for now, assume extension is .gif

  fileSizeW = LEN(file$)*2 + 2
  lpFileW = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, fileSizeW)
  MultiByteToWideChar ($$CP_ACP, 0, &file$, -1, lpFileW, fileSizeW)
  IF gdipGetEncoderCLSID ("image/gif", @encoderClsid) THEN
    IFZ GdipSaveImageToFile (image, lpFileW, &encoderClsid, 0) THEN ret = $$TRUE  
  END IF
  GlobalFree (lpFileW)
  RETURN ret

END FUNCTION
'
' ###########################
' #####  gdipSaveAsJPG  #####
' ###########################
'
' Save image object to file in JPG format.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0.  
'
FUNCTION gdipSaveAsJPG (image, file$, quality)

	GUIDAPI encoderClsid 
	STATIC EncoderParameters ep
	STATIC quality$

	IFZ file$ THEN RETURN
	IFZ image THEN RETURN

' note: quality not working. if ep.Paramter.Guid is assigned, program crashes
	
'	IFZ quality$ THEN 
'		quality$ = "1d5be4b5,fa4a,452d,9c,dd,5d,b3,51,05,e7,eb"
'		ep.Count = 1
'		ep.Parameter.Guid = DEFINE_GUID (quality$) 
'		ep.Parameter.NumberOfValues = 1
'		ep.Parameter.Type = $$EncoderParameterValueTypeLong
'	END IF
	
'	ep.Parameter.Value = quality 

' for now, assume extension is .jpg

  fileSizeW = LEN(file$)*2 + 2
  lpFileW = GlobalAlloc ($$GMEM_FIXED | $$GMEM_ZEROINIT, fileSizeW)
  MultiByteToWideChar ($$CP_ACP, 0, &file$, -1, lpFileW, fileSizeW)
  IF gdipGetEncoderCLSID ("image/jpeg", @encoderClsid) THEN
'    GdipSaveImageToFile (image, lpFileW, &encoderClsid, &ep) 
		IFZ GdipSaveImageToFile (image, lpFileW, &encoderClsid, 0) ret = $$TRUE   
  END IF
  GlobalFree (lpFileW)
  RETURN ret

END FUNCTION
'
'
' ###################################
' #####  ShowOpenFileDialog ()  #####
' ###################################
'
FUNCTION  ShowOpenFileDialog (hWndOwnder, @fileName$, filter$, initDir$, title$)

	OPENFILENAME ofn
	SHARED hInst

	ofn.lStructSize = LEN(ofn)				'set length of struct
	ofn.hwndOwner 	= hWndOwner				'set parent window handle
	ofn.hInstance 	= hInst						'set the application's instance

'select a filter
'pstrFilter points to a buffer containing pairs of null-terminated
'filter strings. The first string in each pair describes a filter
'(for example, "Text Files"), and the second specifies the
'filter pattern (for example, "*.TXT"). Multiple filters can be
'specified for a single item by separating the filter pattern strings
'with a semicolon (for example, "*.TXT;*.DOC;*.BAK"). The last string
'in the buffer must be terminated by two NULL characters. If this member
'is NULL, the dialog box will not display any filters.
'The filter strings are assumed to be in the proper order - the
'operating system does not change the order.

'	filter$ = "XB Files (*.x, *.dec)" + CHR$(0) + "*.x;*.dec" + CHR$(0) + "Text Files (*.txt)" + CHR$(0) + "*.txt" + CHR$(0) + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
	ofn.lpstrFilter = &filter$

' create a buffer for the returned file
	IF fileName$ = "" THEN
		fileName$ = SPACE$(254)
	ELSE
		fileName$ = fileName$ + SPACE$(254 - LEN(fileName$))
	END IF
	ofn.lpstrFile 			= &fileName$

	ofn.nMaxFile 				= 255					'set the maximum length of a returned file

	buffer2$ = SPACE$(254)
	ofn.lpstrFileTitle 	= &buffer2$		'Create a buffer for the file title
	ofn.nMaxFileTitle 	= 255					'Set the maximum length of a returned file title
	ofn.lpstrInitialDir = &initDir$		'Set the initial directory
  ofn.lpstrTitle 			= &title$			'Set the title
  ofn.flags = $$OFN_FILEMUSTEXIST OR $$OFN_PATHMUSTEXIST OR $$OFN_EXPLORER	'flags

' call dialog
	IFZ GetOpenFileNameA (&ofn) THEN
		fileName$ = ""
		RETURN 0
	ELSE
		fileName$ = CSTRING$(ofn.lpstrFile)
		RETURN $$TRUE
	END IF

END FUNCTION
'
'
' ###################################
' #####  ShowSaveFileDialog ()  #####
' ###################################
'
FUNCTION  ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)

	OPENFILENAME ofn
	SHARED hInst

	ofn.lStructSize = LEN(ofn)			'set length of struct
	ofn.hwndOwner 	= hWndOwner			'set parent window handle
	ofn.hInstance 	= hInst					'set the application's instance

'select a filter
'pstrFilter points to a buffer containing pairs of null-terminated
'filter strings. The first string in each pair describes a filter
'(for example, "Text Files"), and the second specifies the
'filter pattern (for example, "*.TXT"). Multiple filters can be
'specified for a single item by separating the filter pattern strings
'with a semicolon (for example, "*.TXT;*.DOC;*.BAK"). The last string
'in the buffer must be terminated by two NULL characters. If this member
'is NULL, the dialog box will not display any filters.
'The filter strings are assumed to be in the proper order - the
'operating system does not change the order.

'	filter$ = "XB Files (*.x, *.dec)" + CHR$(0) + "*.x;*.dec" + CHR$(0) + "Text Files (*.txt)" + CHR$(0) + "*.txt" + CHR$(0) + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
	ofn.lpstrFilter = &filter$

' create a buffer for the returned file
	IF fileName$ = "" THEN
		fileName$ = SPACE$(254)
	ELSE
		fileName$ = fileName$ + SPACE$(254 - LEN(fileName$))
	END IF
	ofn.lpstrFile 			= &fileName$

	ofn.nMaxFile 				= 255					'set the maximum length of a returned file
	buffer2$ = SPACE$(254)
	ofn.lpstrFileTitle 	= &buffer2$		'Create a buffer for the file title
	ofn.nMaxFileTitle 	= 255					'Set the maximum length of a returned file title
	ofn.lpstrInitialDir = &initDir$		'Set the initial directory
  ofn.lpstrTitle 			= &title$			'Set the title
  ofn.flags = $$OFN_PATHMUSTEXIST OR $$OFN_EXPLORER	'flags

' call dialog
	IFZ GetSaveFileNameA (&ofn) THEN
		fileName$ = ""
		RETURN 0
	ELSE
		fileName$ = CSTRING$(ofn.lpstrFile)
		RETURN $$TRUE
	END IF

END FUNCTION
'
' ##########################
' #####  gdipGetImage  #####
' ##########################
'
' Return an image array from a gdi+ image object.
' If the function succeeds, the return value is -1. 
' If the function fails, the return value is 0. 
'
FUNCTION gdipGetImage (image, UBYTE image[])

	IFZ image THEN RETURN

  GdipGetImageWidth (image, &w)
  GdipGetImageHeight (image, &h)

	IFZ w THEN RETURN
	IFZ h THEN RETURN

	hWnd      = GetDesktopWindow()	
	wndDC 		= GetDC (hWnd)
	hDC 			= CreateCompatibleDC (wndDC)

	IF hDC THEN
		hGraphic = CreateCompatibleBitmap (wndDC, w, h)
		ReleaseDC (hWnd, wndDC)
		
		IF hGraphic THEN
			lastObj = SelectObject (hDC, hGraphic)

			GdipCreateFromHDC (hDC, &GraphicObject1)
			
			IF GraphicObject1 THEN
'				IFZ GdipDrawImageI (GraphicObject1, image, 0, 0) THEN
				IFZ GdipDrawImageRectI (GraphicObject1, image, 0, 0, w, h) THEN
					IF XbmGetImage (hGraphic, @image[]) THEN ret = $$TRUE
				END IF
				GdipDeleteGraphics (GraphicObject1)
			END IF

			SelectObject (hDC, lastObj)
			ReleaseDC (hGraphic, hDC) 
			DeleteObject (hGraphic)
		END IF
	END IF 
	
	RETURN ret

END FUNCTION
END PROGRAM
