'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Example of docking and undocking child windows to parent window
'
VERSION	"0.0000"
'
	IMPORT  "xst"
	IMPORT  "xsx"
	IMPORT	"gdi32"
	IMPORT  "user32"
	IMPORT  "kernel32"
	IMPORT  "comctl32"
'
TYPE MANAGEDWINDOW
	XLONG			.hwnd
	XLONG			.parent
	XLONG			.docked
	XLONG			.currentDockZone
	XLONG			.zone
	XLONG			.oldProc
	XLONG			.leftMouseDown
	XLONG			.invalidZone[9]'$$MaxDockZones
	XLONG			.captionHeight
	XLONG			.frameWidth
	XLONG			.parentCaptionHeight
	XLONG			.parentFrameWidth
	'FUNCADDR	.onDock()
	'FUNCADDR	.onUnDock()
	'FUNCADDR	.onOverDockZone()
END TYPE
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)

DECLARE FUNCTION AddDockZone (RECT rect)
DECLARE FUNCTION RemoveDockZone (zone)
DECLARE FUNCTION AddManagedWindow (hWnd,hParent,frameWidth,captionHeight,parentFrameWidth,parentCaptionHeight)
DECLARE FUNCTION ManagedWindowProc (hWnd, msg, wParam, lParam)
DECLARE FUNCTION DockManagerCreate (brush,border)
DECLARE FUNCTION GetWindowIndex (hWnd)
'
'constants
$$MaxWindows=9
$$MaxDockZones=9

'global variables
RECT DockZone[]
MANAGEDWINDOW ManagedWindow[]
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect

	SELECT CASE msg

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	INITCOMMONCONTROLSEX icc
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
	' initialize the common control classes
  icc.dwSize = SIZE(icc)
  icc.dwICC  = $$ICC_ANIMATE_CLASS      OR _
               $$ICC_BAR_CLASSES        OR _
               $$ICC_COOL_CLASSES       OR _
               $$ICC_DATE_CLASSES       OR _
               $$ICC_HOTKEY_CLASS       OR _
               $$ICC_INTERNET_CLASSES   OR _
               $$ICC_LISTVIEW_CLASSES   OR _
               $$ICC_NATIVEFNTCTL_CLASS OR _
               $$ICC_PAGESCROLLER_CLASS OR _
               $$ICC_PROGRESS_CLASS     OR _
               $$ICC_TAB_CLASSES        OR _
               $$ICC_TREEVIEW_CLASSES   OR _
               $$ICC_UPDOWN_CLASS       OR _
               $$ICC_USEREX_CLASSES     OR _
               $$ICC_WIN95_CLASSES
  InitCommonControlsEx (&icc)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	RECT rect

	' create main window
	titleBar$ 	= "Window Docking Manager Test"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 600
	h 					= 500
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= ""
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

	'create the manager
	DockManagerCreate (0,5)
	
	titleBar$ 	= "Control Properties"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 200
	h 					= 400
	exStyle			= $$WS_EX_TOOLWINDOW
	addrWndProc = &WndProc()
	icon$ 			= ""
	menu$ 			= ""
	window1 = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ window1 THEN RETURN ($$TRUE)
	XstCenterWindow (window1)
	ShowWindow (window1, $$SW_SHOWNORMAL)
	
	titleBar$ 	= "Window Properties"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 200
	h 					= 400
	exStyle			= $$WS_EX_TOOLWINDOW
	addrWndProc = &WndProc()
	icon$ 			= ""
	menu$ 			= ""
	window2 = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ window2 THEN RETURN ($$TRUE)
	XstCenterWindow (window2)
	ShowWindow (window2, $$SW_SHOWNORMAL)
	
	titleBar$ 	= "Some Other Window"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 200
	h 					= 400
	exStyle			= $$WS_EX_TOOLWINDOW
	addrWndProc = &WndProc()
	icon$ 			= ""
	menu$ 			= ""
	window3 = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ window3 THEN RETURN ($$TRUE)
	XstCenterWindow (window3)
	ShowWindow (window3, $$SW_SHOWNORMAL)
	
	rect.top=0
	rect.left=0
	rect.right=200
	rect.bottom=500
	AddDockZone (rect)
	
	rect.top=0
	rect.left=190
	rect.right=600
	rect.bottom=200
	AddDockZone (rect)
	
	rect.top=200
	rect.left=190
	rect.right=400
	rect.bottom=400
	AddDockZone (rect)
	
	AddManagedWindow (window1,#winMain,5,GetSystemMetrics ($$SM_CYSMCAPTION),5,34)
	AddManagedWindow (window2,#winMain,5,GetSystemMetrics ($$SM_CYSMCAPTION),5,34)
	AddManagedWindow (window3,#winMain,5,GetSystemMetrics ($$SM_CYSMCAPTION),5,34)

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR(className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION
'
' #########################
' #####  AddDockZone  #####
' #########################
'
'
'
FUNCTION AddDockZone (RECT rect)

	SHARED RECT DockZone[]

	FOR i=0 TO $$MaxDockZones
		IF DockZone[i].left==0 && DockZone[i].top==0 && DockZone[i].right==0 && DockZone[i].bottom==0
			DockZone[i]=rect
			RETURN $$TRUE
		END IF
	NEXT i
	
	RETURN $$FALSE

END FUNCTION
'
' ############################
' #####  RemoveDockZone  #####
' ############################
'
'
'
FUNCTION RemoveDockZone (zone)

	SHARED RECT DockZone[]
	
	IF zone<0 || zone>UBOUND(DockZone[]) THEN RETURN $$FALSE
	DockZone[i].left=0
	DockZone[i].top=0
	DockZone[i].right=0
	DockZone[i].bottom=0
	RETURN $$FALSE

END FUNCTION
'
' ##############################
' #####  AddManagedWindow  #####
' ##############################
'
'
'
FUNCTION AddManagedWindow (hWnd,hParent,frameWidth,captionHeight,parentFrameWidth,parentCaptionHeight)

	SHARED MANAGEDWINDOW ManagedWindow[]
	
	FOR i=0 TO $$MaxWindows
		IFZ ManagedWindow[i].hwnd
			ManagedWindow[i].hwnd=hWnd
			ManagedWindow[i].docked=$$FALSE
			ManagedWindow[i].currentDockZone=-1
			ManagedWindow[i].zone=-1
			ManagedWindow[i].oldProc=SetWindowLongA (hWnd, $$GWL_WNDPROC, &ManagedWindowProc ())
			ManagedWindow[i].parent=hParent
			ManagedWindow[i].captionHeight=captionHeight
			ManagedWindow[i].frameWidth=frameWidth
			ManagedWindow[i].parentCaptionHeight=parentCaptionHeight
			ManagedWindow[i].parentFrameWidth=parentFrameWidth
			FOR t=0 TO $$MaxDockZones
				ManagedWindow[i].invalidZone[t]=-1
			NEXT t
			RETURN $$TRUE
		END IF
	NEXT i
	
	RETURN $$FALSE

END FUNCTION
'
' ###############################
' #####  ManagedWindowProc  #####
' ###############################
'
'
'
FUNCTION ManagedWindowProc (hWnd, msg, wParam, lParam)
	
	PAINTSTRUCT ps
	RECT rect
	POINT pt,temp
	WINDOWPOS wp
	
	SHARED MANAGEDWINDOW ManagedWindow[]
	SHARED RECT DockZone[]
	SHARED focusBrush,border
	
	'get this index
	window=GetWindowIndex (hWnd)
	IF window==-1 THEN RETURN

	SELECT CASE msg

		CASE $$WM_NCLBUTTONDOWN:
			IFF ManagedWindow[window].leftMouseDown THEN ManagedWindow[window].leftMouseDown=$$TRUE
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

		CASE $$WM_NCHITTEST:
			'since windoze captures the mouse, we can't use $$WM_NCLBUTTONUP.  So we have to use this little patch to detect when the left button is released.
			IFT ManagedWindow[window].leftMouseDown
				ManagedWindow[window].leftMouseDown=$$FALSE
				IF ManagedWindow[window].currentDockZone>-1
					FOR t=0 TO $$MaxWindows
						IF ManagedWindow[t].docked==$$TRUE && ManagedWindow[t].zone==ManagedWindow[window].currentDockZone THEN valid=$$FALSE:EXIT FOR ELSE valid=$$TRUE
					NEXT t
					IFT valid
						InvalidateRect (ManagedWindow[window].parent, &DockZone[ManagedWindow[window].currentDockZone], $$TRUE)
						ManagedWindow[window].docked=$$TRUE
						ManagedWindow[window].zone=ManagedWindow[window].currentDockZone
						SetParent (hWnd, ManagedWindow[window].parent)
						rect=DockZone[ManagedWindow[window].currentDockZone]
						MoveWindow (hWnd, rect.left, rect.top, (rect.right-rect.left)-ManagedWindow[window].frameWidth*2, ((rect.bottom-rect.top)-ManagedWindow[window].captionHeight)-ManagedWindow[window].frameWidth*3, $$TRUE)
					END IF
				END IF
			END IF
			
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

		CASE $$WM_MOVING:
			'make sure the window is not already docked
			IFF ManagedWindow[window].docked
			
				'get window position
				XstCopyMemory (lParam, &wp, SIZE(wp))
				GetWindowRect (hWnd, &rect)
				pt.x=rect.left
				pt.y=rect.top
				ScreenToClient (ManagedWindow[window].parent, &pt)
				
				frameWidth=ManagedWindow[window].parentFrameWidth
				captionHeight=ManagedWindow[window].parentCaptionHeight

				'retrieve the dock zone we are under
				IF ManagedWindow[window].currentDockZone=-1
					FOR i=0 TO $$MaxDockZones
						IF DockZone[i].top>0 || DockZone[i].left>0 || DockZone[i].right>0 || DockZone[i].bottom>0
							IF pt.x<DockZone[i].right-frameWidth && pt.x>DockZone[i].left && pt.y>DockZone[i].top && pt.y<DockZone[i].bottom-captionHeight
								ManagedWindow[window].currentDockZone=i
								EXIT FOR
							END IF
						END IF
					NEXT i
				ELSE
					zone=ManagedWindow[window].currentDockZone
					IF zone>-1
						IF pt.x<DockZone[zone].right-frameWidth && pt.x>DockZone[zone].left && pt.y>DockZone[zone].top && pt.y<DockZone[zone].bottom-captionHeight
								FOR t=0 TO $$MaxWindows
									IF ManagedWindow[t].docked==$$TRUE && ManagedWindow[t].zone==zone THEN valid=$$FALSE:EXIT FOR ELSE valid=$$TRUE
								NEXT t
								IFT valid
									InvalidateRect (ManagedWindow[window].parent, &DockZone[zone], $$TRUE)
									hdc=BeginPaint (ManagedWindow[window].parent, &ps)
									hbrushOrig=SelectObject(hdc, focusBrush)
									width=DockZone[zone].right-DockZone[zone].left-frameWidth
									height=DockZone[zone].bottom-DockZone[zone].top-captionHeight
									PatBlt(hdc, DockZone[zone].left+border, DockZone[zone].top, width-border, border, $$PATINVERT)
									PatBlt(hdc, DockZone[zone].left+width-border, DockZone[zone].top+border, border, height-border, $$PATINVERT)
									PatBlt(hdc, DockZone[zone].left, DockZone[zone].top+height-border, width-border, border, $$PATINVERT)
									PatBlt(hdc, DockZone[zone].left, DockZone[zone].top, border, height-border, $$PATINVERT)
									SelectObject(hdc, hbrushOrig)
									EndPaint (ManagedWindow[window].parent, &ps)
								END IF
						ELSE
							InvalidateRect (ManagedWindow[window].parent, &DockZone[zone], $$TRUE)
							ManagedWindow[window].currentDockZone=-1
						END IF
					END IF
				END IF
			ELSE
				ManagedWindow[window].docked=$$FALSE
				ManagedWindow[window].currentDockZone=-1
				ManagedWindow[window].zone=-1
				SetParent (hWnd, $$HWND_DESKTOP)
			END IF

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT


END FUNCTION
'
' ###############################
' #####  DockManagerCreate  #####
' ###############################
'
'
'
FUNCTION DockManagerCreate (brush,focusWidth)

	SHARED RECT DockZone[]
	SHARED MANAGEDWINDOW ManagedWindow[]
	SHARED focusBrush,border
	
	USHORT bmp[]
	
	DIM DockZone[$$MaxDockZones]
	DIM ManagedWindow[$$MaxWindows]
	
	IFZ brush
		DIM bmp[7]
		bmp[0]=0x55
		bmp[1]=0xaa
		bmp[2]=0x55
		bmp[3]=0xaa
		bmp[4]=0x55
		bmp[5]=0xaa
		bmp[6]=0x55
		bmp[7]=0xaa
		hbmp=CreateBitmap (8,8,1,1,&bmp[])
		focusBrush=CreatePatternBrush (hbmp)
		DeleteObject (hbm)
	ELSE
		focusBrush=brush
	END IF
	
	border=focusWidth

END FUNCTION
'
' ############################
' #####  GetWindowIndex  #####
' ############################
'
'
'
FUNCTION GetWindowIndex (hWnd)

	SHARED MANAGEDWINDOW ManagedWindow[]
	
	upp=UBOUND(ManagedWindow[])
	FOR i=0 TO upp
		IF ManagedWindow[i].hwnd==hWnd THEN RETURN i
	NEXT i
	
	RETURN -1

END FUNCTION
END PROGRAM
