'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Draw a hilbert curve

VERSION	"0.0001"
'
'	IMPORT  "xst_s.lib"
'	IMPORT  "xsx_s.lib"
'	IMPORT  "xio_s.lib"
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "shell32"   ' shell32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)
DECLARE FUNCTION DrawHilbert 			(hDC, stage, LeftOrRight)
DECLARE FUNCTION TurnDirection    (direction)
DECLARE FUNCTION OnDraw           (hWnd, hDC, m_stage)

$$TURNLEFT  =  1
$$TURNRIGHT = -1

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect

	SELECT CASE msg

'		CASE $$WM_CREATE :

'		CASE $$WM_COMMAND :
'			id         = LOWORD(wParam)
'			hwndCtl    = lParam
'			notifyCode = HIWORD(wParam)
'			SELECT CASE id
'			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

'		CASE $$WM_NOTIFY :
'			idCtrl = wParam
'			SELECT CASE idCtrl
'				CASE $$ListView1 :
'					GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)
'					SELECT CASE code :
'					END SELECT
'			END SELECT

		CASE $$WM_PAINT :
			hDC = BeginPaint (hWnd, &ps)
			m_stage =  5
			OnDraw (hWnd, hDC, m_stage)
			EndPaint (hWnd, &ps)

'		CASE $$WM_SIZE :
'			w = LOWORD (lParam)
'			h = HIWORD (lParam)
'			sizeType = wParam

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	INITCOMMONCONTROLSEX icc

	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library

	' initialize the common control classes
  icc.dwSize = SIZE(icc)
  icc.dwICC  = $$ICC_ANIMATE_CLASS      OR _
               $$ICC_BAR_CLASSES        OR _
               $$ICC_COOL_CLASSES       OR _
               $$ICC_DATE_CLASSES       OR _
               $$ICC_HOTKEY_CLASS       OR _
               $$ICC_INTERNET_CLASSES   OR _
               $$ICC_LISTVIEW_CLASSES   OR _
               $$ICC_NATIVEFNTCTL_CLASS OR _
               $$ICC_PAGESCROLLER_CLASS OR _
               $$ICC_PROGRESS_CLASS     OR _
               $$ICC_TAB_CLASSES        OR _
               $$ICC_TREEVIEW_CLASSES   OR _
               $$ICC_UPDOWN_CLASS       OR _
               $$ICC_USEREX_CLASSES     OR _
               $$ICC_WIN95_CLASSES
  InitCommonControlsEx (&icc)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "Hilbert Curve"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 538
	h 					= 562
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	className$ = titleBar$
	IFZ className$ THEN className$ = "MainProgram"

	IFZ icon$ THEN icon$ = "scrabble"

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION


FUNCTION OnDraw (hWnd, hDC, m_stage)

SHARED POINT g_position
SHARED POINT g_direction
RECT rc
POINT old
SHARED g_step

	GetClientRect(hWnd, &rc)

	g_position.x = rc.right-10   	' (rc.right*0.618)
	g_position.y = 10 						'rc.bottom/6.0
	g_step = (rc.bottom - 20)/(2.0 ** m_stage)				' rc.bottom*5.0/(6.0 * (2 ** m_stage))

	MoveToEx (hDC, g_position.x, g_position.y, &old)
	IF (m_stage MOD 2 == 0) THEN
		g_direction.x = 0
		g_direction.y = 1
	ELSE
		g_direction.x = -1
		g_direction.y = 0
	END IF
	DrawHilbert (hDC, m_stage, $$TURNLEFT)

END FUNCTION


FUNCTION TurnDirection(direction)

SHARED POINT g_direction

	x = g_direction.x
	y = g_direction.y

	g_direction.x = direction*y
	g_direction.y = -direction*x

END FUNCTION

FUNCTION DrawHilbert (hDC, stage, LeftOrRight)

SHARED POINT g_position
SHARED POINT g_direction
SHARED g_step

	IF (stage == 1) THEN

		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)
		TurnDirection (LeftOrRight)

		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)
		TurnDirection(LeftOrRight)

		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)

	ELSE

		DrawHilbert(hDC, stage-1, -LeftOrRight)

		IF ( stage MOD 2 == 0 ) THEN
			TurnDirection(LeftOrRight)
		END IF
		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)
		IF ( stage MOD 2 != 0 ) THEN
			TurnDirection(LeftOrRight)
		END IF
		DrawHilbert(hDC, stage-1, LeftOrRight)

		IF (stage MOD 2 == 0 ) THEN
			TurnDirection(-LeftOrRight)
		END IF
		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)
		IF ( stage MOD 2 == 0 ) THEN
			TurnDirection(-LeftOrRight)
		END IF

		DrawHilbert(hDC, stage-1, LeftOrRight)

		IF (stage MOD 2 != 0 ) THEN
			TurnDirection(LeftOrRight)
		END IF
		g_position.x = g_position.x + g_step*g_direction.x
		g_position.y = g_position.y + g_step*g_direction.y
		LineTo (hDC, g_position.x, g_position.y)
		IF ( stage MOD 2 == 0 ) THEN
			TurnDirection(LeftOrRight)
		END IF

		DrawHilbert(hDC, stage-1, -LeftOrRight)

	END IF
END FUNCTION

'void CHilbertView::OnChangeEdit1()
'{
'	// TODO: If this is a RICHEDIT control, the control will not
'	// send this notification unless you override the CFormView::OnInitDialog()
'	// function to send the EM_SETEVENTMASK message to the control
'	// with the ENM_CHANGE flag ORed into the lParam mask.

'	// TODO: Add your control notification handler code here
'	UpdateData(TRUE);
'	if(m_stage>=1 && m_stage<=7)
'		Invalidate();
'}

'void CHilbertView::OnInitialUpdate()
'{
'	CFormView::OnInitialUpdate();

'	// TODO: Add your specialized code here and/or call the base class
'	m_spin.SetRange(1, 7);
'	m_spin.SetPos(m_stage);
'	m_spin.SetBuddy(GetDlgItem( IDC_EDIT1 ));
'}

END PROGRAM