'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo which syncs two rich edit controls, the left one is the "editor"
' and the right one is a non-editable zoomed preview map. Using mouse scrolling on either
' edit controls moves them in sync. 
'
VERSION	"1.0000"
'
	IMPORT  "xst_s.lib"
	IMPORT  "xsx_s.lib"
'	IMPORT  "xio_s.lib"
'	IMPORT	"xst"   		' standard library	: required by most programs
'	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "shell32"   ' shell32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)
DECLARE FUNCTION SyncEditControls (hEdit1, hEdit2)
DECLARE FUNCTION SCROLLINFO GetAbsoluteMaxVScroll (ctrl)
DECLARE FUNCTION SINGLE GetRelativeScrollDiff (sourceScrollMax, destScrollMax, srcCtrl, destCtrl)
DECLARE FUNCTION GetBorderSize    (hCtrl)
DECLARE FUNCTION SyncScrollPosition (ctrlSource, ctrlDest)

$$EDIT_1 		= 100
$$EDIT_2 		= 101
$$MINIWIDTH = 140
$$ZOOMLEVEL	= 12
$$PRF_CLIENT = 4

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect
	CHARFORMAT2 cf
	SHARED hEdit1, hEdit2

	SELECT CASE msg

		CASE $$WM_CREATE :
			
			hRichEditDll = LoadLibraryA (&"riched20.dll")
			
 			text$ = "One day, a family was camping and decided to hike.  _
\r\nMidway through their hike, they stopped because of rain and got lost  _
in the woods while coming back to their campsite. \r\nBeing experienced hikers,  _
the parents decided not to wander in the woods and wait for rescue.  _
In the middle of the night, they heard noise from the trees. \r\nWhen one of the parents  _
asked who was there, nobody answered. \r\nSo the daughter thought maybe it was  _
someone who could not speak. \r\nSo the mother asked them questions in claps:  _
one clap for yes and two claps for no. \r\nWhen mom asked if somebody was there to rescue them,  _
two claps came. \r\nThen, she asked, \"Are you lost like us?\" \r\nClap clap. \r\nThe son asked,  _
\"Are you a boy?\" \r\nClap clap. \r\n\"Are you a girl?\" \r\nClap clap. \r\nIt started seeming very suspicious.  _
Finally, the son asked, \"Are you human?\" \r\nClap Clap. \r\nThe family was frightened by now.  _
They finally asked, \r\n\"How many of you are here?\"  _
\r\nThe answer came: Clap clap clap clap clap clap clap clap clap  _
clap clap clap clap clap clap clap clap clap clap clap clap.... \r\n\r\n\r\n"

		text$ = text$ + text$ + text$ + text$ + text$
			
		' create the edit controls
		style = $$ES_MULTILINE | $$ES_LEFT | $$WS_TABSTOP | $$ES_AUTOVSCROLL | $$WS_VSCROLL | $$ES_WANTRETURN 
		hEdit1 = NewChild ("richedit20A", text$, style, 0, 0, 0, 0, hWnd, $$EDIT_1, 0)
		
		' make sure edit control sends EN_VSCROLL and ENM_CHANGE messages	
		SendMessageA (hEdit1, $$EM_SETEVENTMASK, 0, $$ENM_CHANGE | $$ENM_SCROLL)
		
		' set background color
		SendMessageA (hEdit1, $$EM_SETBKGNDCOLOR, 0, RGB(255, 255, 237))
		
		' set font and font size
		cf.cbSize = SIZE(cf)
		cf.dwMask = $$CFM_FACE  | $$CFM_SIZE | $$CFM_WEIGHT
		cf.szFaceName = "Segoe UI" 
		cf.yHeight = 220		' Font size in twips (1/20th of a point)
		cf.wWeight = 300
		SendMessageA (hEdit1, $$EM_SETCHARFORMAT, $$SCF_ALL, &cf)
		
		' set second edit control exStyle as zoomable ES_EX_ZOOMABLE
		style = $$ES_MULTILINE | $$ES_LEFT | $$WS_VSCROLL | $$ES_READONLY
		hEdit2 = NewChild ("richedit20A", text$, style, 0, 0, 0, 0, hWnd, $$EDIT_2, $$ES_EX_ZOOMABLE)	

		' set Zoom Ratio: The zoom ratio is a decimal value between 0.015625 (1/64) and 64
		SendMessageA (hEdit2, $$EM_SETZOOM, $$ZOOMLEVEL, 64)

		SendMessageA (hEdit2, $$EM_SETEVENTMASK, 0, $$ENM_SCROLL)	
		SendMessageA (hEdit2, $$EM_SETBKGNDCOLOR, 0, RGB(255, 255, 255))
		
		' set font and font size and text color
		cf.cbSize 			= SIZE(CHARFORMAT)
		cf.dwMask 			= $$CFM_FACE | $$CFM_SIZE | $$CFM_COLOR
		cf.szFaceName 	= "Consolas" 
		cf.yHeight 			= 200		' Font size in twips (1/20th of a point)
		cf.crTextColor 	= RGB(255, 0, 0)
		SendMessageA (hEdit2, $$EM_SETCHARFORMAT, $$SCF_ALL, &cf)

		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			
			SELECT CASE notifyCode
				CASE $$EN_CHANGE :
					IF hwndCtl = hEdit1 THEN 
						SyncEditControls (hEdit1, hEdit2)
						SendMessageA (GetDlgItem (hWnd, $$EDIT_2), $$EM_SETZOOM, $$ZOOMLEVEL, 64)
					END IF 
					
				CASE $$EN_VSCROLL :
					SELECT CASE hwndCtl
						CASE hEdit1 : SyncScrollPosition (hEdit1, hEdit2)
						CASE hEdit2 : SyncScrollPosition (hEdit2, hEdit1)
					END SELECT 
			END SELECT
			
		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE $$WM_SIZE :
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			sizeType = wParam
			MoveWindow (hEdit1, 0, 0, w - $$MINIWIDTH, h, 1)
			MoveWindow (hEdit2, w - $$MINIWIDTH, 0, $$MINIWIDTH, h, 1)
			RETURN 
			
		CASE $$WM_DESTROY:
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	INITCOMMONCONTROLSEX icc
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
	' initialize the common control classes
  icc.dwSize = SIZE(icc)
  icc.dwICC  = $$ICC_ANIMATE_CLASS      OR _
               $$ICC_BAR_CLASSES        OR _
               $$ICC_COOL_CLASSES       OR _
               $$ICC_DATE_CLASSES       OR _
               $$ICC_HOTKEY_CLASS       OR _
               $$ICC_INTERNET_CLASSES   OR _
               $$ICC_LISTVIEW_CLASSES   OR _
               $$ICC_NATIVEFNTCTL_CLASS OR _
               $$ICC_PAGESCROLLER_CLASS OR _
               $$ICC_PROGRESS_CLASS     OR _
               $$ICC_TAB_CLASSES        OR _
               $$ICC_TREEVIEW_CLASSES   OR _
               $$ICC_UPDOWN_CLASS       OR _
               $$ICC_USEREX_CLASSES     OR _
               $$ICC_WIN95_CLASSES
  InitCommonControlsEx (&icc)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "Sync RichEdit Controls"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 540
	h 					= 400
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "MainProgram"
	
	IFZ icon$ THEN icon$ = "scrabble"
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION

FUNCTION SyncEditControls (hEdit1, hEdit2)

    textLength = GetWindowTextLengthA (hEdit1)
    textBuffer$ = NULL$(textLength + 1)

    GetWindowTextA (hEdit1, &textBuffer$, textLength + 1)
    SetWindowTextA (hEdit2, &textBuffer$)

END FUNCTION


FUNCTION SCROLLINFO GetAbsoluteMaxVScroll (ctrl)

	SCROLLINFO si
	
  si.cbSize = SIZE(SCROLLINFO)
  si.fMask = $$SIF_ALL
  GetScrollInfo (ctrl, $$SB_VERT, &si)
  RETURN si

END FUNCTION

FUNCTION SINGLE GetRelativeScrollDiff (sourceScrollMax, destScrollMax, srcCtrl, destCtrl)

	RECT srcRC, destRC
	GetClientRect (srcCtrl, &srcRC)
	GetClientRect (destCtrl, &destRC)

	border = GetBorderSize (srcCtrl)
  RETURN (SINGLE(destScrollMax - destRC.bottom) / SINGLE(sourceScrollMax - srcRC.bottom - border))

END FUNCTION

FUNCTION GetBorderSize (hCtrl)

	RECT rcClient, rcWind

	GetClientRect(hCtrl, &rcClient) 
	GetWindowRect(hCtrl, &rcWind) 
	border_thickness = ((rcWind.right - rcWind.left) - rcClient.right) / 2
	RETURN border_thickness

END FUNCTION

FUNCTION SyncScrollPosition (ctrlSource, ctrlDest)

	SHARED synchScroll
	SCROLLINFO infoSource, infoDest
	POINT pt
	SINGLE relScrollDiff, nPos

	IF synchScroll THEN RETURN 
    synchScroll = $$TRUE

    infoSource = GetAbsoluteMaxVScroll (ctrlSource)
    infoDest = GetAbsoluteMaxVScroll (ctrlDest)
    relScrollDiff = GetRelativeScrollDiff (infoSource.nMax, infoDest.nMax, ctrlSource, ctrlDest)

		IF infoSource.nTrackPos > 0 THEN 
			nPos = infoSource.nTrackPos
		ELSE
			nPos = infoSource.nPos
		END IF 

		pt.x = 0
'		pt.y = (nPos + 0.5) * relScrollDiff
		pt.y = nPos * relScrollDiff

    SendMessageA (ctrlDest, $$EM_SETSCROLLPOS, 0, &pt)
    synchScroll = $$FALSE

END FUNCTION

END PROGRAM
