'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A simple toolbar demo using stock bitmaps.
'
VERSION "0.0001"
'
IMPORT "xst_s.lib"
IMPORT "xsx_s.lib"
IMPORT "xio_s.lib"
' IMPORT	"xst"   		' standard library	: required by most programs
' IMPORT  "xsx"				' extended std library
' IMPORT	"xio"				' console io library
IMPORT "gdi32"		' gdi32.dll
IMPORT "user32"		' user32.dll
IMPORT "kernel32"		' kernel32.dll
IMPORT "shell32"		' shell32.dll
IMPORT "comctl32"		' comctl32.dll			: common controls library
IMPORT "comdlg32"		' comdlg32.dll	    : common dialog library
' IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
' IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION WndProc (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui ()
DECLARE FUNCTION CreateWindows ()
DECLARE FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION MessageLoop ()
DECLARE FUNCTION CreateSimpleToolbar (hWndParent)

$$ButtonNew = 1001
$$ButtonOpen = 1002
$$ButtonSave = 1003
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	XioCreateConsole (title$, 50)		' create console, if console is not wanted, comment out this line
	InitGui ()											' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)		' create windows and other child controls
	MessageLoop ()											' the main message loop
	XioFreeConsole ()										' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	SELECT CASE msg

		CASE $$WM_CREATE :
			CreateSimpleToolbar (hWnd)

		CASE $$WM_COMMAND :
			id = LOWORD (wParam)
			hwndCtl = lParam
			notifyCode = HIWORD (wParam)
			SELECT CASE notifyCode :
				CASE $$BN_CLICKED :
					SELECT CASE id
						CASE $$ButtonNew :
							? "Button New pressed"
						CASE $$ButtonOpen :
							? "Button Open pressed"
						CASE $$ButtonSave :
							? "Button Save pressed"
					END SELECT
			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage (0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION

FUNCTION CreateSimpleToolbar (hWndParent)

	SHARED hInst
	TBBUTTON tbb[]

	' Define some constants.
	ImageListID 	= 0
	numButtons 		= 3
	buttonStyles 	= $$BTNS_AUTOSIZE
	bitmapSize 		= 24

	' Create the toolbar.
	hWndToolbar = CreateWindowExA (0, &$$TOOLBARCLASSNAME$, NULL, _
								$$WS_CHILD | $$TBSTYLE_WRAPABLE, _
								0, 0, 0, 0, _
								hWndParent, NULL, hInst, NULL)

	IFZ hWndToolbar THEN RETURN


	' Create the imagelist.
	hImageList = ImageList_Create ( _
								bitmapSize, bitmapSize, _				' Dimensions of individual bitmaps.
								$$ILC_COLOR16 | $$ILC_MASK, _		' Ensures transparent background.
								numButtons, 0)

	' Set the image list.
	SendMessageA (hWndToolbar, $$TB_SETIMAGELIST, ImageListID, hImageList)

	' Load the button images.
	SendMessageA (hWndToolbar, $$TB_LOADIMAGES, $$IDB_STD_LARGE_COLOR, $$HINST_COMMCTRL)

	' Initialize button info.
	' IDM_NEW, IDM_OPEN, and IDM_SAVE are application-defined command constants.
	DIM tbb[2]
	tbb[0].iBitmap = $$STD_FILENEW
	tbb[0].idCommand = 1001
	tbb[0].fsState = $$TBSTATE_ENABLED
	tbb[0].fsStyle = $$TBSTYLE_BUTTON
	tbb[0].dwData = 0
	tbb[0].iString = &"New"
	tbb[1].iBitmap = $$STD_FILEOPEN
	tbb[1].idCommand = 1002
	tbb[1].fsState = $$TBSTATE_ENABLED
	tbb[1].fsStyle = $$TBSTYLE_BUTTON
	tbb[1].dwData = 0
	tbb[1].iString = &"Open"
	tbb[2].iBitmap = $$STD_FILESAVE
	tbb[2].idCommand = 1003
	tbb[2].fsState = $$TBSTATE_ENABLED
	tbb[2].fsStyle = $$TBSTYLE_BUTTON
	tbb[2].dwData = 0
	tbb[2].iString = &"Save"

	' Add buttons.
	SendMessageA (hWndToolbar, $$TB_BUTTONSTRUCTSIZE, SIZE (TBBUTTON), 0)
	SendMessageA (hWndToolbar, $$TB_ADDBUTTONS, numButtons, &tbb[])

	' Tell the toolbar to resize itself, and show it.
	SendMessageA (hWndToolbar, $$TB_AUTOSIZE, 0, 0)
	ShowWindow (hWndToolbar, 1)
	RETURN hWndToolbar
END FUNCTION


'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst

	hInst = GetModuleHandleA (0)		' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()		' initialize comctl32.dll library

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ = "Simple Toolbar"
	style = $$WS_OVERLAPPEDWINDOW
	w = 300
	h = 300
	exStyle = 0
	addrWndProc = &WndProc ()
	icon$ = "scrabble"
	menu$ = ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)		' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)		' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR (className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF

	IFZ icon$ THEN icon$ = "scrabble"

	wc.style = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc = addrWndProc
	wc.cbClsExtra = 0
	wc.cbWndExtra = 0
	wc.hInstance = hInst
	wc.hIcon = LoadIconA (hInst, &icon$)
	wc.hCursor = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground = $$COLOR_BTNFACE + 1
	wc.lpszMenuName = &menu$
	wc.lpszClassName = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION

'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

	' main message loop

	IF LIBRARY (0) THEN RETURN		' main program executes message loop

	DO		' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)		' retrieve next message from queue

		SELECT CASE ret
			CASE 0 : RETURN msg.wParam		' WM_QUIT message
			CASE - 1 : RETURN $$TRUE		' error
			CASE ELSE :
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
					TranslateMessage (&msg)		' translate virtual-key messages into character messages
					DispatchMessageA (&msg)		' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION

END PROGRAM