PROGRAM  "volume"
VERSION  "0.0001"
'
  IMPORT  "xst"       ' Standard library : required by most programs
  IMPORT  "xio"
	IMPORT  "xsx"
  IMPORT  "gdi32"     ' gdi32.dll
  IMPORT  "user32"    ' user32.dll
  IMPORT  "kernel32"  ' kernel32.dll
  IMPORT  "comctl32"  ' comctl32.dll"
	IMPORT  "msvcrt"
'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION InitGui ()
DECLARE FUNCTION CreateWindows ()
DECLARE FUNCTION DialogProc (hwndDlg, uMsg, wParam, lParam)
DECLARE FUNCTION SetColor (txtColor, bkColor, wParam, lParam)
DECLARE FUNCTION EditProc (hWnd, msg, wParam, lParam)

'Control IDs

$$Edit1 = 152
$$Edit2 = 154
$$Edit3 = 156

$$Edit4 = 162
$$Edit5 = 164

$$Button1 = 111
$$Button2 = 112

' Edit box return message
$$EDITBOX_RETURN = 402
'
' ######################
' #####  Entry ()  #####
' ######################
'
'
FUNCTION  Entry ()

  STATIC  entry
'
  IF entry THEN RETURN          	' enter once
  entry =  $$TRUE                	' enter occured

'  XioCreateConsole (title$, 50)  ' create console, if console is NOT wanted, comment out this line
  InitGui ()                    	' initialize program and libraries
  IF CreateWindows () THEN QUIT (0)  ' create main windows and other child controls
'  XioFreeConsole ()              ' free console

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION  InitGui ()

  SHARED hInst
  hInst = GetModuleHandleA (0)  ' get current instance handle
  IFZ hInst THEN QUIT(0)
  InitCommonControls()          ' initialize comctl32.dll library

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION  CreateWindows ()

  SHARED hInst

' create main modal dialog window.
' to process messages for the modal dialog box,
' Windows starts its own message loop, taking
' temporary control of the message queue for
' the entire application.

  IFZ DialogBoxParamA (hInst, 100, 0, &DialogProc(), 0) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ###########################
' #####  DialogProc ()  #####
' ###########################
'
FUNCTION  DialogProc (hwndDlg, msg, wParam, lParam)

  DOUBLE base1, base2, height, area, volume

  SHARED hInst
  bkColor = GetSysColor ($$COLOR_BTNFACE)

  SELECT CASE msg

    CASE $$WM_INITDIALOG :

      ' add menu
      menu$ = "MENU"
      SetMenu (hwndDlg, LoadMenuA (hInst, &menu$))

      ' set icon in title bar
      icon$ = "scrabble"
      hIcon = LoadIconA (hInst, &icon$)
      IF hIcon THEN
        SendMessageA (hwndDlg, $$WM_SETICON, $$ICON_BIG, hIcon)
        SendMessageA (hwndDlg, $$WM_SETICON, $$ICON_SMALL, hIcon)
      END IF

			' center dialog window
      XstCenterWindow (hwndDlg)

			' subclass edit controls
			' this means that the following edit controls will use the EditProc() function
			' before using the default control function
			#old_proc = SetWindowLongA (GetDlgItem (hwndDlg, $$Edit1), $$GWL_WNDPROC, &EditProc())
			#old_proc = SetWindowLongA (GetDlgItem (hwndDlg, $$Edit2), $$GWL_WNDPROC, &EditProc())
			#old_proc = SetWindowLongA (GetDlgItem (hwndDlg, $$Edit3), $$GWL_WNDPROC, &EditProc())

    CASE $$WM_CTLCOLORDLG :
      hdcDlg = wParam
      hwndDlg = lParam
      RETURN SetColor (0, bkColor, wParam, lParam)

    CASE $$WM_CTLCOLORBTN :
      hdcDlg = wParam
      hwndDlg = lParam
      RETURN SetColor (0, bkColor, wParam, lParam)

    CASE $$WM_CTLCOLORSTATIC :
      hdcDlg = wParam
      hwndDlg = lParam
      RETURN SetColor (0, bkColor, wParam, lParam)

    CASE $$WM_COMMAND :
      notifyCode = HIWORD(wParam)
      ID         = LOWORD(wParam)
      hwndCtl    = lParam
      SELECT CASE notifyCode
        CASE $$BN_CLICKED :
          SELECT CASE ID :

            CASE $$IDCANCEL :
              EndDialog (hwndDlg, ID)

            CASE $$Button1:
							' run button pressed
							' get values entered by user, these are strings!
							base1$ = NULL$(12)			' create buffer for base1$
							base2$ = NULL$(12)			' create buffer for base2$
							height$ = NULL$(12)			' create buffer for height$
              GetDlgItemTextA (hwndDlg, $$Edit1, &base1$,  LEN(base1$))
              GetDlgItemTextA (hwndDlg, $$Edit2, &base2$,  LEN(base2$))
              GetDlgItemTextA (hwndDlg, $$Edit3, &height$, LEN(height$))

							' calculate volume
              area = DOUBLE(base1$) * DOUBLE(base2$)			' convert strings to double values
              area$ = FORMAT$("#######.### ", area)				' create formatted string for area
              volume = area * DOUBLE(height$)
              volume$ = FORMAT$("#######.### ", volume)		' create formatted string for volume

              SetDlgItemTextA (hwndDlg, $$Edit4, &area$)	' display area$
              SetDlgItemTextA (hwndDlg, $$Edit5, &volume$)' display volume$

            CASE $$Button2:  ' exit button pressed, quit program
              CLOSE($$ALL)
              PostQuitMessage(0)

          END SELECT

      END SELECT

    CASE ELSE : RETURN ($$FALSE)

  END SELECT

  RETURN ($$TRUE)

END FUNCTION
'
'
' #########################
' #####  SetColor ()  #####
' #########################
'
FUNCTION  SetColor (txtColor, bkColor, wParam, lParam)
  SHARED hNewBrush
  DeleteObject (hNewBrush)
  hNewBrush = CreateSolidBrush(bkColor)
  SetTextColor (wParam, txtColor)
  SetBkColor (wParam, bkColor)
  RETURN hNewBrush
END FUNCTION

FUNCTION EditProc (hWnd, msg, wParam, lParam)

	SELECT CASE msg

		' check if Enter key has been pressed
'		CASE $$WM_KEYDOWN :			' WM_KEYDOWN returns virtKey constants
'			virtKey = wParam
'			IF virtKey = $$VK_RETURN THEN
'				id = GetWindowLongA (hWnd, $$GWL_ID)
'				wParam = ($$EDITBOX_RETURN << 16) OR id
'				SendMessageA (GetParent(hWnd), $$WM_COMMAND, wParam, hWnd)	' send WM_COMMAND message to main window callback function
'			END IF

		CASE $$WM_CHAR :				' WM_CHAR can capture keyboard characters
			charCode = wParam
'			PRINT "WM_CHAR message: ASCII charCode="; charCode, "CHAR="; CHR$(charCode)	' validate text entry by character

			' allow control chars
			IF iscntrl (charCode) THEN RETURN CallWindowProcA (#old_proc, hWnd, msg, wParam, lParam)

			SELECT CASE charCode

				CASE '0', '1','2','3','4','5','6','7','8','9','-','+','.'  : 	' check for acceptable chars
					s$ = NULL$(128)
					GetWindowTextA (hWnd, &s$, LEN(s$))													' get current entry in edit box
					s$ = CSIZE$(s$) + CHR$(charCode)														' add new char
					l = LEN(s$)
					IF l <> 1 THEN
						IF charCode = '-' || charCode = '+' THEN RETURN						' except - or + as first char only
					END IF
					RETURN CallWindowProcA (#old_proc, hWnd, msg, wParam, lParam)

				CASE ELSE : RETURN
			END SELECT

		CASE ELSE :
			RETURN CallWindowProcA (#old_proc, hWnd, msg, wParam, lParam)

	END SELECT
END FUNCTION
END PROGRAM