'Subject: Solution of a system of linear congruences.
'         Apply the Chinese remainder theorem to p
'         simultaneous congruences a_i*x = b_i Mod M_i.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo

PROGRAM "chineser"
VERSION "00.01"
CONSOLE

IMPORT	"bignumXB"
IMPORT	"xst"
IMPORT  "xsx"
IMPORT  "xio"

DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
DIM i[93, 3] '                         pointer array
X = 0: d = 1: t0 = 2: t1 = 3
r = LargeInit("chineser")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XioClearConsole(XioGetStdOut()): fl = 0 '            set flag for file input

Readnr = OPEN(WrkD$ + "\\chineser", $$RD)
PRINT " +------------------------------------+"
PRINT " |  To solve a(i)*x = b(i) Mod M(i),  |"
PRINT " |  input number of equations p,      |"
PRINT " |  and p times a(i), b(i), M(i),     |"
PRINT " |  p = 0 to exit.                    |"
PRINT " |                                    |"
PRINT " +------------------------------------+"

begin:
IF fl THEN
   ip$ = INFILE$ (Readnr)
ELSE
   ip$ = INLINE$ (" p? ")
END IF
pmx = 0: IF INSTR(ip$, "'") THEN GOTO begin
IF XLONG(LEFT$(ip$, 5)) < 31 THEN pmx = XLONG(ip$)
IF pmx < 1 THEN GOTO eind
'
p = 0
FOR r = 3 TO 3 * pmx STEP 3
   p = p + 1
   FOR s = 1 TO 3
      IF fl THEN
         g$ = INFILE$ (Readnr)
      ELSE
         g$ = INLINE$ (" (" + LTRIM$(STR$(p)) + "," + STR$(s) + ")? ")
      END IF
      i[p, s] = r + s
      Readst(i[p, s], g$)
   NEXT s
   Sets(i[p, 3], 1)
NEXT r

p = 1: ps = -1
Euclid(i[p, 1], i[p, 3], d) '    i:= a(1)^ -1, M:= M(1)/gcd, d:= gcd(a(1), M(1))
Divd(i[p, 2], d, X) '                  Xt:= b(1)/gcd
IF NOT Isf(i[p, 2], 0) THEN
   ps = 0: GOTO jump '                 remainder > 0
END IF
Modmlt(X, i[p, 1], i[p, 3]) '          X:= Xt * i mod M
FOR p = 2 TO pmx
   Mult(X, i[p, 1], t0) '              Xt:= X * a(p)
   Swp(X, t0): Subt(i[p, 2], t0) '     bt:= b(p) - Xt
   Mult(i[p, 1], i[p - 1, 3], t0) '    at:= a(p) * M
   Euclid(i[p, 1], i[p, 3], d) ' i:= a(p)^ -1, M':= M(p)/gcd, d:= gcd(at, M(p))
   Divd(i[p, 2], d, t1) '              t1:= bt/gcd
   IF NOT Isf(i[p, 2], 0) THEN
      ps = 0: EXIT FOR '               remainder > 0
   END IF
   Mult(t1, i[p, 1], t0) '             t1:= t1 * i
   Mult(t1, i[p - 1, 3], t0) '         t1:= t1 * M
   Add(X, t1) '                        X:= X + (b(p) - X * a(p))/gcd * i * M
   Mult(i[p, 3], i[p - 1, 3], t0) '    M:= M' * M
   Moddiv(X, i[p, 3]) '                X:= X mod M
NEXT p

jump:
IF NOT ps THEN
   Prints(" Modulus = 0", 1) '         system unsolvable
   IF p > 1 THEN
      Prints(" (" + LTRIM$(STR$(p - 1)) + ") ", 1)
   END IF
END IF
IF ps OR (p > 1) THEN
   Printn(X, " X  ", "", 2) '         output X,
   Printn(i[p - 1, 3], "  mod ", "", 2) ' output M
END IF
Prints("", 1)
GOTO begin

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
Term ()
END FUNCTION
END PROGRAM
