'Subject: Decryption using the Chinese remainder theorem.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"decoder"
VERSION	"01.02"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Deco()
DECLARE FUNCTION VOID Readkey (SLONG n, STRING g)
'read base 64 data

FUNCTION VOID Deco()
STRING byt, b4, g[]
DIM g[4]: byt = NULL$(1): b4 = NULL$(4)
P = 0: Q = 1: dP = 2: dQ = 3
Q1 = 4: i0 = 5: i1 = 6: t0 = 7
t = LargeInit("decoder")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim): sw = -1 '       set switch for file input
XstClearConsole(): PRINT: fl = -1 '    set flag to Print Scrn
WrkD$ = WrkD$ + "\\"

Readnr = OPEN(WrkD$ + "decoder",$$RD)

begin:
IF sw THEN
   g[0] = INFILE$ (Readnr)
ELSE
   g[0] = INLINE$ (" k? ")
END IF
IF INSTR(g[0], "'") THEN GOTO begin
IF (g[0] = "") OR (g[0] = "0") THEN GOTO eind
k = OPEN(WrkD$ + g[0], $$RD)
   FOR t = 0 TO 4 '                    read prime factors,
      g[t] = INFILE$ (k) '             Crt exponents & Crt coefficient
   NEXT t '
CLOSE(k)
'
Readkey(P, g[0]): Readkey(Q, g[1])
Readkey(dP, g[2]): Readkey(dQ, g[3])
Readkey(Q1, g[4])
Copyf(Q, i0): Modmlt(i0, Q1, P)
IF NOT Isf(i0, 1) THEN '               check
   Prints(" invalid keyfile", 1)
   GOTO eind
END IF
'
IF sw THEN
   g[0] = INFILE$ (Readnr)
   g[1] = INFILE$ (Readnr)
ELSE
   g[0] = INLINE$ (" c? ")
   g[1] = INLINE$ (" m? ")
END IF
Cfile = OPEN(WrkD$ + g[0], $$RD) '     cipher
Pfile = OPEN(WrkD$ + g[1], $$WRNEW) '  plaintext

READ [Cfile], b4: pc = Cvl(b4)
pp = pc \ 512: k = pc - pp * 512 '     len(Pfile), len(modulus)

ks = k - 8: k = k + 1 '                subtract len(salt), add space
s = pp \ ks: u = pp - s * ks '         total records, byte remainder
IF u > 0 THEN s = s + 1

pc = 3: pp = -1 '                      initial positions (zero - 1)
FOR r = 1 TO s
   Letf(i0, 0)
   FOR t = 1 TO k '                    convert cipher to base MB
      SEEK(Cfile, pc + t)
      READ [Cfile], byt
      Inc(i0, ASC(byt))
      IF t < k THEN Lsft(i0, 8)
   NEXT t
   pc = pc + k
   '
   Copyf(i0, i1)
   Modpwr(i0, dP, P) '                 i0:= c^ dP (mod P)
   Modpwr(i1, dQ, Q) '                 i1:= c^ dQ (mod Q)
   Subt(i0, i1): Mult(i0, Q1, t0) '    Chinese recombination
   Moddiv(i0, P): Mult(i0, Q, t0)
   Add(i0, i1): Rsft(i0, 64) '         desalinate
   '
   FOR t = 1 TO ks '                   write message octets
      c = Mp2(i0, 256)
      Rsft(i0, 8): byt = CHR$(c)
      SEEK(Pfile, pp + t)
      WRITE [Pfile], byt
      IF fl AND (c <> 13) THEN '       print to screen
         PRINT byt;
      END IF
      IF (r = s) AND (t = u) THEN EXIT FOR
   NEXT t
   pp = pp + ks
   '
   IF NOT fl THEN PRINT "*";
NEXT r

CLOSE(Pfile)
CLOSE(Cfile)

eind:
XstGetSystemTime(@Now)
g[0] = STR$(SINGLE(Now - Tim) / 1000)
PRINT: PRINT
Prints(" Timer:" + g[0] + " s", 0)
Term ()
END FUNCTION

FUNCTION VOID Readkey (SLONG n, STRING g)
b64$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
   '
   IF RIGHT$(g, 1) = "=" THEN i = 1
   IF RIGHT$(g, 2) = "==" THEN i = 2
   Letf(n, 0): k = LEN(g) - i
   FOR t = 1 TO k '                    base-64 to largeint
      j = INSTR(b64$, MID$(g, t, 1))
      IF j > 0 THEN Inc(n, j - 1)
      IF t < k THEN Lsft(n, 6)
   NEXT t
   IF i > 0 THEN Rsft(n, i * 2)
END FUNCTION
END PROGRAM
