'Subject: Cryptography, exponential encryption with salt.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"encoder"
VERSION	"01.02"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Enco()
DECLARE FUNCTION VOID Readkey (SLONG p, STRING g)
'read base 64 data

FUNCTION VOID Enco()
STRING byt, b4, g[]
DIM g[2]: byt = NULL$(1): b4 = NULL$(4)
m = 0: e = 1: N = 2: t0 = 3
t = LargeInit("encoder")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim): sw = -1 '       set switch for file input
XstClearConsole(): PRINT
WrkD$ = WrkD$ + "\\"

Readnr = OPEN(WrkD$ + "encoder",$$RD)

begin:
IF sw THEN
   g[0] = INFILE$ (Readnr)
ELSE
   g[0] = INLINE$ (" k? ")
END IF
IF INSTR(g[0], "'") THEN GOTO begin
IF (g[0] = "") OR (g[0] = "0") THEN GOTO eind
k = OPEN(WrkD$ + g[0], $$RD)
   FOR t = 0 TO 2
      g[t] = INFILE$ (k) '             split modulus N & public exp.
   NEXT t
CLOSE(k)
'
Readkey(e, g[2])
Readkey(N, g[0] + g[1])
k = INT(Logf(N) * .18033688#) '        length(N) in octets
IF k < 9 THEN
   Prints(" modulus too small", 1)
   GOTO eind
END IF
'
IF sw THEN
   g[0] = INFILE$ (Readnr)
   g[1] = INFILE$ (Readnr)
ELSE
   g[0] = INLINE$ (" m? ")
   g[1] = INLINE$ (" c? ")
END IF
Pfile = OPEN(WrkD$ + g[0], $$RD) '     plaintext
Cfile = OPEN(WrkD$ + g[1], $$WRNEW) '  cipher

pp = LOF(Pfile)
b4 = Mkl(pp * 512 + k)
WRITE [Cfile], b4 '                    write len(Pfile), len(N)

ks = k - 8: k = k + 1 '                subtract len(salt), add space
s = -INT(-SINGLE(pp) / ks)

Prints(" record length: " + STR$(ks), 1)
Prints(" total records: " + STR$(s), 1)

pp = 0: pc = 4 '                       initial positions (zero!)
PRINT " record ";
FOR r = 1 TO s
   PRINT r;
   '
   Letf(m, 0)
   pp = pp + ks
   FOR t = 1 TO ks '                   convert message to base MB
      SEEK(Pfile, pp - t)
      READ [Pfile], byt
      Inc(m, ASC(byt)): Lsft(m, 8)
   NEXT t
   Lsft(m, 56): Rndf(t0, 19)
   Add(m, t0) '                        add random 8-byte salt
   '
   Modpwr(m, e, N) '                   cipher m^ e Mod N
   '
   pc = pc + k
   FOR t = 1 TO k '                    write cipher octets
      byt = CHR$(Mp2(m, 256))
      SEEK(Cfile, pc - t)
      WRITE [Cfile], byt
      Rsft(m, 8)
   NEXT t
NEXT r

CLOSE(Cfile)
CLOSE(Pfile)

eind:
XstGetSystemTime(@Now)
g[0] = STR$(SINGLE(Now - Tim) / 1000)
PRINT: PRINT
Prints(" Timer:" + g[0] + " s", 0)
Term ()
END FUNCTION

FUNCTION VOID Readkey (SLONG p, STRING g)
b64$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
   '
   IF RIGHT$(g, 1) = "=" THEN i = 1
   IF RIGHT$(g, 2) = "==" THEN i = 2
   Letf(p, 0): k = LEN(g) - i
   FOR t = 1 TO k '                    base-64 to largeint
      j = INSTR(b64$, MID$(g, t, 1))
      IF j > 0 THEN Inc(p, j - 1)
      IF t < k THEN Lsft(p, 6)
   NEXT t
   IF i > 0 THEN Rsft(p, i * 2)
END FUNCTION
END PROGRAM
