'Subject: Factorization by the difference of two squares.
'         Fermat's method is useful only if N has
'         factors close to its square root.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"fermatfr"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
t0 = 0: N = 1: x = 2: y = 3: z = 4
t = LargeInit("fermatfr")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole()

Readnr = OPEN(WrkD$ + "\\fermatfr", $$RD)

begin:
'Ni$ = INLINE$ (" N? ")
Ni$ = INFILE$ (Readnr)
IF INSTR(Ni$, "'") THEN GOTO begin
IF XLONG(LEFT$(Ni$, 9)) < 2 THEN GOTO eind
XstClearConsole(): PRINT
'
Readst(N, Ni$)
Printn(N, " N = ", "", 2)
'
g$ = ""
IF IsPPrm(N, x, 5) THEN '              preliminary tests
   g$ = "N is probably prime"
ELSE
   IF Mp2(N, 2) = 0 THEN
      g$ = "N is even"
   ELSE
      Isqrt(N, x): Squ(x, t0)
      Subt(t0, N) '                    t0:= -r
      IF Isf(t0, 0) THEN
         Printn(x, " r = ", "", 2)
         g$ = "N is square"
      END IF
   END IF
END IF
IF g$ <> "" THEN
   Prints(g$, 2): GOTO begin
ENDIF
'
Copyf(x, z): Lsft(z, 1)
Inc(z, 1): Add(z, t0): Inc(x, 1) '     z:= 2x + 1 - r, x:= Isqr(N) + 1
c = 0
DO
   c = c + 1
   IF IsSqr(z, y) THEN EXIT DO '       (x + y)(x - y) found
   Copyf(x, t0): Lsft(t0, 1)
   Inc(z, 1): Add(z, t0): Inc(x, 1) '  z:= z + 2x + 1, x:= x + 1
LOOP
'
Prints(" t =" + STR$(c), 1)
Copyf(x, N): Add(x, y): Subt(N, y)
Printn(x, "f1 = ", "", 2)
Printn(N, "f2 = ", "", 2)
Prints("", 1)
GOTO begin

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION
END PROGRAM
