'Subject: Cryptography: probable primes and crypto key generation.
'         Prints relevant values to public & private key-files.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"genrator"
VERSION	"01.02"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()
DECLARE FUNCTION VOID Prntkey (SLONG n, SLONG sw)
'write base 64 data

FUNCTION VOID Main()
SHARED Keyfil, t0
STRING g
i0 = 0: i1 = 1: i2 = 2 '               largeint pointers
P = 3: Q = 4: t0 = 5: w = 10 '         number of witnesses
t = LargeInit("genrator")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim): sw = -1 '       set switch for file input
XstClearConsole(): PRINT

Readnr = OPEN(WrkD$ + "\\genrator", $$RD)

begin:
IF sw THEN
   g = INFILE$ (Readnr)
ELSE
   g = INLINE$ (" l(N)? ")
END IF
IF INSTR(g, "'") THEN GOTO begin
L# = DOUBLE(g)
IF L# < 1 THEN GOTO eind
IF (L# < 74) OR (L# > 2048) THEN
   Prints(" illegal modulus size", 1)
   GOTO begin
END IF
lx = 1 + INT(L# * .30103) '            length decimal(N)
lp = lx \ 2 + INT(Rnd(0) * 2)
lq = lx - lp '                         lengths primes P & Q

lx = lp
FOR t = 1 TO 2
   Rndf(i0, lx)
   Copyf(i0, t0): Letf(i1, 6)
   Moddiv(t0, i1): d = 5: df = 4
   IF Gete(t0, 0) < 2 THEN d = 1: df = 2
   Inc(i0, d - Gete(t0, 0)) '          random i0 = +-1 (mod 6)
   '
   g = " searching P..."
   IF t = 2 THEN g = " Q..."
   PRINT g;
   DO '                                strong pseudoprime-test
      IF IsPPrm(i0, i1, w) THEN
         IF t = 1 THEN Copyf(i0, P)
         EXIT DO
      END IF
      df = 6 - df: Inc(i0, df)
   LOOP: lx = lq
NEXT t
Copyf(i0, Q)
IF Cmp(P, Q) < 1 THEN Swp(P, Q)

Keyfil = OPEN(WrkD$ + "\\public.key", $$WRNEW)
   Mult(P, Q, i0): Swp(P, i0) '        RSA modulus P * Q
   Letf(i1, 65537) '                   public exponent F4
   Prntkey(i0, 1): Prntkey(i1, 0)
CLOSE(Keyfil)

XstClearConsole(): PRINT
Printn(P, " P = ", "", 2) '            prime factors
Printn(Q, " Q = ", "", 2)
Printn(i0, " N = ", "", 2)
Printn(i1, " e = ", "", 2)
'
Copyf(i1, i0)
Dcr(P, 1): Euclid(i0, P, t0) '         e * i0 = 1 (mod P-1)
Inc(P, 1): t = -Isf(t0, 1)
Dcr(Q, 1): Euclid(i1, Q, t0) '         e * i1 = 1 (mod Q-1)
Inc(Q, 1): t = t * Isf(t0, 1)
IF NOT t THEN
   Prints(" gcd(phi(N), e) > 1, no private key generated", 1)
   GOTO eind
END IF
Copyf(Q, i2): Euclid(i2, P, t0) '      Q * i2 = 1 (mod P)
'
Printn(i0, "dP = ", " (mod P-1)", 2) ' Crt exponents
Printn(i1, "dQ = ", " (mod Q-1)", 2)
Printn(i2, "Q1 = ", " (mod P)", 2) '   Crt coefficient

Keyfil = OPEN(WrkD$ + "\\private.key", $$WRNEW)
   Prntkey(P, 0): Prntkey(Q, 0)
   Prntkey(i0, 0): Prntkey(i1, 0)
   Prntkey(i2, 0)
CLOSE(Keyfil)

eind:
Prints("", 1)
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints(" Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION

FUNCTION VOID Prntkey (SLONG n, SLONG sw)
SHARED Keyfil, t0
b64$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
   '
   i = 1 + INT(Logf(n) * 1.442695040889#) ' bit Len
   k = -INT(-SINGLE(i) / 8): j = k * 8 '  byte Len
   k = -INT(-SINGLE(j) / 6): i = k * 6 '6-bit Len
   i = i - j: Copyf(n, t0)
   IF i > 0 THEN Lsft(t0, i) '         left-align
   '
   i = i \ 2
   g$ = CHR$('=', k + i)
   FOR t = 0 TO k - 1 '                largeint to base 64
      j = Mp2(t0, 64) + 1
      g$ = STUFF$(g$, MID$(b64$, j, 1), k - t, 1)
      Rsft(t0, 6)
   NEXT t
   '
   IF sw THEN
      k = k + i: t = k \ 2
      PRINT [Keyfil], LEFT$(g$, t); CHR$(13) ' split g high
      PRINT [Keyfil], RIGHT$(g$, k - t); CHR$(13) ' & low
   ELSE
      PRINT [Keyfil], g$; CHR$(13)
   END IF
END FUNCTION
END PROGRAM
