'Subject: Lucas-Lehmer test for Mersenne numbers 2^ p - 1, with odd prime p.
'         Toy version for small p.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic library testing
PROGRAM	"mersenne"
VERSION	"00.01"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()

FUNCTION VOID Main ()
t = 0: p = 1: s = 2
k = LargeInit("mersenne")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole(): PRINT

Readnr = OPEN(WrkD$ + "\\mersenne", $$RD)

begin:
'p$ = INLINE$ (" p? ")
p$ = INFILE$ (Readnr)
IF INSTR(p$, "'") THEN GOTO begin
ep = XLONG(LEFT$(p$, 9))
IF ep < 2 THEN GOTO eind
IF ep > 30703 THEN GOTO begin
IF (ep AND 1) = 0 THEN GOTO begin '    skip even p

PRINT "p ="; ep

Letf(s, 4): Letf(p, 1) '               initialize s,
Lsft(p, ep): Dcr(p, 1) '               compute power - 1
FOR k = 2 TO ep - 1 '                  calculate Lucas series
   Squ(s, t): Dcr(t, 2)
   Copyf(t, s): Andf(s, p)
   Rsft(t, ep): Add(s, t) '            Mod 2^ p - 1
   IF Cmp(s, p) >= 0 THEN Subt(s, p) 
NEXT k

g$ = " 2^ " + p$ + " - 1 is " '        output test
IF NOT Isf(s, 0) THEN g$ = g$ + "not "
Prints(g$ + "prime", 2)
GOTO begin

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION
END PROGRAM
