'Subject: Calculation of pi with the 1976 Salamin-Brent
'         arithmetic-geometric mean (AGM) algorithm.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"pi_agm"
VERSION	"1.01"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()
DECLARE FUNCTION VOID Sqrt (SLONG p, SLONG q)
'p:= integer square root(p), using q as seed.

FUNCTION VOID Main()
SHARED SLONG t0, t1
t0 = 0: t1 = 1: A = 2: B = 3: D = 4: S = 5
k = LargeInit("pi_agm")
XstGetSystemTime(@Tim)
XstClearConsole()

imx = 12 '                              set number of iterations, max. 12
IF (imx < 1) OR (imx > 12) THEN
  PRINT "value out of range": GOTO eind
END IF
PRINT "working..."
'
DIM e[12] '            			number of correct digits
e[1] = 1: e[2] = 3: e[3] = 9: e[4] = 20: e[5] = 42
e[6] = 85: e[7] = 173: e[8] = 347: e[9] = 697
e[10] = 1393: e[11] = 2792: e[12] = 5250
'
Letf(A, 10): Powr(A, e[imx] + 4) '      initiate arithmetic mean A,
Squ(A, S): Rsft(S, 1) '                 sum S,
Isqrt(S, B) '                           powers-of-two, geometric mean B
'
FOR i = 1 TO imx
   PRINT i;
   Copyf(A, D): Subt(D, B): Rsft(D, 1) 'D:= (A[n-1] - B[n-1]) / 2
   Squ(D, t0): Lsft(t0, i)
   Subt(S, t0) '                        S[n]:= S[n-1] - D^2 * 2^i
   Mult(A, B, D): Swp(A, D)
   Add(A, B): Rsft(A, 1) '              A[n]:= (A[n-1] + B[n-1]) / 2
   Copyf(A, B): Sqrt(D, B) '            B[n]:= Sqrt(A[n-1] * B[n-1])
NEXT i
PRINT
Squ(A, D): Lsft(D, 1) '    		D:= 2 * A[n]^ 2
Setl(A, e[imx])
Printr(D, S, A, "pi = ", "")

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
Term ()
END FUNCTION

FUNCTION VOID Sqrt (SLONG p, SLONG q)
SHARED SLONG t0, t1
   DO
      Copyf(p, t0)
      Divd(t0, q, t1)
      Add(q, t1): Rsft(q, 1)
      Subt(t1, q)
      r = Gete(t1, 1) + Gete(t1, 0) < 2
      r = r AND (Getl(t1) = Gets(t1))
   LOOP UNTIL r
END FUNCTION
END PROGRAM


