'Subject: Calculation of pi with Gauss's equation
'         pi/4 = 12*arctan(1/18) + 8*arctan(1/57) - 5*arctan(1/239)
'         using James Gregory's inverse tangent series.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"pi_atan"
VERSION	"1.01"
CONSOLE
IMPORT	"bignumXB"
IMPORT	"xst"
IMPORT	"xsx"

DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
t0 = 0: t1 = 1: sum = 2: pi = 3
one = 4: odd = 5: pwd = 6: sqd = 7
k = LargeInit("pi_atan")
XstGetSystemTime(@Tim)
'XstClearConsole()

e = 5250 '                               set precision, max. 6900
PRINT "working..."
'
DIM d[2], m[2]
d[0] = 18: d[1] = 57: d[2] = 239 '    	 inverse cotangent arguments
m[0] = 12: m[1] = 8: m[2] = -5 '      	 coefficients
'
Letf(one, 10): Powr(one, e) '            initiate 'one'
FOR n = 0 TO 2
   PRINT n + 1;
   Letf(odd, 1): s = 1
   Letf(pwd, d[n]): Squ(pwd, sqd) '      initiate power series,
   Copyf(one, t0): Divd(t0, pwd, sum) '  arctan series
   Copyf(sum, pwd)
   DO '                                  pwd[t]:= pwd[t-1] / d[n]^ 2,
      Divd(pwd, sqd, t0): Inc(odd, 2) '  odd[t]:= 2t + 1
      Copyf(t0, pwd): Divd(t0, odd, t1) 't1:= pwd[t] / odd[t]
      Sets(t1, s): Subt(sum, t1): s = -s ' sum[t]:= sum[t-1] - sgn[t-1] * t1
   LOOP UNTIL Isf(pwd, 0) '              precision exhausted
   Letf(t0, m[n]): Mult(sum, t0, t1)
   IF n = 0 THEN
      Copyf(sum, pi)
   ELSE
      Add(pi, sum) '                     pi:= pi + m[n] * sum
   END IF
NEXT n
PRINT
Lsft(pi, 2)
Divd(pi, one, sum)
Printn(sum, "pi = ", "", 0) '            sum:= pi \ 1
Printn(pi, ".", "", 2) '                 pi:= pi mod 1

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
Term ()
a$ = INLINE$ ("Press Enter to quit >")
END FUNCTION
END PROGRAM


