'Subject: Pollard's Rho factorization method, Brent's modification.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"pollarho"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"
'
DECLARE FUNCTION VOID Main()
'
FUNCTION VOID Main()
N = 0: d = 1: p = 2
x = 3: y = 4: ys = 5
k = LargeInit("pollarho")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole()

Readnr = OPEN(WrkD$ + "\\pollarho",$$RD)

begin:
'Ni$ = INLINE$ (" N? ")
Ni$ = INFILE$ (Readnr)
IF INSTR(Ni$, "'") THEN GOTO begin
IF XLONG(LEFT$(Ni$, 9)) < 2 THEN GOTO eind

'bi$ = INLINE$ (" c? ")
bi$ = INFILE$ (Readnr): b = 0 '        f(y) = y^2 (mod N) + b
IF ABS(XLONG(bi$)) < $$MB \ 2 THEN
  b = ABS(XLONG(bi$))
END IF
IF b = 0 THEN b = 3 '                  default b
m = INT(LEN(Ni$) * 2.3026) '           m = presumed length of
XstClearConsole(): PRINT '             the non-periodic segment

Readst(N, Ni$)
Printn(N, "  N = ", "", 2)

sw = 0: c = 0
IF IsPPrm(N, d, 5) THEN '              preliminary tests
   Prints(" N is probably prime", 2)
   GOTO begin
ELSE
   IF NOT Isf(d, 1) THEN GOTO jump
   IF IsSqr(N, d) THEN GOTO jump
END IF

Prints("  m =" + STR$(m) + "  c =" + STR$(b), 0)
Letf(y, 0): Letf(p, 1): r = 1
DO
   Copyf(y, x)
   FOR i = 1 TO r
      Modsqu(y, N): Inc(y, b) '        y:= f(y)
   NEXT i
   c = c + r: k = 0
   DO
      Copyf(y, ys)
      il = r - k
      IF m < il THEN il = m '          il:= min(m, r - k)
      FOR i = 1 TO il
         Modsqu(y, N): Inc(y, b) '     y:= f(y)
         Copyf(x, d): Subt(d, y)
         Sets(d, 1): Modmlt(p, d, N) ' p:= p * abs(x - y) mod N
      NEXT i
      c = c + 2 * il
      IF Isf(p, 0) THEN sw = -1: GOTO jump
      Gcd(p, N, d)
      k = k + m: s = NOT Isf(d, 1) '   gcd(p, N) > 1 ?
   LOOP UNTIL (k >= r) OR s
   r = 2 * r
LOOP UNTIL s
'
jump:
IF sw THEN '                           case p = 0, backtrack cycle
   DO
      Modsqu(ys, N): Inc(ys, b) '      y:= f(y)
      Copyf(x, p): Subt(p, ys)
      Sets(p, 1): c = c + 1
      IF Isf(p, 0) THEN Letf(p, 1)
      Gcd(p, N, d)
   LOOP WHILE Isf(d, 1) '              gcd(abs(x - ys), N) > 1
END IF
'
IF c > 0 THEN
   Prints("  t =" + STR$(c), 1) '      number of multiplications (mod N)
END IF
Divd(N, d, p) '                        gcd in d
IF Isf(d, 1) OR Isf(p, 1) THEN
   Prints("failure", 1)
ELSE
   Printn(d, "  f = ", "", 1)
   Printn(p, "N/f = ", "", 2)
ENDIF
Prints("", 1)
GOTO begin
'
eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION
END PROGRAM
