'Subject: Sieve of Erathostenes: a variation of Chartres' Algorithm 311.
'         Generates PrimFlgs.bin, an encoded list of prime numbers
'         read by library function Nxtprm(). The prime / not prime
'         information is stored for 90 integers in 4 bytes.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"primflgs"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"
IMPORT	"xma"
'
DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
STRING dword
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstClearConsole(): PRINT

DIM bi[95], bo[95]
N = 1: dt = 4: t = 5
FOR k = 1 TO 30
   dt = 6 - dt: t = t + dt
   bi[t] = N: bo[t] = NOT N '         store masks
   N = N * 2
NEXT k

Readnr = OPEN(WrkD$ + "\\primflgs", $$RD)

begin:
'il$ = INLINE$ (" l? ")
il$ = INFILE$ (Readnr)
IF INSTR(il$, "'") THEN GOTO begin
IF DOUBLE(il$) < 1 THEN GOTO eind
IF DOUBLE(il$) > $$Fx THEN il$ = ""
lP = DOUBLE(il$)
'
XstGetSystemTime(@Tim)
PRINT " Filling slate..."
lv = (lP - 7) \ 90
DIM bv[lv] '                          preprocessed bit vector
bv[0] = 0xB76BDBF '                   5 & 7-folds excluded
FOR i = 1 TO lv - 1
   bv[i] = 0x1BF6FDBF '               5-folds excluded
NEXT i
'
PRINT " Erasing multiples..."
li = (SQRT(lP) - 7) \ 90: dt = 4
FOR i = 0 TO li
   c = bv[i]: t = 5 '                 read 30-bit chunk
   FOR k = 1 TO 30
      dt = 6 - dt: t = t + dt '       skip multiples of 2 and 3
      IF c AND bi[t] THEN
         P = i * 90 + t '             calculate prime,
         dP = dt * P: P6 = 6 * P '     steps
         N = P * P '                  initial N = k * P
         DO WHILE N < lP
            j = (N - 7) \ 90 '        point to multiple N
            m = N - j * 90
            bv[j] = bv[j] AND bo[m] ' clear bit
            dP = P6 - dP: N = N + dP 'step to next N
         LOOP
      END IF
   NEXT k
NEXT i
XstGetSystemTime(@Now)
'
Slate = OPEN(WrkD$ + "\\primflgs.bin", $$RWNEW)
PRINT " Writing slate to disk..."
dword = NULL$(4)
FOR i = 0 TO lv - 1
   dword = Mkl(bv[i])
   WRITE [Slate], dword
NEXT i
PRINT " Done": PRINT

eind:
CLOSE(Slate)
Slate = OPEN(WrkD$ + "\\primflgs.log", $$WRNEW)
g$ = STR$(SINGLE(Now - Tim) / 1000)
g$ = "Timer:" + g$ + " s"
PRINT [Slate], g$: PRINT g$
CLOSE(Slate)
END FUNCTION
END PROGRAM
