'Subject: The continued fraction algorithm.
'         Simplify ratios and express decimals as common fractions.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"rational"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"
'
DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
t0 = 0: n = 1: d = 2: a = 3: qx = 4
p0 = 5: p1 = 6: q0 = 7: q1 = 8
k = LargeInit("rational")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole(): PRINT

Readnr = OPEN(WrkD$ + "\\rational", $$RD)

begin:
'n$ = INLINE$ (" n? ")
n$ = INFILE$ (Readnr)
IF INSTR(n$, "'") THEN GOTO begin
IF XLONG(LEFT$(n$, 9)) = 0 THEN GOTO eind

'd$ = INLINE$ (" d? ")
d$ = INFILE$ (Readnr)
IF XLONG(LEFT$(d$, 9)) < 1 THEN GOTO begin
XstClearConsole(): PRINT

Readst(n, n$): Readst(d, d$)
Copyf(d, qx): Rsft(qx, 1)
Printn(n,"  n = ", "", 2)
Printn(d,"  d = ", "", 2)
'
Letf(p0, 0): Letf(p1, 1)
Letf(q0, 1): Letf(q1, 0): t = 0
DO
   t = t + 1
   Divd(n, d, a) '                     finite continued fraction a_t
   Mult(a, p1, t0) '                  Euclid's algorithm:
   Swp(a, t0): Add(p0, t0) '           p_t = p_t-2 + a_t * p_t-1
   Mult(a, q1, t0)
   Swp(a, t0): Add(q0, t0) '           q_t = q_t-2 + a_t * q_t-1
   Swp(n, d): Swp(p0, p1): Swp(q0, q1)
   '
   Printn(a, "", "    (" + LTRIM$(STR$(t)) + ")", 1)
   Printn(p1, "  ", "", 1)
   Printn(q1, "  ", "", 1)
   '
   Squ(q1, t0)
   r = Cmp(t0, qx) = 1 '               check convergence
LOOP UNTIL Isf(d, 0) OR r
'
Setl(a, 2 * Getl(q1) / $$L10 - 5)
Printr(p1, q1, a, "p/q = ", "")
Prints("", 1)
GOTO begin
'
eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION
END PROGRAM
