'Subject: Prime factorization and arithmetic functions.
'         Trial division: quick check for factors up to 2^ 21.
'         Calculates Euler totient and Carmichael lambda functions,
'         also the divisor functions (a), w(a), (a), (a) and (a).
'Author : Sjoerd.J.Schaper
'Date   : 21-12-2003
'Code   : XBasic adaptation demo
PROGRAM	"trialdiv"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"
DECLARE FUNCTION VOID Main()
DECLARE FUNCTION VOID Afuncs(SLONG fr, SLONG k, SLONG sw)
$$lim = 2097143 '                     prime trial limit
'
FUNCTION VOID Main()
SHARED SLONG t0, t1, t2, t3, p, l, d, s, sq
t0 = $$ui + 1: t1 = $$ui + 2
t2 = $$ui + 3: t3 = $$ui + 4
a = 0: dr = 1: q = 2: p = 3: l = 4: d = 5: s = 6
r = LargeInit("trialdiv")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole()

Readnr = OPEN(WrkD$ + "\\trialdiv",$$RD)

begin:
'ai$ = INLINE$ (" a? ")
ai$ = INFILE$ (Readnr)
IF INSTR(ai$, "'") THEN GOTO begin
IF XLONG(LEFT$(ai$, 5)) < 1 THEN GOTO eind

Readst(a, ai$)
Printn(a, "    a = ", "", 2)
Afuncs(a, 0, 0)
pr = 0: sq = 0
IF Getl(a) > 2 THEN '                 preliminary tests
   sq = IsSqr(a, q)
   IF sq THEN Swp(a, q) '             a is square
   pr = IsPPrm(a, q, 7) '             a or sqrt(a) is pprime
END IF

IF pr THEN
   Afuncs(a, 1, 1)
ELSE
   Triald(q, a, $$lim): t = 0
   DO WHILE ExQ(dr, @k, q, @t)
      Afuncs(dr, k, 1)
   LOOP
   '
   IF NOT Isf(a, 1) THEN
      IF IsPPrm(a, q, 7) THEN
         Afuncs(a, 1, 1) '            prime cofactor
      ELSE
         Prints(" failure ", 2) '     quit job
         GOTO begin
      END IF
   END IF
END IF
Readst(a, ai$)
Afuncs(a, 0, 2) '                     print results
Prints("", 1)
GOTO begin

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION

FUNCTION VOID Afuncs (SLONG fr, SLONG k, SLONG sw)
SHARED SLONG t0, t1, t2, t3, p, l, d, s, sq
STATIC SLONG bo, o

SELECT CASE sw
CASE 0 '                             initialize
   Letf(p, 1): Letf(l, 1): Letf(s, 1) ' totient, lambda & divisor functions
   Letf(d, 1): o = 0: bo = 0
   '
CASE 1 '                              main
   g$ = "": IF sq THEN k = k * 2
   IF k > 1 THEN g$ = "^ " + LTRIM$(STR$(k))
   Printn(fr, SPACE$(8), g$, 1)
   '
   o = o + 1: bo = bo + k '           omega functions
   Letf(t2, k + 1)
   Mult(d, t2, t1) '                  s_0(a)
   Letf(t3, 1): Letf(t2, 1)
   FOR i = 1 TO k
      Copyf(t3, t0)
      Mult(t3, fr, t1)
      Add(t2, t3)
   NEXT i
   Mult(s, t2, t1) '                  s_1(a)
   Subt(t3, t0)
   Mult(p, t3, t1) '                  phi(a)
   IF Isf(fr, 2) AND (k > 2) THEN Rsft(t3, 1)
   Lcm(l, t3, fr): Swp(l, fr) '       lambda(a)
   '
CASE ELSE
   Printn(p, "totient  ", "", 2) '    size of the unit group (mod a)
   Printn(l, " lambda  ", "", 2) '    largest cyclic subgroup (mod a)
   m = 1 - 2 * (o AND 1) '            Moebius function
   IF bo > o THEN m = 0
   Prints("moebius " + STR$(m), 0) '  parity,
   Prints("   omega " + STR$(o), 0) '  distinct primefactors
   Prints("   bigOo " + STR$(bo), 1) '  total primefactors
   Printn(d, "numdivr  ", "", 1) '    number of divisors
   Printn(s, "sumdivr  ", "", 2) '     sum of all divisors
   Lsft(fr, 1): Subt(s, fr)
   Printn(s, "aliquot  ", "", 2) '    abundance s - 2a
END SELECT
END FUNCTION
END PROGRAM
