
PROGRAM	"basics"
VERSION	"0.0000"

	IMPORT	"xma"   		' Math library		 : Sin\Cos\Tan...
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT	"xsx"   		' Standard library : required by most programs
	IMPORT	"xio"			' Console IO library
	IMPORT  "gdi32"
	IMPORT	"user32"
	IMPORT  "kernel32"
	IMPORT  "turtle"

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hWnd, msg, wParam, lParam)

'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	WNDCLASS wc
	USER32_MSG msg
	
'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line

' get instance handle
	hInstance = GetModuleHandleA (0)

' define application name and window title
	szAppName$  = "Turtle"
	wintitle$   = "Basics"

' fill in WNDCLASS struct
	wc.style           = $$CS_HREDRAW OR $$CS_VREDRAW OR $$CS_OWNDC
	wc.lpfnWndProc     = &WndProc()
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInstance
	wc.hIcon           = LoadIconA (hInst, $$IDI_APPLICATION)		' load icon from resource file
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)			' use standard arrow cursor
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH)			' paint window background white
	wc.lpszMenuName    = 0
	wc.lpszClassName   = &szAppName$

' register window class
	IFZ RegisterClassA (&wc) THEN
		MessageBoxA(NULL, &"This program requires Windows NT!", &szAppName$, MB_ICONERROR)
		RETURN 0
	ENDIF
	

' create window
	hwnd = CreateWindowExA (0, &szAppName$, &wintitle$, $$WS_OVERLAPPEDWINDOW, 0, 0, 700, 700, 0, 0, hInst, 0)
	IFZ hwnd THEN QUIT (0)

' center window position in display
	XstCenterWindow (hwnd)

' show window
	ShowWindow (hwnd, $$SW_SHOWNORMAL)

' main message loop
	DO WHILE (GetMessageA(&msg, NULL, 0, 0))
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
	LOOP
	RETURN msg.wParam

' unregister window
	UnregisterClassA(&className$, hInst)
	
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
' This is the main window callback function

FUNCTION  WndProc (hWnd, msg, wParam, lParam)
	
	PAINTSTRUCT ps
	RECT wRect
	STATIC hdc
	
	SELECT CASE msg

		CASE $$WM_CREATE:
			
		
		CASE $$WM_SIZE:
			
			
			
	
		CASE $$WM_PAINT:
			hdc = BeginPaint (hWnd, &ps)
			InitialiseTurtle (hWnd, hdc, 1)	'origin = 1, (0,0) is centre of client area
			SetTurtleDelay(500)
		
		
			GoTo(-250,50)			'move to start point without a trail
			'draw a square
			Move(200)					'default heading is zero so this will draw up the page
			Turn(90)					'heading = 90 (East)
			Move(200)
			Turn(90)					'heading = 180 (South)
			Move(200)
			Turn(90)					'heading = 270 (West)
			Move(200)
			
			'draw an equilateral triangle 
			'Forward / Backward and Left / Right can be used instead of Move (+/-) Turn(+/-) if you prefer 
			GoTo(50,50)
			TurnTo(90)				'set initial heading to 90 degrees (East)
			Forward(200)
			Left(120)					'turn anticlockwise by the exterior angle
			Forward(200)
			Left(120)
			Forward(200)
			
			'draw a hexagon
			GoTo(0,-250)			'set initial position
			TurnTo(-60)				'and initial heading - minus means counterclockwise from north
			FOR i = 1 TO 6		'use loops to do repetitive things		
				Move(100)
				Right(60)
			NEXT i
			
			
			TerminateTurtle()
			EndPaint (hWnd, &ps)			
			
			
		CASE $$WM_DESTROY:
			
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
		
	END SELECT

END FUNCTION

END PROGRAM



