
PROGRAM	"curves" 
VERSION	"0.0000"

	IMPORT	"xma"   		' Math library		 : Sin\Cos\Tan...
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT	"xsx"   		' Standard library : required by most programs
	IMPORT	"xio"				' Console IO library
	IMPORT  "gdi32"
	IMPORT	"user32"
	IMPORT  "kernel32"
	IMPORT  "turtle"

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hWnd, msg, wParam, lParam)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	WNDCLASS wc
	USER32_MSG msg
	
	'XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line

' get instance handle
	hInstance = GetModuleHandleA (0)

' define application name and window title
	szAppName$  = "Turtle"
	wintitle$   = "Draw various curves with Scaling"

' fill in WNDCLASS struct
	wc.style           = $$CS_HREDRAW OR $$CS_VREDRAW OR $$CS_OWNDC
	wc.lpfnWndProc     = &WndProc()
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInstance
	wc.hIcon           = LoadIconA (hInst, $$IDI_APPLICATION)		' load icon from resource file
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)			' use standard arrow cursor
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH)			' paint window background white
	wc.lpszMenuName    = 0
	wc.lpszClassName   = &szAppName$

' register window class
	IFZ RegisterClassA (&wc) THEN
		MessageBoxA(NULL, &"This program requires Windows NT!", &szAppName$, MB_ICONERROR)
		RETURN 0
	ENDIF
	

' create window
	hwnd = CreateWindowExA (0, &szAppName$, &wintitle$, $$WS_OVERLAPPEDWINDOW, 0, 0, 750, 700, 0, 0, hInst, 0)
	IFZ hwnd THEN QUIT (0)

' center window position in display
	XstCenterWindow (hwnd)

' show window
	ShowWindow (hwnd, $$SW_SHOWNORMAL)

' main message loop
	DO WHILE (GetMessageA(&msg, NULL, 0, 0))
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
	LOOP
	RETURN msg.wParam

' unregister window
	UnregisterClassA(&className$, hInst)
	
	'XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
' This is the main window callback function

FUNCTION  WndProc (hWnd, msg, wParam, lParam)
	
	PAINTSTRUCT ps
	RECT wRect
	STATIC hdc
	
	SELECT CASE msg

		CASE $$WM_CREATE:
			
		
		CASE $$WM_SIZE:
			
			
			
	
		CASE $$WM_PAINT:
			hdc = BeginPaint (hWnd, &ps)
			
			InitialiseTurtle (hWnd, hdc, 1)
			SetTurtleRange(10#,250#)				'x = -5 to +5, y = -125 to +125
			
			'draw the axes
			SetTurtleStyle($$PS_DASH)
			GoTo(-5,0):MoveTo(+5,0)
			GoTo(0,125):MoveTo(0,-125)
			SetTurtleStyle($$PS_SOLID)
			
			SetTurtleWidth(3)
			SetTurtleDelay(10)
			
				'y = x^2
				SetTurtleColor($$BrightRed)
				GoTo(-5,25)
				FOR x# = -5 TO +5 STEP .05 
					y# = x# * x#
					MoveTo(x#,y#)
				NEXT x#
				
				'y = - x^2
				SetTurtleColor($$BrightGreen)
				GoTo(-5,-25)
				FOR x# = -5 TO +5 STEP .05 
					y# = -x# * x#
					MoveTo(x#,y#)
				NEXT x#
				
				'y = x^3
					SetTurtleColor($$BrightCyan)
				GoTo(-5,-125)
				FOR x# = -5 TO +5 STEP .05 
					y# = x# * x# * x#
					MoveTo(x#,y#)
				NEXT x#
				
				'y = -x^3
				SetTurtleColor($$BrightYellow)
				GoTo(-5,125)
				FOR x# = -5 TO +5 STEP .05 
					y# = -x# * x# *x#
					MoveTo(x#,y#)
				NEXT x#
				
				'y = x^4
				SetTurtleColor($$BrightBlue)
				GoTo(-5,625)			'this is offscreen to start with
				FOR x# = -5 TO +5 STEP .05 
					y# = x# * x# * x# * x# 
					MoveTo(x#,y#)
				NEXT x#
				
				'y = x^3 - 3x^2 + 7x - 9
				SetTurtleColor($$BrightMagenta)
				GoTo(-5,-244)			'this is offscreen to start with
				FOR x# = -5 TO +5 STEP .05
					x2# = x# * x#
					x3# = x2# * x#
					y# = x3# - (3 * x2#) + (7 * x#) - 9
					MoveTo(x#,y#)
				NEXT x#
				
				
			TerminateTurtle()
			EndPaint (hWnd, &ps)							
			
		CASE $$WM_DESTROY:
			
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
		
	END SELECT

END FUNCTION
END PROGRAM

