
PROGRAM	"hilbert2" 
VERSION	"0.0000"

	IMPORT	"xma"   		' Math library		 : Sin\Cos\Tan...
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT	"xsx"   		' Standard library : required by most programs
'	IMPORT	"xio"				' Console IO library
	IMPORT  "gdi32"
	IMPORT	"user32"
	IMPORT  "kernel32"
	IMPORT  "turtle"

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hWnd, msg, wParam, lParam)
DECLARE FUNCTION 	LeftHilbert (depth, side)
DECLARE FUNCTION 	RightHilbert (depth, side)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	WNDCLASS wc
	USER32_MSG msg
	
'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line

' get instance handle
	hInstance = GetModuleHandleA (0)

' define application name and window title
	szAppName$  = "Turtle"
	wintitle$   = "Hilbert Curve with recursive functions"

' fill in WNDCLASS struct
	wc.style           = $$CS_HREDRAW OR $$CS_VREDRAW OR $$CS_OWNDC
	wc.lpfnWndProc     = &WndProc()
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInstance
	wc.hIcon           = LoadIconA (hInst, $$IDI_APPLICATION)		' load icon from resource file
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)			' use standard arrow cursor
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH)			' paint window background white
	wc.lpszMenuName    = 0
	wc.lpszClassName   = &szAppName$

' register window class
	IFZ RegisterClassA (&wc) THEN
		MessageBoxA(NULL, &"This program requires Windows NT!", &szAppName$, MB_ICONERROR)
		RETURN 0
	ENDIF
	

' create window
	hwnd = CreateWindowExA (0, &szAppName$, &wintitle$, $$WS_OVERLAPPEDWINDOW, 0, 0, 700, 700, 0, 0, hInst, 0)
	IFZ hwnd THEN QUIT (0)

' center window position in display
	XstCenterWindow (hwnd)

' show window
	ShowWindow (hwnd, $$SW_SHOWNORMAL)

' main message loop
	DO WHILE (GetMessageA(&msg, NULL, 0, 0))
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
	LOOP
	RETURN msg.wParam

' unregister window
	UnregisterClassA(&className$, hInst)
	
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
' This is the main window callback function

FUNCTION  WndProc (hWnd, msg, wParam, lParam)
	
	PAINTSTRUCT ps
	RECT wRect
	STATIC hdc
	
	SELECT CASE msg

		CASE $$WM_CREATE:
			
		
		CASE $$WM_SIZE:
			
			
			
	
		CASE $$WM_PAINT:
			'experiment with different depths and sizes.
			'use (1,320), (2,160), (3,80), (4,40), (5,20), (6,10), (7,5), (8,2), (9,1)
			'at (9,1) the fact that the hilbert curve is a space filling curve becomes clear!
			'only use delay for lower depths
			
			hdc = BeginPaint (hWnd, &ps)	
			InitialiseTurtle (hWnd, hdc, 2)	'origin = 2, (0,0) is bottom left
			GoTo (30,30)										'move away from the edges
			'SetTurtleDelay(5)
			
			
			RightHilbert(5,20)
			
			
			TerminateTurtle()
			EndPaint (hWnd, &ps)
	
		CASE $$WM_DESTROY:
			
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
		
	END SELECT

END FUNCTION

FUNCTION LeftHilbert (depth, side)
	IF depth = 0 THEN
		RETURN
	ELSE
		Left (90)
		RightHilbert (depth - 1, side)
		Forward (side)
		Right (90)
		LeftHilbert (depth - 1, side)
		Forward (side)
		LeftHilbert (depth - 1, side)
		Right (90)
		Forward (side)
		RightHilbert (depth - 1, side)
		Left (90)
	ENDIF
END FUNCTION

FUNCTION RightHilbert (depth, side)
	IF depth = 0 THEN
		RETURN
	ELSE
		Right (90)
		LeftHilbert (depth - 1, side)
		Forward (side)
		Left (90)
		RightHilbert (depth - 1, side)
		Forward (side)
		RightHilbert (depth - 1, side)
		Left (90)
		Forward (side)
		LeftHilbert (depth - 1, side)
		Right (90)
	ENDIF
END FUNCTION
END PROGRAM






