
PROGRAM	"koch"
VERSION	"0.0000" 

	IMPORT	"xma"   		' Math library		 : Sin\Cos\Tan...
	IMPORT	"xst"   		' Standard library : required by most programs
	IMPORT	"xsx"   		' Standard library : required by most programs
'	IMPORT	"xio"				' Console IO library
	IMPORT  "gdi32"
	IMPORT	"user32"
	IMPORT  "kernel32"
	IMPORT  "turtle"

DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hWnd, msg, wParam, lParam)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	WNDCLASS wc
	USER32_MSG msg
	
	'XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line

' get instance handle
	hInstance = GetModuleHandleA (0)

' define application name and window title
	szAppName$  = "Turtle"
	wintitle$   = "Draw Kock Snowflake / Antiflake from Lstring"

' fill in WNDCLASS struct
	wc.style           = $$CS_HREDRAW OR $$CS_VREDRAW OR $$CS_OWNDC
	wc.lpfnWndProc     = &WndProc()
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInstance
	wc.hIcon           = LoadIconA (hInst, $$IDI_APPLICATION)		' load icon from resource file
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)			' use standard arrow cursor
	wc.hbrBackground   = GetStockObject ($$WHITE_BRUSH)			' paint window background white
	wc.lpszMenuName    = 0
	wc.lpszClassName   = &szAppName$

' register window class
	IFZ RegisterClassA (&wc) THEN
		MessageBoxA(NULL, &"This program requires Windows NT!", &szAppName$, MB_ICONERROR)
		RETURN 0
	ENDIF
	

' create window
	hwnd = CreateWindowExA (0, &szAppName$, &wintitle$, $$WS_OVERLAPPEDWINDOW, 0, 0, 750, 700, 0, 0, hInst, 0)
	IFZ hwnd THEN QUIT (0)

' center window position in display
	XstCenterWindow (hwnd)

' show window
	ShowWindow (hwnd, $$SW_SHOWNORMAL)

' main message loop
	DO WHILE (GetMessageA(&msg, NULL, 0, 0))
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
	LOOP
	RETURN msg.wParam

' unregister window
	UnregisterClassA(&className$, hInst)
	
	'XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
' This is the main window callback function

FUNCTION  WndProc (hWnd, msg, wParam, lParam)
	
	PAINTSTRUCT ps
	RECT wRect
	STATIC hdc
	
	SELECT CASE msg

		CASE $$WM_CREATE:
			
		
		CASE $$WM_SIZE:
			
			
			
	
		CASE $$WM_PAINT:
			
			hdc = BeginPaint (hWnd, &ps)
			InitialiseTurtle (hWnd, hdc, 1)
			
			
			in$ = "F--F--F"
			'SELECT ONE OR OTHER OF THESE TWO
			'rule$ = "F>F-F++F-F"  'Koch Anti- snowflake
			rule$ = "F>F+F--F+F"  'Kock snowflake
			d# = 600.0
			CreateColorSequence($$LightCyan,$$LightRed,$$BrightBlue,$$BrightYellow,$$LightGreen,$$Black,-1,-1)
			
			'Draw the initial triangle
			GoTo(170,-300)
			SetTurtleWidth(30)
			SetTurtleColor(NextColorInSequence())
			DrawLstring(in$,60.0,d#)
			
			'Draw each level down in different colour and thickness
			FOR level = 1 TO 5
				
				d# = d# / 3
				ls$ = ""
				GenerateLstring(in$,rule$,@ls$)
				GoTo(170,-300)
				TurnTo(0)
				SetTurtleColor(NextColorInSequence())
				SetTurtleWidth(26 - level * 5)
				SetTurtleDelay(75/(level * level))
				DrawLstring(ls$,60.0,d#)
				in$ = ls$
				
			NEXT level
			
			
			TerminateTurtle()
			EndPaint (hWnd, &ps)			
			
		CASE $$WM_DESTROY:
			
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
		
	END SELECT

END FUNCTION

