'
' ####################
' #####  PROLOG  #####
' ####################
'	Author: Alan Gent November 2009
'	Version: 1.00 Initial version
' Copyight: Alan Gent 2009
'
' This library is available for free use in any open source, private or commercial product
' provided that the authors name and copyright remain with the code.
' Use of this code is entirely at your own risk.
'
PROGRAM "unc"
VERSION "1.00"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
  IMPORT "kernel32"
	IMPORT "xio"

DECLARE FUNCTION Unc ()

EXPORT
'ANSI specific
DECLARE FUNCTION UncShowAnsi(ansi$, startChar, endChar, @report$)

'UTF8 specific
'NO Endian considerations
'NO terminating null
DECLARE FUNCTION UncMakeUTF8 (UBYTE u8[], ucChar$)
DECLARE FUNCTION UncWriteUTF8(UBYTE u8[], fileName$, bBOM)
DECLARE FUNCTION UncReadUTF8(UBYTE u8[], fileName$, bom$)
DECLARE FUNCTION UncValidateUTF8 (UBYTE u8[], @report$)
DECLARE FUNCTION UncRepairUTF8 (UBYTE u8[], UBYTE u8Copy[], action$, bNonCharacters, @report$)
DECLARE FUNCTION UncShowUTF8( UBYTE u8[], startChar, endChar, @report$)
DECLARE FUNCTION UncShowUTF8Glyphs( UBYTE u8[], startChar, endChar, @report%%[])
DECLARE FUNCTION UncCharsUTF8(UBYTE u8[], ucValue$, n)
DECLARE FUNCTION UncGetCharacterOffsetUTF8(UBYTE u8[], charNum)
DECLARE FUNCTION ULONG UncExtractCharacterUTF8(UBYTE u8[], charNum)
DECLARE FUNCTION ULONG UncSequentialParseUTF8(UBYTE u8[], @offset, @bEnd)
DECLARE FUNCTION UncGetByteSignificanceUTF8(UBYTE value)
DECLARE FUNCTION UncGetByteSignificance$()
DECLARE FUNCTION UncSubstringUTF8(UBYTE u8[], fromChar, toChar, UBYTE u8Sub[])

'UTF16 specific
'Endian considerations apply
'Null not required unless passed to Windows or C program when it is
'Best to convert to WideString when using with Windows / C functions - See utf16lib by Guy Lonne
DECLARE FUNCTION UncMakeUTF16(USHORT u16[], ucChar$)
DECLARE FUNCTION UncWriteUTF16(USHORT u16[], fileName$, standard$)
DECLARE FUNCTION UncReadUTF16(USHORT u16[], fileName$, bom$)
DECLARE FUNCTION UncValidateUTF16(USHORT u16[], @report$)
DECLARE FUNCTION UncRepairUTF16(USHORT u16[], USHORT u16Copy[], action$, bNonCharacters, @report$)
DECLARE FUNCTION UncShowUTF16 (USHORT u16[], startChar, endChar, @report$)
DECLARE FUNCTION UncShowUTF16Glyphs (USHORT u16[], startChar, endChar, @report%%[])
DECLARE FUNCTION UncSwapEndianUTF16(USHORT u16[])
DECLARE FUNCTION UncCharsUTF16(USHORT u16[], ucValue$, n)
DECLARE FUNCTION UncGetCharacterOffsetUTF16(USHORT u16[], charNum)
DECLARE FUNCTION ULONG UncExtractCharacterUTF16(USHORT u16[], charNum)
DECLARE FUNCTION ULONG UncSequentialParseUTF16(USHORT u16[], @offset, @bEnd)
DECLARE FUNCTION UncSubstringUTF16(USHORT u16[], fromChar, toChar, USHORT u16Sub[])

'WIDESTRING specific
DECLARE FUNCTION UncMakeWS(@wide$, ucChar$)  
DECLARE FUNCTION UncWriteWS(wide$, fileName$, standard$)
DECLARE FUNCTION UncReadWS(@wide$, fileName$, bom$)
DECLARE FUNCTION UncValidateWS(wide$, @report$)
DECLARE FUNCTION UncRepairWS(@wide$, @wideCopy$, action$, bNonCharacters, @report$)
DECLARE FUNCTION UncSwapEndianWS(@wide$)
DECLARE FUNCTION UncShowWS (wide$, startChar, endChar, @report$)
DECLARE FUNCTION UncShowWSGlyphs (wide$, startChar, endChar, @report%%[])
DECLARE FUNCTION UncNumCharactersWS(wide$)
DECLARE FUNCTION UncNumNullsWS(wide$)
DECLARE FUNCTION UncLengthWS(wide$)
DECLARE FUNCTION UncCharsWS(@wide$, ucValue$, n)
DECLARE FUNCTION UncTrailingNullsWS(@wide$, action$, cNulls)
DECLARE FUNCTION UncShowCodepointsWS(wide$, startChar, endChar, @report$)
DECLARE FUNCTION UncShowBlocksUsedWS(wide$, plane, @report$)
DECLARE FUNCTION UncShowPlanesUsedWS(wide$, @report$)
DECLARE FUNCTION UncShowHexCharWS(wide$, @report%%[])
DECLARE FUNCTION UncGetCharacterOffsetWS(wide$, charNum)
DECLARE FUNCTION ULONG UncExtractCharacterWS(wide$, charNum)
DECLARE FUNCTION ULONG UncSequentialParseWS(wide$, @offset, @bEnd)
DECLARE FUNCTION ULONG UncGetMaxCodepointWS(@wide$)
DECLARE FUNCTION UncConcatWS(@wide1$, wide2$)
DECLARE FUNCTION UncOpenInApplicationWS(wide$, application$)
DECLARE FUNCTION UncViewInConsoleWS(wide$)
DECLARE FUNCTION UncSubstringWS(wide$, fromChar, toChar, @subWide$)

'UTF32 specific
'Endian considerations apply
'NO terminating null
DECLARE FUNCTION UncMakeUTF32(ULONG u32[], ucChar$)
DECLARE FUNCTION UncWriteUTF32(ULONG u32[], fileName$, standard$)
DECLARE FUNCTION UncReadUTF32(ULONG u32[], fileName$, bom$)
DECLARE FUNCTION UncValidateUTF32(ULONG u32[], @report$)
DECLARE FUNCTION UncRepairUTF32(ULONG u32[], ULONG u32Copy[], action$, bNonCharacters, report$)
DECLARE FUNCTION UncShowUTF32 (ULONG u32[], startChar, endChar, @report$)
DECLARE FUNCTION UncShowUTF32Glyphs (ULONG u32[], startChar, endChar, @report%%[])
DECLARE FUNCTION UncSwapEndianUTF32(ULONG u32[])
DECLARE FUNCTION UncCharsUTF32(ULONG u32[], ucValue$, n)
DECLARE FUNCTION UncSubstringUTF32(ULONG u32[], fromChar, toChar, ULONG u32Sub[])
DECLARE FUNCTION ULONG UncExtractCharacterUTF32(ULONG u32[], charNum)

'GENERAL - work with UTFxx arrays
DECLARE FUNCTION UncTrailingNulls(ANY u[], action$, cNulls)
DECLARE FUNCTION UncNumNulls(ANY u[])
DECLARE FUNCTION UncLength(ANY u[])
DECLARE FUNCTION UncNumCharacters( ANY u[])
DECLARE FUNCTION UncShowCodepoints(ANY u[], startChar, endChar, @report$)
DECLARE FUNCTION UncShowHexChar(ANY u[], @report%%[])
DECLARE FUNCTION UncShowPlanesUsed(ANY u[], @report$)
DECLARE FUNCTION UncShowBlocksUsed(ANY u[], plane, @report$)
DECLARE FUNCTION UncDetermineProbableFormat(fileName$, @endian, @BOM)
DECLARE FUNCTION ULONG UncGetMaxCodepoint(ANY u[])
DECLARE FUNCTION UncConcat(ANY u1[], ANY u2[])
DECLARE FUNCTION UncOpenInApplication(ANY u[], application$)
DECLARE FUNCTION UncViewInConsole(ANY u[])

'CONVERSIONS
DECLARE FUNCTION UncConvertAnsiToUTF8(ansi$, UBYTE u8[])
DECLARE FUNCTION UncConvertAnsiToUTF16(ansi$, USHORT u16[])
DECLARE FUNCTION UncConvertAnsiToWS(ansi$, @wide$)
DECLARE FUNCTION UncConvertAnsiToUTF32(ansi$, ULONG u32[])
'
DECLARE FUNCTION UncConvertUTF8ToAnsi(UBYTE u8[], @ansi$)
DECLARE FUNCTION UncConvertUTF8ToWS(UBYTE u8[], @wide$)
DECLARE FUNCTION UncConvertUTF8ToUTF16(UBYTE u8[], USHORT u16[])
DECLARE FUNCTION UncConvertUTF8ToUTF32(UBYTE u8[], ULONG u32[])
'
DECLARE FUNCTION UncConvertUTF16ToAnsi(USHORT u16[], @ansi$)
DECLARE FUNCTION UncConvertUTF16ToWS(USHORT u16[], @wide$)
DECLARE FUNCTION UncConvertUTF16ToUTF8(USHORT u16[], UBYTE u8[])
DECLARE FUNCTION UncConvertUTF16ToUTF32(USHORT u16[], ULONG u32[])
'
DECLARE FUNCTION UncConvertUTF32ToAnsi(ULONG u32[], @ansi$)
DECLARE FUNCTION UncConvertUTF32ToWS(ULONG u32[], @wide$)
DECLARE FUNCTION UncConvertUTF32ToUTF8(ULONG u32[], UBYTE u8[])
DECLARE FUNCTION UncConvertUTF32ToUTF16(ULONG u32[], USHORT u16[])
'
DECLARE FUNCTION UncConvertWSToAnsi(wide$, @ansi$)
DECLARE FUNCTION UncConvertWSToUTF8(wide$, UBYTE u8[])
DECLARE FUNCTION UncConvertWSToUTF16(wide$, USHORT u16[])
DECLARE FUNCTION UncConvertWSToUTF32(wide$, ULONG u32[])
'

'CODE PAGE MAPPINGS - based on Windows MultiByte functions
DECLARE FUNCTION UncMapAnsiToUTF16(ansi$, codePage, USHORT u16[])
DECLARE FUNCTION UncMapUTF16ToAnsi(USHORT u16[], codePage, @ansi$)


'Low level functions
'CODEPOINT
DECLARE FUNCTION UncCodepointToSurrogatePair(codepoint&&, @hiWord%%, @loWord%%)
DECLARE FUNCTION ULONG UncSurrogatePairToCodepoint(hiWord%%, loWord%%)
DECLARE FUNCTION ULONG UncGetCodepointFromUTF16(@address)
DECLARE FUNCTION UncEmitCodepointAsUTF16(codepoint&&, @address)
DECLARE FUNCTION ULONG UncGetCodepointFromUTF8(@address)
DECLARE FUNCTION UncEmitCodepointAsUTF8(codepoint&&, @address)
DECLARE FUNCTION UncLengthAsUTF8(codepoint&&)
DECLARE FUNCTION UncIsValidCodepoint (codepoint&&)							
DECLARE FUNCTION UncIsNonCharacter (codepoint&&)
DECLARE FUNCTION UncIsPrivateUse (codepoint&&)


'GENERAL
DECLARE FUNCTION UncSetAsciiSubstitutionChar(asciiCode)						'note XLONG needed here to allow -1
DECLARE FUNCTION UncSetUnicodeSubstitutionChar(codepoint)					'note XLONG needed here to allow -1
DECLARE FUNCTION UncSetMakeSeparator(asciiCode)										'note XLONG needed here to allow -1
DECLARE FUNCTION UncSetAutoNull(bTrueFalse)												
DECLARE FUNCTION UncSetConcatNullMode(mode$)
DECLARE FUNCTION UncSetSubstringNullMode(mode$)

'Constants
$$MAX_CODEPOINT				= 0x10FFFF		'1,114,111 = highest valid codepoint allowed in unicode
$$FIRST_PLANE1				= 0x10000			'65,536	any codepoint >= this value generates a surrogate pair in UTF16 / WideString
$$BOM16 							= 0xFEFF			'Normal 16 bit BOM - LE machine stores as FFFE - BE machine stores as FEFF 
$$INVERSE_BOM16				= 0xFFFE			'Inverted 16 bit BOM - used to emulate BE output on LE machine
$$BOM32								= 0x0000FEFF	'Normal 32 bit BOM - LE machine stores as FFFE0000 - BE machine stores as 0000FEFF
$$INVERSE_BOM32   		= 0xFFFE0000	'Inverted 32 bit BOM - used to emulate BE output on LE machine
$$DEFAULT_SUB_ASCII		= '?'					'Used as substitute character in Ansi and individual bytes of UTF8 sequences
$$DEFAULT_SUB_UTF   	= '?'					'Used as substitute character for complete UTF8 sequences, UTF16 code units, WideString code units and UTF32 
$$HIGH_FIRST					= 0xD800			'Start of UTF16 High surrogate range 
$$HIGH_LAST						= 0xDBFF			'End of UTF16 High surrogate range 
$$LOW_FIRST						= 0xDC00			'Start of UTF16 Low surrogate range
$$LOW_LAST						= 0xDFFF			'End of UTF16 Low surrogate range           
END EXPORT

'Internal functions not exported
INTERNAL FUNCTION AnalyseFixUTF8(UBYTE @result[], bRepair, bNonCharacters, @report$)
INTERNAL FUNCTION StringToCodepoint(val$, codepoint&&)
INTERNAL FUNCTION DisplayCodepointRange(ULONG u32[], startChar, endChar, @report$)
INTERNAL FUNCTION PlanesUsed(ULONG u32[], @report$)
INTERNAL FUNCTION FitToRange(@start, @end, upper)
INTERNAL FUNCTION HexChar(ULONG u32[], @report%%[])
INTERNAL FUNCTION FromTo(@fromChar, @toChar, nChars)



' ######################
' #####  Unc()     #####
' ######################

FUNCTION	Unc()
'Initialise global variables
	#SUB_ASCII					= $$DEFAULT_SUB_ASCII		'"?" in line with Windows - change with UncSetAsciiSubstitutionChar()
	#SUB_UTF						= $$DEFAULT_SUB_UTF			'"?" in line with Windows - change with UncSetUnicodeSubstitutionChar()
	#AUTONULL						= $$FALSE								'Null not added by default - change with UncSetAutoNull()
	#SEPARATOR$					= ","										'Separator for MAKE functions - change with UncSetMakeSeparator()
	#CONCAT_MODE  			= $$TRUE								'Remove Nulls from first of concatenated arrays , WideStrings
	#SUBSTRING_NULLS		= $$TRUE								'Include trailing nulls when substringing
	'Following defines an Xblite string which shares the utf8ByteSignificance table
	'The xblite string header is pre-defined immediately preceding the table
	#UTF8SIG$ = ""																			'handle = 0
ASM mov d[%#UTF8SIG$.unc], ADDR utf8ByteSignificance	;set handle to table address, this can now be referenced through the string

END FUNCTION

'MAKE FUNCTIONs****************************************************************************************************************
'******************************************************************************************************************************
FUNCTION UncMakeUTF8(UBYTE u8[],ucChar$)
'Make a UTF-8 array

	IFZ ucChar$ THEN RETURN $$TRUE
	
	XstParseStringToStringArray (ucChar$, #SEPARATOR$, @uc$[])
	
	maxLen = LEN(ucChar$)													'Maximum possible output characters
	upper = UBOUND(uc$[])	
	IF upper < 0 THEN DIM u8[]: RETURN 0					'Empty string - no terminating null	
	
	IF u8[] THEN
		IF #CONCAT_MODE THEN UncTrailingNulls(@u8[],"LEAVE",0)
		existing = UBOUND(u8[])	
		REDIM u8[existing + (maxLen <<< 2)]								
		outIndex = &u8[] + existing + 1 
	ELSE
		DIM u8[maxLen <<< 2]
		outIndex = &u8[]
	ENDIF 

	outLen = 0
	
	bError = $$FALSE
	FOR c = 0 TO upper
		val$ = uc$[c]
		len = LEN(val$)
		
		'Process specials
		IF len > 2	THEN
			ret = 0		
			IF val${0} = '&' THEN
				GOSUB OutputCodepoint: DO NEXT
			ELSE
				first2$ = LEFT$(val$,2)
				SELECT CASE first2$
					CASE "0x", "0o", "0b", "U+"
						GOSUB OutputCodepoint: DO NEXT
				END SELECT
			ENDIF
		ENDIF
		
		'Ansi stuff
		IF len > 0	THEN											'Ignore null input strings
			FOR i = 0 TO len - 1
				UncEmitCodepointAsUTF8 (val${i}, @outIndex)
			NEXT i
		ENDIF
		
	NEXT c
	
	seqLen = (outIndex - &u8[]) - 1
	
	REDIM u8[seqLen]											'Trim off unused slots
	RETURN bError
	
SUB OutputCodepoint
	IF StringToCodepoint(@val$, @codepoint&&) THEN codepoint&& = #SUB_UTF: bError = $$TRUE
	UncEmitCodepointAsUTF8 (codepoint&&, @outIndex)
END SUB
	
END FUNCTION


FUNCTION UncMakeUTF16(USHORT u16[],ucChar$)
'Make a unicode ushort array - covers all planes and generates valid surrogate pairs where needed

	IFZ ucChar$ THEN RETURN $$TRUE 
	XstParseStringToStringArray (ucChar$, #SEPARATOR$, @uc$[])
	
	maxLen = LEN(ucChar$)													'Maximum possible output characters
	upper = UBOUND(uc$[])
	IF upper < 0 THEN DIM u16[0]: RETURN 					'Empty string - just terminating 0x0000 
	
	IF u16[] THEN
		IF #CONCAT_MODE THEN UncTrailingNulls (@u16[], "LEAVE", 0)
		existing = UBOUND(u16[])	
		REDIM u16[existing + maxLen]								
		outIndex = existing + 1
	ELSE
		DIM u16[maxLen]
		outIndex = 0
	ENDIF
	
	bError = $$FALSE
	FOR c = 0 TO upper
		val$ = uc$[c]
		len = LEN(val$)
		
		'Process specials
		IF len > 2	THEN
			ret = 0		
			IF val${0} = '&' THEN
				GOSUB OutputCodepoint: DO NEXT
			ELSE
				first2$ = LEFT$(val$,2)
				SELECT CASE first2$
					CASE "0x", "0o", "0b", "U+"
						GOSUB OutputCodepoint: DO NEXT
				END SELECT
			ENDIF
		ENDIF
		
		'Ansi stuff
		IF len > 0	THEN											'Ignore null input strings
			FOR i = 0 TO len - 1
				u16[outIndex] = val${i}
				INC outIndex
			NEXT i
		ENDIF
		
	NEXT c
	
	IFF #AUTONULL THEN DEC outIndex			'leave terminating null if required
	REDIM u16[outIndex]									'Trim off unused slots
	RETURN bError
	
SUB OutputCodepoint
	IF StringToCodepoint(@val$, @codepoint&&) THEN codepoint&& = #SUB_UTF: bError = $$TRUE
	IF codepoint&& < $$FIRST_PLANE1 THEN			'Plane 0 BMP
		u16[outIndex] = USHORT(codepoint&&)
		INC outIndex
	ELSE
		'Planes 1 to 16
		UncCodepointToSurrogatePair(codepoint&&, @hiWord%%, @loWord%%)
		u16[outIndex] = hiWord%%
		INC outIndex
		u16[outIndex] = loWord%%
		INC outIndex
	ENDIF							
END SUB
	
END FUNCTION


FUNCTION UncMakeWS(@wide$, ucChar$)
'Make a wide string - covers all planes and generates valid surrogate pairs where needed

	IFZ ucChar$ THEN RETURN $$TRUE 
	XstParseStringToStringArray (ucChar$, #SEPARATOR$, @uc$[])
	
	maxLen = LEN(ucChar$)																	'Maximum possible output characters
	upper = UBOUND(uc$[])
	IF upper < 0 THEN RETURN
	
	IF wide$ THEN
		IF #CONCAT_MODE THEN UncTrailingNullsWS (@wide$, "LEAVE", 0) 	'Strip off any trailing nulls ready to append	
		startLen = LEN(wide$)										
		wide$ = wide$ + NULL$((maxLen <<< 2) + 2)							'Max number of bytes required = 4 per character + 2 null bytes
		writeP = &wide$ + startLen
	ELSE
		startLen = 0
		wide$ = NULL$((maxLen <<< 2) + 2)
		writeP = &wide$
	ENDIF
	
	bError = $$FALSE
	FOR c = 0 TO upper
		val$ = uc$[c]
		len = LEN(val$)
		
		'Process specials
		IF len > 2	THEN
			ret = 0		
			IF val${0} = '&' THEN
				GOSUB OutputCodepoint: DO NEXT
			ELSE
				first2$ = LEFT$(val$,2)
				SELECT CASE first2$
					CASE "0x", "0o", "0b", "U+"
						GOSUB OutputCodepoint: DO NEXT
				END SELECT
			ENDIF
		ENDIF
		
		'Ansi stuff
		IF len > 0	THEN											'Ignore null input strings
			FOR i = 0 TO len - 1
			USHORTAT(writeP) = val${i}
			writeP = writeP + 2
			NEXT i
		ENDIF
		
	NEXT c
	
	actualBytes = writeP - &wide$
	IF #AUTONULL THEN actualBytes = actualBytes + 2 
	wide$ = LEFT$(wide$, actualBytes)				'Trim off unused slots
	RETURN bError
	
SUB OutputCodepoint
	IF StringToCodepoint(@val$, @codepoint&&) THEN codepoint&& = #SUB_UTF: bError = $$TRUE
	UncEmitCodepointAsUTF16(codepoint&&, @writeP)
END SUB

END FUNCTION



FUNCTION UncMakeUTF32(ULONG u32[], ucChar$)
'Make a unicode ulong array - utf32

	IFZ ucChar$ THEN RETURN $$TRUE
	XstParseStringToStringArray (ucChar$, #SEPARATOR$, @uc$[])
	
	maxLen = LEN(ucChar$)					'Maximum possible output characters
	upper = UBOUND(uc$[])
	IF upper < 0 THEN RETURN  		'Empty string - just terminating 0x0000
	
	IF u32[] THEN
		IF #CONCAT_MODE THEN UncTrailingNulls(@u32[],"LEAVE",0)
		existing = UBOUND(u32[])	
		REDIM u32[existing + maxLen]								
		outIndex = existing + 1
	ELSE
		DIM u32[maxLen]
		outIndex = 0
	ENDIF

	
	bError = $$FALSE
	FOR c = 0 TO upper
		val$ = uc$[c]
		len = LEN(val$)
		
		'Process specials
		IF len > 2	THEN
			ret = 0		
			IF val${0} = '&' THEN
				GOSUB OutputCodepoint: DO NEXT
			ELSE
				first2$ = LEFT$(val$,2)
				SELECT CASE first2$
					CASE "0x", "0o", "0b", "U+"
						GOSUB OutputCodepoint: DO NEXT
				END SELECT
			ENDIF
		ENDIF
		
		'Ansi stuff
		IF len > 0	THEN											'Ignore null input strings
			FOR i = 0 TO len - 1
				u32[outIndex] = ULONG(val${i})
				INC outIndex
			NEXT i
		ENDIF
		
	NEXT c
	
	REDIM u32[outIndex - 1]											'Trim off unused slots
	RETURN bError
	
SUB OutputCodepoint
	IF StringToCodepoint(@val$, @codepoint&&) THEN codepoint&& = #SUB_UTF: bError = $$TRUE
	u32[outIndex] = codepoint&&
	INC outIndex
END SUB

END FUNCTION

'******************************************************************************************************************************
'CHARS FUNCTIONS ***************************************************************************************************************
'******************************************************************************************************************************
FUNCTION UncCharsUTF8(UBYTE u8[], ucValue$, nRep)
'Make UTF8 text of nRep repeats of character represented by ucValue$

	IF nRep < 1 THEN RETURN $$TRUE
	IFZ ucValue$ THEN RETURN $$TRUE
	
	IF LEN(ucValue$) = 1 THEN
		codepoint&& = ucValue${0}
	ELSE
		IF StringToCodepoint(ucValue$, @codepoint&&) THEN RETURN $$TRUE
	ENDIF
	
	IFZ u8[] THEN
		upper = -1
		DIM u8[(nRep <<< 2) - 1]			'worst case is 4 bytes per character
		base = &u8[]
	ELSE
		IF #CONCAT_MODE THEN UncTrailingNulls(@u8[],"LEAVE",0)
		upper = UBOUND(u8[])
		REDIM u8[upper + (nRep <<< 2)]
		base = &u8[] + upper + 1
	ENDIF
	
	'Encode just once into buffer
	buffer$ = NULL$(4)
	buffAddress = &buffer$
	cBytes = UncEmitCodepointAsUTF8 (codepoint&&, buffAddress)	'Note no @ on buffAddress so it stays fixed!
	
	'Copy buffer nRep times
	SELECT CASE cBytes
		CASE 1
			val@@ = buffer${0}
			FOR i = 0 TO nRep - 1
				UBYTEAT(base,[i]) = val@@
			NEXT i
			
		CASE 2
			val%% = USHORTAT(buffAddress)
			FOR i = 0 TO nRep - 1
				USHORTAT(base,[i]) = val%%
			NEXT i
			
		CASE 3
			val%% = USHORTAT(buffAddress)
			val@@ = buffer${2}
			FOR i = 0 TO nRep - 1
				USHORTAT(base) =	val%%					
				UBYTEAT(base + 2) = val@@
				base = base + 3
			NEXT i
			
		CASE 4
			val&& = ULONGAT(buffAddress)
			FOR i = 0 TO nRep - 1
				ULONGAT(base,[i]) = val&&
			NEXT i
			
		CASE ELSE RETURN $$TRUE
	END SELECT		
	
	REDIM u8[upper + (nRep * cBytes)]
	
END FUNCTION


FUNCTION UncCharsUTF16(USHORT u16[], ucValue$, nRep)
'Make UTF16 text of nRep repeats of character represented by ucValue$

	IF nRep < 1 THEN RETURN $$TRUE
	IFZ ucValue$ THEN RETURN $$TRUE
	
	IF LEN(ucValue$) = 1 THEN
		codepoint&& = ASC(ucValue$)
	ELSE
		IF StringToCodepoint(ucValue$, @codepoint&&) THEN RETURN $$TRUE
	ENDIF
	
	IF codepoint&& < $$FIRST_PLANE1 THEN
		
		IFZ u16[] THEN
			start = 0: stop = nRep - 1  
			IFF #AUTONULL THEN DEC nRep
			DIM u16[nRep]
		ELSE
			IF #CONCAT_MODE THEN UncTrailingNulls(@u16[],"LEAVE",0)
			upper = UBOUND(u16[])
			start = upper + 1	 
			newUpper = upper + nRep
			stop = newUpper
			IF #AUTONULL THEN INC newUpper
			REDIM u16[newUpper]
		ENDIF
		
		val%% = USHORT(codepoint&&) 
		FOR i = start TO stop
			u16[i] = val%%
		NEXT i
		
	ELSE
		
		nWords = nRep <<< 1			'2 words per value
		
		IFZ u16[] THEN
			start = 0: stop = nWords - 2
			upper = nWords  
			IFF #AUTONULL THEN DEC upper
			DIM u16[upper]
		ELSE
			IF #CONCAT_MODE THEN UncTrailingNulls(@u16[],"LEAVE",0)
			upper = UBOUND(u16[])
			start = upper + 1	 
			newUpper = upper + nWords
			stop = newUpper
			IF #AUTONULL THEN INC newUpper
			REDIM u16[newUpper]
		ENDIF
		
		UncCodepointToSurrogatePair(codepoint&&, @hiWord%%, @loWord%%)
		
		FOR i = start TO stop STEP 2
			u16[i] = hiWord%%
			u16[i + 1] = loWord%%
		NEXT i
		
	ENDIF

END FUNCTION


FUNCTION UncCharsWS(wide$, ucValue$, nRep)
'Make WideString text of nRep repeats of character represented by ucValue$

	IF nRep < 1 THEN RETURN $$TRUE
	IFZ ucValue$ THEN RETURN $$TRUE
	
	IF LEN(ucValue$) = 1 THEN
		codepoint&& = ASC(ucValue$)
	ELSE
		IF StringToCodepoint(ucValue$, @codepoint&&) THEN RETURN $$TRUE
	ENDIF
	
	IF codepoint&& < $$FIRST_PLANE1 THEN
		val%% = USHORT(codepoint&&)
		
		IFZ wide$ THEN
			wide$ = NULL$(nRep <<< 1)		'2 bytes per character
			base = &wide$ 
		ELSE
			IF #CONCAT_MODE THEN UncTrailingNullsWS(@wide$,"LEAVE",0)
			len = LEN(wide$)
			wide$ = wide$ + NULL$(nRep <<< 1)	 
			base = &wide$ + len 
		ENDIF
		
		FOR i = 0 TO nRep - 1
			USHORTAT(base,[i]) = val%%
		NEXT i
		
	ELSE
		UncCodepointToSurrogatePair(codepoint&&, @hiWord%%, @loWord%%)
		
		IFZ wide$ THEN
			wide$ = NULL$(nRep <<< 2)
			base = &wide$
		ELSE
			IF #CONCAT_MODE THEN UncTrailingNullsWS(@wide$,"LEAVE",0)
			len = LEN(wide$)
			wide$ = wide$ + NULL$(nRep <<< 2)	 
			base = &wide$ + len
		ENDIF
		
		FOR i = 0 TO ((nRep - 1) <<< 1) STEP 2
			USHORTAT(base,[i]) = hiWord%%
			USHORTAT(base,[i + 1]) = loWord%%
		NEXT i
		
	ENDIF

	IF #AUTONULL THEN wide$ = wide$ + "\0\0"
	
END FUNCTION


FUNCTION UncCharsUTF32(ULONG u32[], ucValue$, nRep)
'Make UTF32 text of nRep repeats of character represented by ucValue$

	IF nRep < 1 THEN RETURN $$TRUE
	IFZ ucValue$ THEN RETURN $$TRUE
	
	IF LEN(ucValue$) = 1 THEN
		codepoint&& = ASC(ucValue$)
	ELSE
		IF StringToCodepoint(ucValue$, @codepoint&&) THEN RETURN $$TRUE
	ENDIF
	
	
	IFZ u32[] THEN
		DIM u32[nRep - 1]
		start = 0: end = nRep - 1
	ELSE
		IF #CONCAT_MODE THEN UncTrailingNulls(@u32[],"LEAVE",0)
		upper = UBOUND(u32[])
		start = upper + 1
		end = upper + nRep		
		REDIM u32[end] 
	ENDIF
	
	FOR i = start TO end
		u32[i] = codepoint&&
	NEXT i

END FUNCTION

'******************************************************************************************************************************
'WRITE FUNCTIONS **************************************************************************************************************
'******************************************************************************************************************************
FUNCTION UncWriteUTF8(UBYTE u8[], fileName$, bBOM)
'Write a UBYTE UTF8 array to a file

	IFZ u8[] THEN RETURN $$TRUE
	IFZ fileName$ THEN RETURN $$TRUE
	
	'Open the file for write
	fNum = OPEN(fileName$, $$WRNEW)
	IF fNum < 3 THEN RETURN $$TRUE
	
	IF bBOM THEN
		DIM temp@@[2]
		UncEmitCodepointAsUTF8 ( 0xFEFF, &temp@@[])
		WRITE [fNum], temp@@[]
	ENDIF

	WRITE [fNum], u8[]
	
	CLOSE(fNum)

END FUNCTION


FUNCTION UncWriteUTF16(USHORT u16[], fileName$, standard$)
'Write a USHORT UTF16 array to a file

	IFZ u16[] THEN RETURN $$TRUE
	IFZ fileName$ THEN RETURN $$TRUE

	standard$ = UCASE$(standard$)
	swap = $$FALSE
	
	SELECT CASE standard$
		CASE "BIG"
			BOM%% = $$INVERSE_BOM16: swap = $$TRUE
		CASE "UTF16" 
			BOM%% = $$BOM16
		CASE "UTF16LE"
			BOM%% = 0
		CASE "UTF16BE"
			BOM%% = 0: swap = $$TRUE
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	fNum = OPEN(fileName$, $$WRNEW)
	IF fNum < 3 THEN RETURN $$TRUE
	
	IF BOM%% THEN WRITE [fNum], BOM%%
	
	IF swap THEN 
		'Swap to Big Endian
		XstCopyArray(@u16[], @temp%%[])
		UncSwapEndianUTF16(@temp%%[])			
		WRITE [fNum], temp%%[]
	ELSE
		WRITE [fNum], u16[]
	ENDIF
	
	CLOSE(fNum)	
	
END FUNCTION


FUNCTION UncWriteWS(wide$, fileName$, standard$)

'Save WS to a file. 
'UTF-16 standard requires a BOM 
'BOM not required for UTF-16BE or UTF-16LE.

	IFZ wide$ THEN RETURN $$TRUE
	IFZ fileName$ THEN RETURN $$TRUE
	
	standard$ = UCASE$(standard$)
	swap = $$FALSE
	
	SELECT CASE standard$
		CASE "BIG"
			BOM%% = $$INVERSE_BOM16: swap = $$TRUE
		CASE "UTF16" 
			BOM%% = $$BOM16
		CASE "UTF16LE"
			BOM%% = 0
		CASE "UTF16BE"
			BOM%% = 0: swap = $$TRUE
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	fNum = OPEN(fileName$, $$WRNEW)
	IF fNum < 3 THEN RETURN $$TRUE
	
	IF BOM%% THEN WRITE [fNum], BOM%%
	
	IF swap THEN 
		'Swap to Big Endian
		tempWide$ = wide$
		UncSwapEndianWS(@tempWide$)			
		WRITE [fNum], tempWide$
	ELSE
		WRITE [fNum], wide$
	ENDIF	

	CLOSE(fNum)
	
END FUNCTION


FUNCTION UncWriteUTF32(ULONG u32[], fileName$, standard$)
'UTF-32 standard requires a BOM 
'BOM not required for UTF-32BE or UTF-32LE.

	IFZ u32[] THEN RETURN $$TRUE
	IFZ fileName$ THEN RETURN $$TRUE

	
	standard$ = UCASE$(standard$)
	swap = $$FALSE
	
	SELECT CASE standard$
		CASE "BIG"
			BOM = $$INVERSE_BOM32: swap = $$TRUE
		CASE "UTF32" 
			BOM = $$BOM32
		CASE "UTF32LE"
			BOM = 0
		CASE "UTF32BE"
			BOM = 0: swap = $$TRUE
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	fNum = OPEN(fileName$, $$WRNEW)
	IF fNum < 3 THEN RETURN $$TRUE
	

	IF BOM THEN WRITE [fNum], BOM
	
	IF swap THEN 
		'Swap to Big Endian
		XstCopyArray(@u32[], @temp&&[])
		UncSwapEndianUTF32(@temp&&[])			
		WRITE [fNum], temp&&[]
	ELSE
		WRITE [fNum], u32[]
	ENDIF

	CLOSE(fNum)
	
END FUNCTION

'******************************************************************************************************************************
'READ FUNCTIONS ***************************************************************************************************************
'******************************************************************************************************************************
FUNCTION UncReadUTF8(UBYTE u8[], fileName$, bom$)
'Read a file of UTF-8 data into a UBYTE array

	IFZ fileName$ THEN RETURN $$TRUE

	bom$ = UCASE$(bom$)
	SELECT CASE bom$
		CASE "BOM","BOM_STRIP","NONE","KEEP","STRIP"
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	'Open the file for read
	fNum = OPEN(fileName$, $$RD)
	IF fNum < 3 THEN RETURN $$TRUE
	
	len = LOF(fNum)
	IF len < 1 THEN RETURN $$TRUE
	
	DIM temp@@[len - 1]
	READ [fNum], temp@@[]
	CLOSE(fNum)
	
	'See if the first sequence is a BOM - endian makes no difference
	IF UncGetCodepointFromUTF8 (&temp@@[]) = 0xFEFF THEN
		'BOM present
		SELECT CASE bom$
			CASE "NONE"
				RETURN $$TRUE
			CASE "BOM", "KEEP"
				DIM u8[]: ATTACH temp@@[] TO u8[]
			CASE "BOM_STRIP", "STRIP"
				remainder = len - 3
				IF remainder < 1 THEN DIM u8[]: RETURN
				DIM u8[remainder - 1]
				XstCopyMemory(&temp@@[] + 3, &u8[], remainder)
		END SELECT
		
	ELSE
		'No BOM present
		SELECT CASE bom$
			CASE "BOM", "BOM_STRIP"
				RETURN $$TRUE
			CASE "NONE", "KEEP", "STRIP"
				DIM u8[]: ATTACH temp@@[] TO u8[]
			CASE ELSE RETURN $$TRUE
		END SELECT
	ENDIF
	
END FUNCTION


FUNCTION UncReadUTF16(USHORT u[], fileName$, bom$)
'Read unicode array from file into a Little Endian machine

'bom$ can be as follows:	(BE = Big Endian, LE = Little Endian)
'BOM, UTF-16							-	there must be a BOM 	- error if not
'													- IF BOM = BE strip the BOM, load remaining data, swap bytes 
'													- IF BOM = LE strip the BOM, load remaining data
' 
'BIG_NONE, UTF-16BE 			-	there must be no BOM - error if there is, otherwise load data assuming BE, swap bytes
'BIG_STRIP								- there may be a BOM but if present strip it off, load remaining data, swap bytes
'BIG_KEEP									- there may be a BOM but if present load it as part of data, swap bytes
'BIG_CHECK								- there may be a BOM. If it is LE then error. Otherwise strip it if present, load remaining data, swap bytes 
'LITTLE_NONE, UTF-16LE		- there must be no BOM - error if there is, otherwise load data assuming little endian
'LITTLE_STRIP							- there may be a BOM but if present strip it off, load remaining data
'LITTLE_KEEP							- there may be a BOM but if present load it as part of data
'LITTLE_CHECK							- there may be a BOM. If it is BE then error. Otherwise strip it, load remaining data
'AUTO_BIG									- If BOM present, load as BOM above. If no BOM present assume BE, load data, swap bytes
'AUTO_LITTLE							- If BOM present, load as BOM above. If no BOM present assume LE, load data

'UTF16 specifies a BOM must be present - to enforce this use "BOM" or "UTF-16"
'But a few applications do not add one
'		Use AUTO_LITTLE or AUTO_BIG which will process the BOM if present or default to LE / BE if it is missing

'UTF16BE and UTF16LE specify no BOM....this can be enforced with "BIG_NONE" or "UTF-16BE" / "LITTLE_NONE" or "UTF-16LE" 
'But some applications add one anyway! There are then a number of options.
'			STRIP it off and ignore it - use BIG_STRIP or LITTLE_STRIP
'     include it as part of the data to load - use BIG_KEEP / LITTLE_KEEP 	
'     CHECK to see if it agrees with the expected endian. Error if not, strip it if it does - use BIG_CHECK or LITTLE_CHECK
'			Default to BE or LE if no BOM. If BOM present this overrides the default - use AUTO_BIG or AUTO_LITTLE


	'Check input parameters
	IFZ fileName$ THEN RETURN $$TRUE
	bom$ = UCASE$(bom$)
	SELECT CASE bom$
		CASE "BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","BOM","AUTO_BIG","AUTO_LITTLE"
		CASE "UTF-16","UTF-16BE","UTF-16LE"
		CASE ELSE RETURN $$TRUE
	END SELECT
		
	'Open the file for read
	fNum = OPEN(fileName$, $$RD)
	IF fNum < 3 THEN GOTO error
	
	'Check even number of bytes and at least 2 bytes 
	fLen = LOF(fNum)
	IF fLen < 2 THEN GOTO error
	IF (fLen AND 1) THEN GOTO error
	
	'Read first word to see if it is a valid BOM
	READ [fNum], BOM%%
		
	SELECT CASE BOM%%
		CASE $$BOM16
				'Valid LITTLE ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-16","BOM","LITTLE_STRIP","LITTLE_CHECK","AUTO_BIG","AUTO_LITTLE"
						GOSUB ReadData
					CASE "BIG_STRIP"
						GOSUB ReadData: UncSwapEndianUTF16(@u[])
					CASE "BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianUTF16(@u[])
					CASE "LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG_NONE,UTF-16BE,LITTLE_NONE,UTF-16LE,BIG_CHECK
						GOTO error
				END SELECT
		CASE $$INVERSE_BOM16
				'Valid BIG ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-16","BOM","BIG_STRIP","BIG_CHECK","AUTO_LITTLE","AUTO_BIG"
						GOSUB ReadData:	UncSwapEndianUTF16(@u[])
					CASE "BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianUTF16(@u[])
					CASE "LITTLE_STRIP"
						GOSUB ReadData
					CASE "LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG_NONE,UTF-16BE,LITTLE_NONE,UTF-16LE,LITTLE_CHECK
						GOTO error
				END SELECT
		CASE ELSE
				'First word is NOT A VALID BOM
				SELECT CASE bom$
					CASE "UTF-16BE","BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","AUTO_BIG"
						GOSUB ReadAll:	UncSwapEndianUTF16(@u[])
					CASE "UTF-16LE","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","AUTO_LITTLE"
						GOSUB ReadAll
					CASE ELSE	'UTF-16,BOM
						GOTO error
				END SELECT
				
	END SELECT
		
SUB ReadAll
'Read entire file into array - including the BOM if present.
	SEEK(fNum,0)						'rewind to read the first word / BOM again
	DIM u[(fLen >>> 1) - 1]
	READ [fNum], u[]
END SUB

SUB ReadData
'Read data only after dropping BOM
	DIM u[(fLen >>> 1) - 2]
	READ [fNum], u[]
END SUB

	CLOSE(fNum)
	RETURN 
	
error:
	CLOSE(fNum)
	RETURN $$TRUE
	
END FUNCTION


FUNCTION UncReadWS(wide$, fileName$, bom$)
'Read unicode array from file into a Little Endian machine

'bom$ can be as follows:	(BE = Big Endian, LE = Little Endian)
'BOM, UTF-16							-	there must be a BOM 	- error if not
'													- IF BOM = BE strip the BOM, load remaining data, swap bytes 
'													- IF BOM = LE strip the BOM, load remaining data
' 
'BIG_NONE, UTF-16BE 			-	there must be no BOM - error if there is, otherwise load data assuming BE, swap bytes
'BIG_STRIP								- there may be a BOM but if present strip it off, load remaining data, swap bytes
'BIG_KEEP									- there may be a BOM but if present load it as part of data, swap bytes
'BIG_CHECK								- there may be a BOM. If it is LE then error. Otherwise strip it if present, load remaining data, swap bytes 
'LITTLE_NONE, UTF-16LE		- there must be no BOM - error if there is, otherwise load data assuming little endian
'LITTLE_STRIP							- there may be a BOM but if present strip it off, load remaining data
'LITTLE_KEEP							- there may be a BOM but if present load it as part of data
'LITTLE_CHECK							- there may be a BOM. If it is BE then error. Otherwise strip it, load remaining data
'AUTO_BIG									- If BOM present, load as BOM above. If no BOM present assume BE, load data, swap bytes
'AUTO_LITTLE							- If BOM present, load as BOM above. If no BOM present assume LE, load data

'UTF16 specifies a BOM must be present - to enforce this use "BOM" or "UTF-16"
'But a few applications do not add one
'		Use AUTO_LITTLE or AUTO_BIG which will process the BOM if present or default to LE / BE if it is missing

'UTF16BE and UTF16LE specify no BOM....this can be enforced with "BIG_NONE" or "UTF-16BE" / "LITTLE_NONE" or "UTF-16LE" 
'But some applications add one anyway! There are then a number of options.
'			STRIP it off and ignore it - use BIG_STRIP or LITTLE_STRIP
'     include it as part of the data to load - use BIG_KEEP / LITTLE_KEEP 	
'     CHECK to see if it agrees with the expected endian. Error if not, strip it if it does - use BIG_CHECK or LITTLE_CHECK
'			Default to BE or LE if no BOM. If BOM present this overrides the default - use AUTO_BIG or AUTO_LITTLE


	'Check input parameters
	IFZ fileName$ THEN RETURN $$TRUE
	bom$ = UCASE$(bom$)
	SELECT CASE bom$
		CASE "BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","BOM","AUTO_BIG","AUTO_LITTLE"
		CASE "UTF-16","UTF-16BE","UTF-16LE"
		CASE ELSE RETURN $$TRUE
	END SELECT

	'Open the file for read
	fNum = OPEN(fileName$, $$RD)
	IF fNum < 3 THEN GOTO error
	
	'Check even number of bytes and at least 2 bytes 
	fLen = LOF(fNum)
	IF fLen < 2 THEN GOTO error
	IF (fLen AND 1) THEN GOTO error
	
	'Read first word to see if it is a valid BOM
	READ [fNum], BOM%%

	SELECT CASE BOM%%
		CASE $$BOM16
				'Valid LITTLE ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-16","BOM","LITTLE_STRIP","LITTLE_CHECK","AUTO_BIG","AUTO_LITTLE"
						GOSUB ReadData
					CASE "BIG_STRIP"
						GOSUB ReadData: UncSwapEndianWS(wide$)
					CASE "BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianWS(wide$)
					CASE "LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG_NONE,UTF-16BE,LITTLE_NONE,UTF-16LE,BIG_CHECK
						GOTO error
				END SELECT
		CASE $$INVERSE_BOM16
				'Valid BIG ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-16","BOM","BIG_STRIP","BIG_CHECK","AUTO_LITTLE","AUTO_BIG"
						GOSUB ReadData:	UncSwapEndianWS(wide$)
					CASE "BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianWS(wide$)
					CASE "LITTLE_STRIP"
						GOSUB ReadData
					CASE "LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG_NONE,UTF-16BE,LITTLE_NONE,UTF-16LE,LITTLE_CHECK
						GOTO error
				END SELECT
		CASE ELSE
				'First word is NOT A VALID BOM
				SELECT CASE bom$
					CASE "UTF-16BE","BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","AUTO_BIG"
						GOSUB ReadAll:	UncSwapEndianWS(wide$)
					CASE "UTF-16LE","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","AUTO_LITTLE"
						GOSUB ReadAll
					CASE ELSE	'UTF-16,BOM
						GOTO error
				END SELECT
				
	END SELECT
	
SUB ReadAll
'Read entire file into string - including the BOM if present.
	SEEK(fNum,0)						'rewind to read the first word / BOM again
	wide$ = NULL$(fLen)
	READ [fNum], wide$
END SUB

SUB ReadData
'Read data only after dropping BOM
	wide$ = NULL$(fLen - 2)
	READ [fNum], wide$
END SUB

	CLOSE(fNum)
	RETURN 
	
error:
	CLOSE(fNum)
	RETURN $$TRUE
	
END FUNCTION


FUNCTION UncReadUTF32(ULONG u[], fileName$, bom$)
'Read UTF32 file into Little Endian machine

	'Check input parameters
	IFZ fileName$ THEN RETURN $$TRUE
	bom$ = UCASE$(bom$)
	SELECT CASE bom$
		CASE "BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","BOM","AUTO_BIG","AUTO_LITTLE"
		CASE "UTF-32","UTF-32BE","UTF-32LE"
		CASE ELSE RETURN $$TRUE
	END SELECT
		
	'Open the file for read
	fNum = OPEN(fileName$, $$RD)
	IF fNum < 3 THEN GOTO error
	
	'Check number of bytes is multiple of 4 and at least 4 bytes 
	fLen = LOF(fNum)
	IF fLen < 4 THEN GOTO error
	IF (fLen AND 3) THEN GOTO error
	
	'Read first word to see if it is a valid BOM
	READ [fNum], BOM
		
	SELECT CASE BOM
		CASE $$BOM32
				'Valid LITTLE ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-32","BOM","LITTLE_STRIP","LITTLE_CHECK","AUTO_BIG","AUTO_LITTLE"
						GOSUB ReadData
					CASE "BIG_STRIP"
						GOSUB ReadData: UncSwapEndianUTF32(@u[])
					CASE "UTF-32BE","BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianUTF32(@u[])
					CASE "UTF-32LE","LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG,LITTLE,BIGCHECK
						GOTO error
				END SELECT
		CASE $$INVERSE_BOM32
				'Valid BIG ENDIAN BOM
				SELECT CASE bom$
					CASE "UTF-32","BOM","BIG_STRIP","BIG_CHECK","AUTO_LITTLE","AUTO_BIG"
						GOSUB ReadData:	UncSwapEndianUTF32(@u[])
					CASE "UTF-32BE","BIG_KEEP"
						GOSUB ReadAll: UncSwapEndianUTF32(@u[])
					CASE "LITTLE_STRIP"
						GOSUB ReadData
					CASE "UTF-32LE","LITTLE_KEEP"
						GOSUB ReadAll
					CASE ELSE	'BIG,LITTLE,LITTLE_CHECK
						GOTO error
				END SELECT
		CASE ELSE
				'First word is NOT A VALID BOM
				SELECT CASE bom$
					CASE "UTF-32BE","BIG_NONE","BIG_STRIP","BIG_KEEP","BIG_CHECK","AUTO_BIG"
						GOSUB ReadAll:	UncSwapEndianUTF32(@u[])
					CASE "UTF-32LE","LITTLE_NONE","LITTLE_STRIP","LITTLE_KEEP","LITTLE_CHECK","AUTO_LITTLE"
						GOSUB ReadAll
					CASE ELSE	'UTF-32,BOM
						GOTO error
				END SELECT
				
	END SELECT
	
SUB ReadAll
'Read entire file into array - including the BOM if present.
	SEEK(fNum,0)						'rewind to read the first word / BOM again
	DIM u[(fLen >>> 2) - 1]
	READ [fNum], u[]
END SUB

SUB ReadData
'Read data only after dropping BOM
	DIM u[(fLen >>> 2) - 2]
	READ [fNum], u[]
END SUB

	CLOSE(fNum)
	RETURN 
	
error:
	CLOSE(fNum)
	RETURN $$TRUE
	
END FUNCTION


'********************************************************************************************************************************	
' VALIDATE / REPAIR *************************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncValidateUTF8 (UBYTE u8[], report$)
'Report any problems with UTF8 text in u8[]
'Front end to AnalyseFixUTF8
	IFZ u8[] THEN RETURN $$TRUE
	'Call with REPAIR FLAG false - u8[] is not changed - just validated
	RETURN AnalyseFixUTF8(@u8[], $$FALSE, $$TRUE, @report$)
END FUNCTION

FUNCTION UncRepairUTF8 (UBYTE u8[], UBYTE u8Copy[], action$, bNonCharacters, report$)
'Repair any problems with UTF8 text in u8[]
	IFZ u8[] THEN RETURN $$TRUE
	
	action$ = UCASE$(action$)
	SELECT CASE action$
		CASE "REMOVE"
			oldSubChar = #SUB_ASCII
			#SUB_ASCII = 0xFF			'Use special substitution that is illegal in UTF8
		CASE "REPLACE"
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	'Make a copy to do the repair on
	XstCopyArray (@u8[], @u8Copy[])
		
	'Call with REPAIR FLAG set
	AnalyseFixUTF8(@u8Copy[], $$TRUE, bNonCharacters, @report$)
	
	IF action$ = "REMOVE" THEN
		'Strip out the special characters
		upper = UBOUND(u8Copy[])
		readP = 0
		writeP = 0
		bWriteRequired = $$FALSE
		FOR readP = 0 TO upper
			val@@ = u8Copy[readP]
			IF val@@ <> 0xFF THEN
				IF bWriteRequired THEN u8Copy[writeP] = val@@
				INC writeP
			ELSE
				bWriteRequired = $$TRUE
			ENDIF
		NEXT readP
		IF writeP < readP THEN REDIM u8Copy[writeP - 1]
		
		'Restore the substitution character
		#SUB_ASCII = oldSubChar
	ENDIF
	
END FUNCTION


FUNCTION AnalyseFixUTF8(UBYTE result[], bRepair, bNonCharacters, report$)
'Low level routine not exported	
	len = UBOUND(result[]) + 1
	resultAddress = &result[]
	
	'Build a string holding the significance value for each byte in the utf8 sequence	
	sig$ = NULL$(len)
	sigAddress = &sig$

ASM mov ebx, ADDR utf8ByteSignificance								;for use with xlatb
ASM mov esi, d[AnalyseFixUTF8.resultAddress]
ASM mov edi, d[AnalyseFixUTF8.sigAddress]
ASM mov ecx, d[AnalyseFixUTF8.len]

ASM sigloop:
ASM 	mov al, b[esi]
ASM 	xlatb 
ASM 	mov b[edi], al
ASM		inc esi
ASM 	inc edi
ASM 	dec ecx
ASM 	jne < sigloop

	
'Now analyse the string for valid / invalid sequences
'	? sig$
	index = 0
	indexMax = LEN(sig$) - 1

	IF bRepair THEN
		report$ = " Repair UTF8:\r\n\r\n"
		IF #SUB_ASCII = 0xFF THEN
			act$ = " - REMOVED"
		ELSE
			act$ = " - REPLACED"
		ENDIF
	ELSE
		report$ = " Validate UTF8:\r\n\r\n"
	ENDIF	

	bError = $$FALSE
	DO WHILE index <= indexMax
		val = sig${index}: INC index
		SELECT CASE val
			CASE '1'
				'Single ASCII byte - cannot be invalid or Non-character
				
			CASE '2'
				'Start of 2 byte sequence - cannot be invalid or Non-character
				IF MID$(sig$, index, 2) <> "2F" THEN
					err$ = "  Invalid 2 byte sequence"
					GOSUB WriteError
					GOSUB Synchronise
				ELSE
					'The second byte value does not need checking separately
					'The significance table checks 0x80 to 0xBF as required
					INC index 'skip the valid follow on bytes
				ENDIF

			CASE '3'
				'Start of 3 byte sequence
				nBytes = 3
				IF MID$(sig$, index, 3) <> "3FF" THEN
					err$ = "  Invalid 3 byte sequence"
					GOSUB WriteError
					GOSUB Synchronise				
				ELSE
					GOSUB CheckByte2
					IF err$ THEN
						GOSUB WriteError
						GOSUB Synchronise					
					ELSE
						'valid sequence
						IF bNonCharacters THEN GOSUB CheckForNonChars
						index = index + 2 'skip the valid follow on bytes
					ENDIF
				ENDIF

			CASE '4'
				'Start of 4 byte sequence
				nBytes = 4
				IF MID$(sig$, index, 4) <> "4FFF" THEN
					err$ = "  Invalid 4 byte sequence"
					GOSUB WriteError
					GOSUB Synchronise
				ELSE
					GOSUB CheckByte2
					IF err$ THEN
						GOSUB WriteError
						GOSUB Synchronise					
					ELSE
						'valid sequence
						IF bNonCharacters THEN GOSUB CheckForNonChars
						index = index + 3 'skip the valid follow on bytes
					ENDIF
				ENDIF

			CASE 'F'
					'All 'F's that are part of valid sequence are skipped over
					'These 'F's are surplus or part of an invalid sequence 
					err$ = "  Follow on byte with no lead byte"
					GOSUB WriteError
			CASE 'L'
					err$ = "  Overlong encoding"
					GOSUB WriteError
			CASE 'R'
					'This catches 5 and 6 byte encodings which although valid are not allowed in unicode files
					'The follow on bytes will be flagged individually as well
					err$ = "  Restricted Range - 5 or 6 byte encoding"
					GOSUB WriteError
			CASE 'I'
					err$ = "  Invalid byte"
					GOSUB WriteError
			CASE ELSE
					'This should never happen unless signature table is altered / corrupted
					err$ = "  Unknown significance code"
					GOSUB WriteError
		END SELECT
	LOOP
	
	IFZ bError THEN	report$ = report$ + " No errors found\r\n"
	RETURN bError
	

SUB WriteError
	'Write error line
	bError = $$TRUE
	report$ = report$ + " At Offset = " + HEX$(index - 1,8) + err$ + act$ + "\r\n"
	'Optionally space out offending sequences and invalid bytes 
	IF bRepair THEN result[index - 1] = #SUB_ASCII
END SUB

SUB Synchronise
	'Read until find a non-follow on byte or end of file
	DO WHILE index <= indexMax
		IF bRepair THEN result[index - 1] = #SUB_ASCII						'Still duff stuff
		IF sig${index} <> 'F' THEN EXIT SUB												'Back to main loop to vet this character
		INC index
	LOOP
	'Fix last character
	IF bRepair result[index - 1] = #SUB_ASCII	
END SUB


SUB CheckByte2
'Check special cases where range of 2nd byte is not 0x80 to 0xBF
'Overlong encodings not detected by Significance table, codepoint corresponds to lone surrogate value, codepoint is out of range (> 0x10FFFF)
	byte2@@ = result[index]
	err$ = ""
	SELECT CASE nBytes
		CASE 3
			'Check special cases for 3 byte sequences
			SELECT CASE result[index - 1]
				CASE 0xE0
					IF byte2@@ < 0xA0 THEN err$ = "  Overlong encoding as 3 byte sequence"
				CASE 0xED
					IF byte2@@ > 0x9F THEN err$ = "  Sequence decodes to lone surrogate value"
			END SELECT
		CASE 4
			'Check special cases for 4 byte sequences
			SELECT CASE result[index - 1]
				CASE 0xF0
					IF byte2@@ < 0x90 THEN err$ = "  Overlong encoding as 4 byte sequence"
				CASE 0xF4
					IF byte2@@ > 0x8F THEN err$ = "  Sequence decodes to value > 0x10FFFF"
			END SELECT
	END SELECT

	IF err$ THEN bError = $$TRUE
END SUB

SUB CheckForNonChars
'Valid 3 or 4 byte sequence
	codepoint&& = UncGetCodepointFromUTF8(resultAddress + index - 1)	
	err$ = ""
	IF UncIsNonCharacter(codepoint&&) THEN
		err$ = "  Warning, Non-character"
		GOSUB WriteError
		IF bRepair THEN
			FOR i = -1 TO nBytes - 2
				IF (index + i) <= indexMax THEN UBYTEAT(resultAddress + index + i) = #SUB_ASCII 
			NEXT i
		ENDIF
	ENDIF

END SUB

END FUNCTION


FUNCTION UncValidateWS(wide$, @report$)
'Report any problems with text in wide$
	IFZ wide$ THEN report$ = "Widestring is empty": RETURN $$TRUE
	
	IF UncConvertWSToUTF16 (wide$, @temp%%[]) THEN report$ = "Widestring invalid": RETURN $$TRUE	
	RETURN UncValidateUTF16(@temp%%[], @report$)
	
END FUNCTION


FUNCTION UncRepairWS(wide$, wideCopy$, action$, bNonCharacters, report$)
'Repair any problems with wide$
	IFZ wide$ THEN RETURN $$TRUE
	IFZ action$ THEN RETURN $$TRUE
	
	IF UncConvertWSToUTF16 (wide$, @temp%%[]) THEN RETURN $$TRUE
	result = UncRepairUTF16(@temp%%[], @tempCopy%%[], action$, bNonCharacters, @report$)
	UncConvertUTF16ToWS (@tempCopy%%[], @wideCopy$)
	
	RETURN result
END FUNCTION


FUNCTION UncValidateUTF16(USHORT u16[], @report$)
'Report any problems with UTF16 text in u16[]
	IFZ u16[] THEN report$ = "Array is empty": RETURN $$TRUE
	
	upper = UBOUND(u16[])
	index  = 0
	report$ = " Validate UTF16 / WideString:\r\n\r\n Offset    Codepoint  UTF16 Encoding\r\n\r\n"
	
	DO WHILE index <= upper
		val%% = u16[index]
		
		SELECT CASE TRUE
			CASE (val%% < $$HIGH_FIRST	) || (val%% > $$LOW_LAST)
				'Normal character in 1 USHORT
				GOSUB Report
				IF UncIsNonCharacter(val%%) THEN report$ = report$ + "        <<< Warning, Non-character" 
				
			CASE (val%% >= $$HIGH_FIRST	) && (val%% <= $$HIGH_LAST)
				'High Surrogate detected
				IF index < upper THEN
					'Check for following Low Surrogate
					val2%% = u16[index + 1]
					IF (val2%% >= $$LOW_FIRST	) && (val2%% <= $$LOW_LAST) THEN
						'Low surrogate so have valid pair
						codepoint&& = UncSurrogatePairToCodepoint(val%%, val2%%)
						'Special report line needed
						report$ = report$ + " " + HEX$(index <<< 1,8) + "  U+" + HEX$(codepoint&&,6) + "   " + HEX$(val%%,4) + "  " + HEX$(val2%%,4)
						IFF UncIsValidCodepoint(codepoint&&) THEN
							report$ = report$ + "  <<< Invalid Codepoint"
						ELSE
							IF UncIsNonCharacter(codepoint&&) THEN report$ = report$ + "  <<< Warning, Non-character"
						ENDIF
						INC index		'Skip the Low surrogate which has been processed now
					ELSE
						'Lone High Surrogate
						GOSUB Report
						report$ = report$ + "        <<< Lone High Surrogate"
					ENDIF
				ELSE
					'Lone High Surrogate - nothing at all follows
					GOSUB Report
					report$ = report$ + "        <<< Lone High Surrogate"
				ENDIF
				
			CASE (val%% >= $$LOW_FIRST	) && (val%% <= $$LOW_LAST)
				'Lone Low Surrogate - would have been processed above if paired
				GOSUB Report
				report$ = report$ + "        <<< Lone Low Surrogate"
				
			CASE ELSE RETURN $$TRUE
			
		END SELECT
		INC index
		report$ = report$ + "\r\n"
	LOOP
	
SUB Report
	report$ = report$ + " " + HEX$(index <<< 1,8) + "  U+" + HEX$(val%%,6) + "   " + HEX$(val%%,4)
END SUB

END FUNCTION


FUNCTION UncRepairUTF16(USHORT u16[], USHORT u16Copy[], action$, bNonCharacters, report$)
'action$ can be
'REMOVE	Remove invalid surrogates only. Leave valid pairs
'REPLACE Replace invalid surrogates only with 0xFFFD

	IFZ u16[] THEN RETURN $$TRUE
	IFZ action$ THEN RETURN $$TRUE
	
	'Perform repair on a copy 
	XstCopyArray(@u16[],@u16Copy[])
	
	readP = 0
	writeP = 0
	upper = UBOUND(u16Copy[])
	bWriteRequired = $$FALSE
	report$ = " Repair UTF16 / WideString:\r\n\r\n"
	
	SELECT CASE UCASE$(action$)
		
		CASE "REMOVE"	'REMOVE standalone surrogate and invalid pairs
			
			act$ = " - REMOVED"										
			DO WHILE readP <= upper
				val%% = u16Copy[readP]
				SELECT CASE TRUE
					CASE (val%% < $$HIGH_FIRST	) || (val%% > $$LOW_LAST)
						'Normal character in 1 USHORT
						IF bNonCharacters && UncIsNonCharacter (val%%) THEN
							GOSUB RemoveNonCharacter
						ELSE
							IF bWriteRequired THEN u16Copy[writeP] = val%%
							INC writeP
						ENDIF
					CASE (val%% >= $$HIGH_FIRST	) && (val%% <= $$HIGH_LAST)
						'High Surrogate detected
						IF readP < upper THEN
							'Check for following Low Surrogate
							val2%% = u16Copy[readP + 1]
							IF (val2%% >= $$LOW_FIRST	) && (val2%% <= $$LOW_LAST) THEN
								'Low surrogate so have valid pair
								IF bNonCharacters THEN
									cp&& = UncSurrogatePairToCodepoint (val%%, val2%%)
									IF UncIsNonCharacter (cp&&) THEN
										GOSUB RemoveNonCharacter
									ELSE
										GOSUB WritePairRemoval
									ENDIF
								ELSE
									GOSUB WritePairRemoval
								ENDIF
								INC readP
							ELSE
								'Lone High Surrogate - remove it by doing nothing
								rep$ = "Lone Surrogate"
								GOSUB Report
								bWriteRequired = $$TRUE								
							ENDIF
						ELSE
							'Lone High Surrogate - nothing at all follows - remove by doing nothing
							rep$ = "Lone Surrogate"
							GOSUB Report
							bWriteRequired = $$TRUE								
						ENDIF
						
					CASE (val%% >= $$LOW_FIRST	) && (val%% <= $$LOW_LAST)
						'Lone Low Surrogate - would have been processed above if paired
						rep$ = "Lone Surrogate"
						GOSUB Report
						bWriteRequired = $$TRUE								

					CASE ELSE RETURN $$TRUE
				END SELECT
				INC readP
				LOOP
			
			IF writeP <> readP THEN REDIM u16Copy[writeP - 1]
				
		CASE "REPLACE"	'REPLACE standalone with 0xFFFD, replace invalid pair with a single 0xFFFD
															'Standalone surrogates are always invalid
															'Pairs must be HighWord, lowWord to be valid - these are retained
															'Two highs, two lows or low, high are all invalid and replaced 
			act$ = " - REPLACED"

			DO WHILE readP <= upper
				val%% = u16Copy[readP]
				IF (val%% < $$HIGH_FIRST	) || (val%% > $$LOW_LAST) THEN
				'Normal Character in 1 USHORT
					IF bNonCharacters && UncIsNonCharacter (val%%) THEN
						u16Copy[readP] = #SUB_UTF
						rep$ = "Non-character "
						GOSUB Report
					ENDIF
					INC readP
				ELSE
				'Surrogate found - see if it is a standalone or first of pair
					IF readP < upper THEN
						val2%% = u16Copy[readP + 1]
						IF (val2%% < $$HIGH_FIRST	) || (val2%% > $$LOW_LAST) THEN
							'val2%% is a normal character so replace a standalone
							u16Copy[readP] = #SUB_UTF
							rep$ = "Lone Surrogate"
							GOSUB Report
							INC readP					
						ELSE
							'Have a pair - see if it is valid
							bHighValid = $$FALSE: bLowValid = $$FALSE
							IF (val%% >= $$HIGH_FIRST) && (val%% <= $$HIGH_LAST) THEN bHighValid = $$TRUE		'Valid highWord comes first
							IF (val2%% >= $$LOW_FIRST) && (val2%% <= $$LOW_LAST) THEN bLowValid = $$TRUE		'Valid lowWord comes second
							IF bHighValid && bLowValid
								'Valid pair
								IF bNonCharacters THEN
									cp&& = UncSurrogatePairToCodepoint (val%%, val2%%)
									IF UncIsNonCharacter (cp&&) THEN
										rep$ = "Non-character "
										GOSUB Report
										GOSUB ReplacePair
									ENDIF
								ENDIF
							ELSE
								'Replace invalid pair
								rep$ = "Invalid surrogate pair"
								GOSUB Report
								GOSUB ReplacePair
							ENDIF
							readP = readP + 2
						ENDIF
					ELSE
						'First surrogate is last USHORT - nothing follows so invalid
						u16Copy[readP] = #SUB_UTF
						rep$ = "Lone Surrogate"
						GOSUB Report
						INC readP	'This will now terminate loop
					ENDIF	
				ENDIF
			LOOP
			
	END SELECT
	
SUB Report
	'Offset relates to the original array
	report$ = report$ + " At Offset =  " + HEX$(readP <<< 1,8) + "  " + rep$ + act$ + "\r\n"
END SUB

SUB RemoveNonCharacter
	rep$ = "Non-character "
	GOSUB Report
	bWriteRequired = $$TRUE
END SUB

SUB WritePairRemoval
'Write or leave a valid surrogate pair
	IF bWriteRequired THEN
		u16Copy[writeP] = val%%		:INC writeP
		u16Copy[writeP] = val2%%	:INC writeP
	ELSE
		writeP = writeP + 2
	ENDIF
END SUB

SUB ReplacePair
'Can be either invalid pair or Non-character
	u16Copy[readP] = #SUB_UTF
	u16Copy[readP + 1] = #SUB_UTF
END SUB

END FUNCTION


FUNCTION UncValidateUTF32(ULONG u32[], @report$)
'Report any problems with UTF32 text in u32[]
	IFZ u32[] THEN RETURN $$TRUE
	
	upper = UBOUND(u32[])
	index = 0
	report$ = " ValidateUTF32:\r\n\r\n Offset    Codepoint\r\n\r\n"
	
	DO WHILE index <= upper
		codepoint&& = u32[index]		
		report$ = report$ + " " + HEX$(index <<< 2,8) + "  U+" + HEX$(codepoint&&,8)
		
		IF UncIsValidCodepoint(codepoint&&) THEN
			IF UncIsNonCharacter(codepoint&&) THEN	report$ = report$ + "  <<< Warning, Non-character"
		ELSE
			report$ = report$ + "  <<< Invalid Codepoint"
		ENDIF
		report$ = report$ + "\r\n"
		INC index
	LOOP
	
END FUNCTION


FUNCTION UncRepairUTF32(ULONG u32[], ULONG u32Copy[], action$, bNonCharacters, report$)
'Repair any problems with UTF32 text in u32[]
	IFZ u32[] THEN RETURN $$TRUE
	
	XstCopyArray(@u32[], @u32Copy[])
	report$ = " RepairUTF32:\r\n\r\n"
		
	SELECT CASE UCASE$(action$)
		CASE "REPLACE"
		
			act$ = " - REPLACED"
			FOR i = 0 TO UBOUND(u32Copy[])
				codepoint&& = u32Copy[i]
				
				IFF UncIsValidCodepoint(codepoint&&) THEN
					rep$ = "  Invalid Codepoint" 
					GOSUB Report
					u32Copy[i] = #SUB_UTF
				ELSE
				  IF bNonCharacters THEN
						IF UncIsNonCharacter(codepoint&&) THEN
							rep$ = "  Non-Character    "
							GOSUB Report
							u32Copy[i] = #SUB_UTF	
						ENDIF					
					ENDIF
				ENDIF			
			NEXT i
				
			
		CASE "REMOVE"
		
			act$ = " - REMOVED"
			bWriteRequired = $$FALSE
			outIndex = 0
			FOR i = 0 TO UBOUND(u32Copy[])
				codepoint&& = u32Copy[i]
				
				IF !UncIsValidCodepoint(codepoint&&) THEN
					rep$ = "  Invalid Codepoint" 
					'Write no output
					bWriteRequired = $$TRUE
					GOSUB Report
				ELSE
				  IF bNonCharacters THEN
						IF UncIsNonCharacter(codepoint&&) THEN
							rep$ = "  Non-Character    "
							'Write no output
							bWriteRequired = $$TRUE
							GOSUB Report
						ELSE
							IF bWriteRequired THEN	u32Copy[outIndex] = codepoint&&
							INC outIndex					
						ENDIF
					ELSE
						IF bWriteRequired THEN	u32Copy[outIndex] = codepoint&&
						INC outIndex				
					ENDIF
				ENDIF			
			NEXT i
			
			REDIM u32Copy[outIndex - 1]			
			
		CASE ELSE RETURN $$TRUE
		
	END SELECT
	
SUB Report
	report$ = report$ + " At Offset =  " + HEX$(i <<< 2,8) + rep$ + act$ + "\r\n" 
END SUB

END FUNCTION

'*******************************************************************************************************************
'SHOW FUNCTIONS ****************************************************************************************************
'*******************************************************************************************************************

FUNCTION UncShowAnsi(ansi$, startChar, endChar, report$)
'Display detailed content of ansi$

	IFZ ansi$ THEN report$ = "Ansi string is empty": RETURN $$TRUE
	report$ = " Show Ansi:\r\n\r\n CharNum  Offset    Codepoint  Ansi  Char (ACP)\r\n\r\n"
	length = LEN(ansi$)
	FitToRange(@startChar, @endChar, length)

	FOR i = startChar - 1 TO endChar - 1
		val@@ = ansi${i}
		report$ = report$ + RJUST$(STRING(i + 1),8) + "  " + HEX$(i,8) + "  U+" + HEX$(val@@,6)
		
		IF val@@ = #SUB_ASCII THEN
			report$ = report$ + " < " + HEX$(val@@,2)
		ELSE
			report$ = report$ + "   " + HEX$(val@@,2)
		ENDIF
		
		IF val@@ > 31 THEN report$ = report$ + "    " + CHR$(val@@)
	
		report$ = report$ + "\r\n"
	NEXT i
END FUNCTION


FUNCTION UncShowUTF8( UBYTE u8[], startChar, endChar, report$)
'Display detailed content of u8[]

	IFZ u8[] THEN report$ = "UTF8 array is empty": RETURN $$TRUE
	report$ = " Show UTF8:\r\n\r\n CharNum  Offset    Codepoint  UTF8 Encoding\r\n\r\n"

	maxChar = UncNumCharacters (@u8[])
	FitToRange(@startChar, @endChar, maxChar)


	base = &u8[]
	address = base + UncGetCharacterOffsetUTF8 (@u8[], startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF8 (@address)
		GOSUB Common
		'Display the actual utf8 bytes
		FOR i = oldAddress TO address - 1
			report$ = report$ + HEX$(UBYTEAT(i),2) + " "
		NEXT i
		report$ = report$ + "\r\n"
		INC char
	LOOP
	RETURN
	
SUB Common
	report$ = report$ + RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6)
	IF cp&& = #SUB_UTF THEN
		report$ = report$ + " < "
	ELSE
		report$ = report$ + "   "
	ENDIF
END SUB

END FUNCTION


FUNCTION UncShowUTF8Glyphs( UBYTE u8[], startChar, endChar, report%%[])
'Display detailed content of u8[] with Glyphs

	IFZ u8[] THEN UncMakeUTF16(@report%%[],"UTF8 array is empty"): RETURN $$TRUE
	UncMakeUTF16(@report%%[]," Show UTF8 with Glyphs:\r\n\r\n CharNum  Offset    Codepoint  Glyph  UTF8 Encoding\r\n\r\n")

	maxChar = UncNumCharacters (@u8[])
	FitToRange(@startChar, @endChar, maxChar)


	base = &u8[]
	address = base + UncGetCharacterOffsetUTF8 (@u8[], startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF8 (@address)
		GOSUB Common
		'Display the actual utf8 bytes
		FOR i = oldAddress TO address - 1
			line$ = line$ + HEX$(UBYTEAT(i),2) + " "
		NEXT i
		UncMakeUTF16(@report%%[],line$ + "\r\n")
		INC char
	LOOP
	RETURN
	
SUB Common
	'character,offset,codepoint
	line$ = RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6)
	IF cp&& = #SUB_UTF THEN
		line$ = line$ + " < "
	ELSE
		line$ = line$ + "   "
	ENDIF
	'glyph
	IF ((cp&& < 32) || ((cp&& > 128) && (cp&& < 160))) THEN
		glyph&& = '.'
	ELSE
		glyph&& = cp&&
	ENDIF

	line$ = line$ + "  ," + HEXX$(glyph&&) + ",    "		
END SUB

END FUNCTION


FUNCTION UncShowUTF16 (USHORT u16[], startChar, endChar, @report$)
'Display detailed content of u16[]

	IFZ u16[] THEN	report$ = "UTF16 array is empty": RETURN $$TRUE	
	
	report$ = " Show UTF16:\r\n\r\n CharNum  Offset    Codepoint  UTF16 Encoding\r\n\r\n"	
	
	maxChar = UncNumCharacters (@u16[])
	FitToRange(@startChar, @endChar, maxChar)

	base = &u16[]
	address = base + UncGetCharacterOffsetUTF16 (@u16[], startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF16 (@address)
		GOSUB Report
		'Display the actual utf16 word(s)
		IF cp&& < 65536 THEN
			'Single value
			report$ = report$ + HEX$(cp&&,4) + "\r\n"
		ELSE
			'Surrogate pair
			report$ = report$ + HEX$(USHORTAT(oldAddress),4) + "  " + HEX$(USHORTAT(oldAddress + 2),4) + "\r\n"
		ENDIF
		INC char
	LOOP
	RETURN
	
SUB Report
	report$ = report$ + RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6)
	IF cp&& = #SUB_UTF THEN
		report$ = report$ + " < "
	ELSE
		report$ = report$ + "   "
	ENDIF
END SUB

END FUNCTION


FUNCTION UncShowUTF16Glyphs (USHORT u16[], startChar, endChar, @report%%[])
'Display detailed content of u16[] with Glyphs

	IFZ u16[] THEN	report$ = "UTF16 array is empty": RETURN $$TRUE	
	
	UncMakeUTF16(@report%%[]," Show UTF16 with Glyphs:\r\n\r\n CharNum  Offset    Codepoint  Glyph  UTF16 Encoding\r\n\r\n")	
	
	maxChar = UncNumCharacters (@u16[])
	FitToRange(@startChar, @endChar, maxChar)

	base = &u16[]
	address = base + UncGetCharacterOffsetUTF16 (@u16[], startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF16 (@address)
		GOSUB Report
		'Display the actual utf16 encoding
		IF cp&& < 65536 THEN
			'Single value
			line$ = line$ + HEX$(cp&&,4) + "\r\n"
		ELSE
			'Surrogate pair
			line$ = line$ + HEX$(USHORTAT(oldAddress),4) + "  " + HEX$(USHORTAT(oldAddress + 2),4) + "\r\n"
		ENDIF
		UncMakeUTF16(@report%%[],line$)
		INC char
	LOOP
	RETURN
	
SUB Report
	'character, offset,codepoint
	line$ = RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6) 
	IF cp&& = #SUB_UTF THEN
		line$ = line$ + " < "
	ELSE
		line$ = line$ + "   "
	ENDIF
	'glyph
	IF ((cp&& < 32) || ((cp&& > 128) && (cp&& < 160))) THEN
		glyph&& = '.'
	ELSE
		glyph&& = cp&&
	ENDIF

	line$ = line$ + "  ," + HEXX$(glyph&&) + ",    "
END SUB

END FUNCTION


FUNCTION UncShowWS (wide$, startChar, endChar, @report$)
'Display detailed content of wide$

	IFZ wide$ THEN report$ = "WideString is empty": RETURN $$TRUE
	report$ = " Show WideString:\r\n\r\n CharNum  Offset    Codepoint  UTF16 WS Encoding\r\n\r\n"	
	
	maxChar = UncNumCharactersWS (@wide$)
	FitToRange(@startChar, @endChar, maxChar)

	base = &wide$
	address = base + UncGetCharacterOffsetWS (@wide$, startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF16 (@address)
		GOSUB Report
		'Display the actual utf16 word(s)
		IF cp&& < 65536 THEN
			'Single value
			report$ = report$ + HEX$(cp&&,4) + "\r\n"
		ELSE
			'Surrogate pair
			report$ = report$ + HEX$(USHORTAT(oldAddress),4) + "  " + HEX$(USHORTAT(oldAddress + 2),4) + "\r\n"
		ENDIF
		INC char
	LOOP
	RETURN
	
SUB Report
	report$ = report$ + RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6)
	IF cp&& = #SUB_UTF THEN
		report$ = report$ + " < "
	ELSE
		report$ = report$ + "   "
	ENDIF
END SUB

END FUNCTION


FUNCTION UncShowWSGlyphs (wide$, startChar, endChar, @report%%[])
'Display detailed content of wide$ with Glyphs

	IFZ wide$ THEN UncMakeUTF16(@report%%[],"WideString is empty"): RETURN $$TRUE
	UncMakeUTF16(@report%%[]," Show WideString with Glyphs:\r\n\r\n CharNum  Offset    Codepoint  Glyph  UTF16 WS Encoding\r\n\r\n")	
	
	maxChar = UncNumCharactersWS (@wide$)
	FitToRange(@startChar, @endChar, maxChar)

	base = &wide$
	address = base + UncGetCharacterOffsetWS (@wide$, startChar)
	char = startChar
	
	DO WHILE char <= endChar
		oldAddress = address
		cp&& = UncGetCodepointFromUTF16 (@address)
		GOSUB Report
		'Display the actual utf16 encoding
		IF cp&& < 65536 THEN
			'Single value
			line$ = line$ + HEX$(cp&&,4) + "\r\n"
		ELSE
			'Surrogate pair
			line$ = line$ + HEX$(USHORTAT(oldAddress),4) + "  " + HEX$(USHORTAT(oldAddress + 2),4) + "\r\n"
		ENDIF
		UncMakeUTF16(@report%%[],line$)
		INC char
	LOOP
	RETURN
	
SUB Report
	'character,offset,codepoint
	line$ =  RJUST$(STRING(char),8) + "  " + HEX$(oldAddress - base,8) + "  U+" + HEX$(cp&&,6)
	IF cp&& = #SUB_UTF THEN
		line$ = line$ + " < "
	ELSE
		line$ = line$ + "   "
	ENDIF
	'glyph
	IF ((cp&& < 32) || ((cp&& > 128) && (cp&& < 160))) THEN
		glyph&& = '.'
	ELSE
		glyph&& = cp&&
	ENDIF
	line$ = line$ + "  ," + HEXX$(glyph&&) + ",    "
END SUB

END FUNCTION


FUNCTION UncShowUTF32 (ULONG u32[], startChar, endChar, @report$)
'Display detailed content of u32[]

	IFZ u32[] THEN report$ = "UTF32 array is empty": RETURN $$TRUE
	
	upper = UBOUND(u32[])
	FitToRange(@startChar, @endChar, upper + 1)
	
	index  = startChar - 1
	last = endChar - 1
	
	report$ = " ShowUTF32:\r\n\r\n CharNum  Offset    Codepoint  UTF32 Encoding\r\n\r\n"
	DO WHILE index <= last
		codepoint&& = u32[index]		
		report$ = report$ + RJUST$(STRING(index + 1),8) + "  " + HEX$(index <<< 2,8) + "  U+" + HEX$(codepoint&&,6)
		IF codepoint&& = #SUB_UTF THEN
			report$ = report$ + " < "
		ELSE
			report$ = report$ + "   "
		ENDIF
		report$ = report$ + + HEX$(codepoint&&,8) + "\r\n"		
		INC index
	LOOP
	
END FUNCTION


FUNCTION UncShowUTF32Glyphs (ULONG u32[], startChar, endChar, @report%%[])
'Display detailed content of u32[]

	IFZ u32[] THEN UncMakeUTF16(@report%%[],"UTF32 array is empty"): RETURN $$TRUE
	
	upper = UBOUND(u32[])
	FitToRange(@startChar, @endChar, upper + 1)
	
	index  = startChar - 1
	last = endChar - 1
	
	UncMakeUTF16(@report%%[]," ShowUTF32 with Glyphs:\r\n\r\n CharNum  Offset    Codepoint  Glyph  UTF32 Encoding \r\n\r\n")
	DO WHILE index <= last
		codepoint&& = u32[index]
		'character,offset,codepoint		
		line$ = RJUST$(STRING(index + 1),8) + "  " + HEX$(index <<< 2,8) + "  U+" + HEX$(codepoint&&,6)
		IF codepoint&& = #SUB_UTF THEN
			line$ = line$ + " < "
		ELSE
			line$ = line$ + "   "
		ENDIF
		'glyph,encoding 
		'replace C0 and C1 control codes
		IF ((codepoint&& < 32) || ((codepoint&& > 128) && (codepoint&& < 160))) THEN
			glyph&& = '.'
		ELSE
			glyph&& = codepoint&&
		ENDIF
		UncMakeUTF16(@report%%[],line$ + "  ," + HEXX$(glyph&&) +",    " + HEX$(codepoint&&,8) + "," + "\r\n")
		INC index
	LOOP
	
END FUNCTION


FUNCTION UncShowCodepoints(u[], startChar, endChar, @report$)
'Front end to DisplayCodepointRange() internal function for u8[], u16[] or u32[]
	
	IFZ u[] THEN report$ = " ShowCodePoints:\r\n\r\n  Array is empty": RETURN $$TRUE
	
	type = TYPE(u[])
	
	SELECT CASE type
		CASE $$UBYTE
			ATTACH u[] TO utf8@@[]
			UncConvertUTF8ToUTF32 (@utf8@@[], @temp&&[])
			ATTACH utf8@@[] TO u[]
			DisplayCodepointRange(@temp&&[], startChar, endChar, @report$)
			
		CASE $$USHORT
			ATTACH u[] TO utf16%%[]
			UncConvertUTF16ToUTF32 (@utf16%%[], @temp&&[])
			ATTACH utf16%%[] TO u[]
			DisplayCodepointRange(@temp&&[], startChar, endChar, @report$)
			
		CASE $$ULONG
			'No conversion needed
			DisplayCodepointRange(@u[], startChar, endChar, @report$)
			
		CASE ELSE
			report$ = "Not a UTF8, UTF16 or UTF32 array"
			RETURN $$TRUE
		
	END SELECT
	
END FUNCTION


FUNCTION UncShowCodepointsWS(wide$, startChar, endChar, @report$)
	IFZ wide$ THEN
		report$ = " ShowCodePoints:\r\n\r\n  WideString is Empty"
		RETURN $$TRUE
	ENDIF
	IF UncConvertWSToUTF32 (wide$, @temp&&[]) THEN
		report$ = " ShowCodePoints:\r\n\r\n  WideString is Mal-formed"
		RETURN $$TRUE
	ENDIF
	RETURN DisplayCodepointRange(@temp&&[], startChar, endChar, @report$) 
END FUNCTION



FUNCTION UncShowBlocksUsed(u[], plane, @report$)
'For the input plane, analyse blocks used and display X against each used block
'Planes contain 65536 characters
'Mapped as 4096 * 16 character blocks
'Format is in line with RoadMaps at www.unicode.org/roadmaps
	
	'Domain constrain plane and determine the codepoint range
	IF plane < 0 THEN plane = 0
	IF plane > 16 THEN plane = 16
	planeStart&& = 65536 * plane
	planeEnd&&  = planeStart&& + 65535
	planeHigh&& = plane * 256		'The 2 to 4 hexits to display on the left hand side
	
	'Convert to UTF32 if required
	type = TYPE(u[])	
	SELECT CASE type
		CASE $$UBYTE
			ATTACH u[] TO utf8@@[]
			UncConvertUTF8ToUTF32 (@utf8@@[], @u32&&[])
			ATTACH utf8@@[] TO u[]
			GOSUB ShowMap
		
		CASE $$USHORT
			ATTACH u[] TO utf16%%[]
			UncConvertUTF16ToUTF32 (@utf16%%[], @u32&&[])
			ATTACH utf16%%[] TO u[]
			GOSUB ShowMap
			
		CASE $$ULONG
			'No conversion needed
			ATTACH u[] TO u32&&[]
			GOSUB ShowMap
			ATTACH u32&&[] TO u[]
			
		CASE ELSE report$ = "Not a UTF8, UTF16 or UTF32 array": RETURN $$TRUE
	END SELECT

SUB ShowMap
	DIM block[4095]
'Analyse the distribution of characters within the 4096 blocks		
	FOR i = 0 TO UBOUND(u32&&[])
		cp&& = u32&&[i]
		IF (cp&& >= planeStart&&) && (cp&& <= planeEnd&&) THEN INC block[(cp&& - planeStart&&) >> 4]
	NEXT i

'Display the results		
	report$ = " Character distribution map for plane " + STRING(plane) + ":\r\n"
	ruler$ = "\r\n\r\n         0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F"
	
	FOR i = 0 TO 255
		IF i MOD 16 = 0 THEN report$ = report$ + ruler$
		report$ = report$ + "\r\n" + "  " + HEX$(planeHigh&&  + i, 4) + "  "
		high = i << 4
		FOR j = high TO high + 15
			IF block[j] THEN
				ex$ = " X "
			ELSE
				ex$ = " . "
			ENDIF
			report$ = report$ + ex$
		NEXT j
	NEXT i
END SUB

END FUNCTION


FUNCTION UncShowBlocksUsedWS(wide$, plane, @report$)
	IFZ wide$ THEN
		report$ = " WideString is Empty"
		RETURN $$TRUE
	ENDIF
	IF UncConvertWSToUTF32 (wide$, @temp&&[]) THEN
		report$ = " WideString is Mal-formed"
		RETURN $$TRUE
	ENDIF
	RETURN UncShowBlocksUsed (@temp&&[], plane, @report$)
END FUNCTION



FUNCTION UncShowPlanesUsedWS(wide$, @report$)
'Front end to PlanesUsed() internal function for WS
	IFZ wide$ THEN
		report$ = " WideString is Empty"
		RETURN $$TRUE
	ENDIF
	IF UncConvertWSToUTF32 (wide$, @temp&&[]) THEN
		report$ = " WideString is Mal-formed"
		RETURN $$TRUE
	ENDIF
	PlanesUsed (@temp&&[], @report$)
END FUNCTION



FUNCTION UncShowPlanesUsed(u[], @report$)
'Front end to PlanesUsed() internal function for u8[], u16[] or u32[]

	IFZ u[] THEN
		report$ = " Array is Empty"
		RETURN $$TRUE
	ENDIF
	type = TYPE(u[])
	
	SELECT CASE type
		CASE $$UBYTE
			ATTACH u[] TO utf8@@[]
			UncConvertUTF8ToUTF32 (@utf8@@[], @temp&&[])
			ATTACH utf8@@[] TO u[]
			PlanesUsed(@temp&&[], @report$)
			
		CASE $$USHORT
			ATTACH u[] TO utf16%%[]
			UncConvertUTF16ToUTF32 (@utf16%%[], @temp&&[])
			ATTACH utf16%%[] TO u[]
			PlanesUsed(@temp&&[], @report$)
			
		CASE $$ULONG
			'No conversion needed
			PlanesUsed(@u[], @report$)
			
		CASE ELSE
			report$ = " Not a UTF8, UTF16 or UTF32 array"
			RETURN $$TRUE
		
	END SELECT
	
END FUNCTION



FUNCTION PlanesUsed(ULONG u32[], @report$)
'For each populated plane, display number of characters in that plane

	report$ = "Planes Used:\r\n\r\n Plane  Num Chars\r\n\r\n"
	DIM plane[16]
	
	upper = UBOUND(u32[])
	FOR i = 0 TO upper
		INC plane[u32[i] \ 65536]
	NEXT i
		
	FOR i = 0 TO 16
		IF plane[i] THEN	report$ = report$ + "  " + RJUST$(STRING(i),2) + "   " + RJUST$(STRING(plane[i]),10) + "\r\n"
	NEXT i
	
END FUNCTION

'******************************************************************************************************************
'GENERAL **********************************************************************************************************
'******************************************************************************************************************

FUNCTION UncLength(u[])
'Returns the length in bytes for UTF8
'Returns the length in words for UTF16
'Returns the length in dwords for UTF32

	IFZ u[] THEN RETURN 0
	SELECT CASE TYPE(u[])
		CASE $$UBYTE, $$USHORT, $$ULONG
			RETURN UBOUND(u[]) + 1
		CASE ELSE
			RETURN $$TRUE
	END SELECT
	
END FUNCTION


FUNCTION UncLengthWS(wide$)
'Returns the length in words for UTF16 WideString
	RETURN (LEN(wide$) >>> 1)	
END FUNCTION


FUNCTION UncLengthAsUTF8(codepoint&&)
'Return length of UTF8 sequence for codepoint&& (can be 0 if codepoint&& not valid)
	SELECT CASE TRUE
		CASE codepoint&& < 0x80			: RETURN 1
		CASE codepoint&& < 0x800 		: RETURN 2
		CASE codepoint&& < 0x10000	: RETURN 3
		CASE codepoint&& <= $$MAX_CODEPOINT : RETURN 4
	END SELECT
	'Error
	RETURN 0
END FUNCTION


FUNCTION UncNumCharacters(u[])
'Returns the actual number of unicode characters including any terminating nulls
'The UTF8, UTF16 or UTF32 array must be 'Well-Formed"

	IFZ u[] THEN RETURN 0
	type = TYPE(u[])
	upper = UBOUND(u[])
	
	SELECT CASE type
		CASE $$UBYTE
			len = upper + 1			
			address = &u[]
			cChars = 0
		
ASM mov ebx, ADDR utf8ByteSignificance									;for use with xlatb
ASM mov esi, d[UncNumCharacters.address]
ASM mov ecx, d[UncNumCharacters.len]
ASM countLoop:
ASM		dec ecx
ASM 	js > countDone
ASM 	mov al, b[esi + ecx]
ASM 	xlatb										;read significance code for this byte value 
ASM 	cmp al, '1'							;check for 1,2,3,4 indicating start of sequence for a character
ASM		jl < countLoop
ASM		cmp al, '4'
ASM		jg < countLoop
ASM 	inc d[UncNumCharacters.cChars]
ASM		jmp < countLoop
ASM countDone:
			RETURN cChars

		CASE $$USHORT
			readP = 0
			cChars = upper + 1
			address = &u[]
			'scan array and subtract 1 for each surrogate pair found
			DO WHILE readP <= upper
				val%% = USHORTAT(address,[readP])		'This DMA is needed! u[readP] would generate XLONG code
				INC readP
				IF val%% < $$HIGH_FIRST	 THEN	DO DO
				IF val%% > $$HIGH_LAST THEN DO DO
				'first of a surrogate pair
				DEC cChars		'1 less actual character
				INC readP				'skip the second surrogate
			LOOP 
			RETURN cChars
				
		CASE $$ULONG
				RETURN upper + 1
				
		CASE ELSE 
				RETURN $$TRUE
	END SELECT
END FUNCTION


FUNCTION UncNumCharactersWS(wide$)
'Returns actual number of characters including trailing nulls

	IFZ wide$ THEN RETURN	0							'empty = 0 characters
	nBytes = LEN(wide$)
	IF nBytes < 2 THEN RETURN					'1 byte no good - return 0
	IF (nBytes AND 1) THEN RETURN			'must be even
	nWords = nBytes >>> 1
	
	readP = 0
	cChars = nWords									'assume 1 character per word to start
	address = &wide$
	'scan string and subtract 1 for each surrogate pair found
	DO WHILE readP <= nWords - 1
		val%% = USHORTAT(address,[readP])		'This DMA is needed! u[readP] would generate XLONG code
		INC readP
		IF val%% < $$HIGH_FIRST	 THEN	DO DO
		IF val%% > $$HIGH_LAST THEN DO DO
		'first of a surrogate pair
		DEC cChars			'1 less actual character
		INC readP				'skip the second surrogate
	LOOP 
	RETURN cChars
END FUNCTION


FUNCTION UncNumNulls(u[])
'Returns the number of trailing nulls
'The UTF8, UTF16 or UTF32 array must be 'Well-Formed"

	IFZ u[] THEN RETURN 0
	type = TYPE(u[])
	readP = UBOUND(u[])
	address = &u[]

	cNulls = 0	
	SELECT CASE type
		CASE $$UBYTE
			DO WHILE (readP >= 0) && UBYTEAT(address, [readP]) = 0
				INC cNulls: DEC readP
			LOOP

		CASE $$USHORT
			DO WHILE (readP >= 0) && USHORTAT(address, [readP]) = 0
				INC cNulls: DEC readP
			LOOP
			
		CASE $$ULONG
			DO WHILE (readP >= 0) && ULONGAT(address, [readP]) = 0
				INC cNulls: DEC readP
			LOOP				
			
		CASE ELSE 
			'Will return 0
	END SELECT
	RETURN cNulls
END FUNCTION


FUNCTION UncNumNullsWS(wide$)
'Returns number of trailing nulls

	IFZ wide$ THEN RETURN	0							'empty = 0 characters
	nBytes = LEN(wide$)
	IF nBytes < 2 THEN RETURN					'1 byte no good - return 0
	IF (nBytes AND 1) THEN RETURN			'must be even
	nWords = nBytes >>> 1
	
	readP = nWords - 1
	cNulls = 0									
	address = &wide$
	'scan string from back counting nulls
	DO WHILE (readP >= 0) && USHORTAT(address,[readP]) = 0
		INC cNulls
		DEC readP
	LOOP 
	RETURN cNulls
END FUNCTION


'****************************************************************************************************************
' SETTINGS ******************************************************************************************************
'****************************************************************************************************************

FUNCTION UncSetAsciiSubstitutionChar(asciiCode)
'set character to use as a substitute in Xblite strings where actual codepoint is out of range 0 - 255
'asciiCode can be -ve to reset default to the default
'constrained to ascii so that substitute is 1 valid byte in UTF8
	IF asciiCode < 0 THEN
		#SUB_ASCII = $$DEFAULT_SUB_ASCII	
	ELSE
		'Restrict size to Ascii range
		IF asciiCode > 0x7F THEN asciiCode = 0x7F
		#SUB_ASCII = asciiCode
	ENDIF
END FUNCTION


FUNCTION UncSetUnicodeSubstitutionChar(codepoint)
'set character to use as a substitute in Unicode strings where actual codepoint is out of range 0 - 0x10FFFF
'codepoint is XLONG here to allow -1 to be input for the default
	IF codepoint < 0 THEN
		#SUB_UTF = $$DEFAULT_SUB_UTF
	ELSE
		'Restrict size so that always fits in a single UTF16 code unit - never needs a surrogate pair
		IF codepoint > 0xFFFF THEN codepoint = 0xFFFF
		#SUB_UTF = codepoint
	ENDIF
END FUNCTION


FUNCTION UncSetAutoNull(bTrueFalse)
'Turn AutoNull On / Off
'Only adds Null to UTF16 or WideString generated by UncMake... or UncChars...
	IF bTrueFalse THEN
		#AUTONULL = $$TRUE
	ELSE
		#AUTONULL = $$FALSE
	ENDIF
END FUNCTION


FUNCTION UncSetMakeSeparator(asciiCode)
'Set the separator used when parsing input strings to UncMake... functions
	IF asciiCode < 0 THEN #SEPARATOR$ = ",": RETURN							'Restore default
	sep$ = CHR$(asciiCode)
	IFZ INCHR("!$%^*:;@~#|,/", sep$) THEN RETURN $$TRUE				'Allow specifed characters only
	#SEPARATOR$ = sep$																					'Set new 
END FUNCTION


FUNCTION UncSetConcatNullMode(mode$)
'Leave or Remove nulls on first array , WideString when concatenating
	SELECT CASE mode$
		CASE "KEEP" #CONCAT_MODE = $$FALSE
		CASE "REMOVE" #CONCAT_MODE = $$TRUE		'Default remove nulls from first of concatenated paior
	END SELECT
END FUNCTION


FUNCTION UncSetSubstringNullMode(mode$)
'INCLUDE = treat nulls as characters and include in substrings
'IGNORE  = exclude trailing nulls from substrings
	SELECT CASE mode$
		CASE "INCLUDE" #SUBSTRING_NULLS = $$TRUE
		CASE "IGNORE"  #SUBSTRING_NULLS = $$FALSE		'Default remove nulls from first of concatenated paior
	END SELECT
END FUNCTION

	
'********************************************************************************************************************
'SWAP ENDIAN ********************************************************************************************************
'********************************************************************************************************************

FUNCTION UncSwapEndianUTF16(USHORT u[])
'Swap bytes in each USHORT within the array 
	IFZ u[] THEN RETURN $$TRUE
	
	address = &u[]
ASM	push ecx, esi												
ASM mov esi, d[UncSwapEndianUTF16.address]	;base of array
ASM	mov ecx, d[esi - 8]											;numElements
ASM jecxz > done16													;just in case empty array	
ASM sub esi, 2															;adjust for zero base	from 1 base

ASM next16:
ASM		ror w[esi + ecx * 2], 8							
ASM 	dec ecx
ASM   jnz < next16
ASM done16:
ASM pop esi, ecx

END FUNCTION


FUNCTION UncSwapEndianWS(wide$)
'Swap bytes in each USHORT within the string array 
	IFZ wide$ THEN RETURN $$TRUE
	
	address = &wide$
ASM	push ecx, esi												
ASM mov esi, d[UncSwapEndianUTF16.address]	;base of array
ASM	mov ecx, d[esi - 8]											;numElements - bytes because this is a string array
ASM shr ecx, 1															;number of words
ASM jecxz > doneWS													;just in case empty array	
ASM sub esi, 2															;adjust for zero base	from 1 base

ASM nextWS:
ASM		ror w[esi + ecx * 2], 8							
ASM 	dec ecx
ASM   jnz < nextWS
ASM doneWS:
ASM pop esi, ecx

END FUNCTION


FUNCTION UncSwapEndianUTF32(ULONG u32[])
'Swap bytes in each ULONG within the array 
	IFZ u32[] THEN RETURN $$TRUE
	
	address = &u32[]
ASM	push ecx, esi												
ASM mov esi, d[UncSwapEndianUTF32.address]	;base of array
ASM	mov ecx, d[esi - 8]											;numElements
ASM jecxz > done32													;just in case empty array	
ASM sub esi, 4															;adjust for zero base	from 1 base

ASM next32:
ASM		mov eax, d[esi + ecx * 4]
ASM		bswap eax
ASM		mov d[esi + ecx * 4], eax							
ASM 	dec ecx
ASM   jnz < next32
ASM done32:
ASM pop esi, ecx
	RETURN 0
END FUNCTION


'*************************************************************************************************************
'TERMINATING NULLS *******************************************************************************************
'*************************************************************************************************************

FUNCTION UncTrailingNulls(u[], action$, cNulls)
'Add or Remove trailing nulls to or from a UTFxx array

	IF cNulls < 0 THEN RETURN $$TRUE
	IFZ u[]  THEN RETURN $$TRUE
	
	cNullsPresent = UncNumNulls(@u[])			'count existing nulls (can be 0)

	upper = UBOUND(u[])
	
	SELECT CASE UCASE$(action$)
		CASE "ADD"
			IFZ cNulls THEN RETURN $$TRUE
			newUpper = upper + cNulls		
		CASE "REMOVE"
			IFZ upper THEN RETURN $$TRUE
			IFZ cNulls THEN RETURN $$TRUE
			newUpper = upper - MIN(cNullsPresent, cNulls)
		CASE "LEAVE"
			newUpper = upper - cNullsPresent + cNulls							
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	REDIM u[newUpper]
	
END FUNCTION


FUNCTION UncTrailingNullsWS(wide$, action$, cNulls)
'Add or Remove trailing nulls to or from a WideString

	IF cNulls < 0 THEN RETURN $$TRUE
	
	cNullsPresent = UncNumNullsWS(wide$)			'count existing nulls (can be 0)
	
	SELECT CASE UCASE$(action$)
		CASE "ADD"
			IFZ cNulls THEN RETURN $$TRUE
			wide$ = wide$ + NULL$(cNulls <<< 1)	
		CASE "REMOVE"
			IFZ cNulls THEN RETURN $$TRUE
			chop = (MIN(cNullsPresent, cNulls) <<< 1)
			wide$ = RCLIP$(wide$, chop)
		CASE "LEAVE"
			
			IF cNullsPresent = cNulls THEN RETURN
			
			IFZ cNullsPresent THEN
				'Add required number of nulls
				wide$ = wide$ + NULL$(cNulls <<< 1)
			ELSE
				IF cNulls > cNullsPresent THEN
					'Add extra nulls
					wide$ = wide$ + NULL$((cNulls - cNullsPresent) <<< 1)	
				ELSE
					'Remove excess nulls					
					chop =  (cNullsPresent - cNulls) <<< 1
					wide$ = RCLIP$(wide$, chop)
				ENDIF
			ENDIF
			
		CASE ELSE RETURN $$TRUE
	END SELECT
	
END FUNCTION

'******************************************************************************************************************************************
'CONVERSIONS ******************************************************************************************************************************
'******************************************************************************************************************************************

'ANSI to >>>>
FUNCTION UncConvertAnsiToUTF8(ansi$, UBYTE u8[])
	IFZ ansi$ THEN DIM u8[]: RETURN			'empty string 
	
	len = LEN(ansi$)
	DIM u8[len <<< 1]		'worst case is 2 output bytes per input
	address = &u8[]

	FOR i = 0 TO len - 1
		UncEmitCodepointAsUTF8 (ansi${i}, @address)
	NEXT i
	
	outLen = (address - &u8[]) - 1
	REDIM u8[outLen]

END FUNCTION


FUNCTION UncConvertAnsiToUTF16(ansi$, USHORT u16[])
	IFZ ansi$ THEN 
		IF #AUTONULL THEN 
			DIM u16[0]
		ELSE
			DIM u16[]
		ENDIF
		RETURN
	ENDIF			
	
	len = LEN(ansi$) - 1
	outLen = len
	IF #AUTONULL THEN INC outLen
	DIM u16[outLen]
	
	FOR i = 0 TO len
		u16[i] = ansi${i}
	NEXT i
	
END FUNCTION


FUNCTION UncConvertAnsiToWS(ansi$, wide$)
	IFZ ansi$ THEN
		IF #AUTONULL THEN
			wide$ = "\0\0"
		ELSE
			wide$ = ""
		ENDIF
		RETURN
	ENDIF
	
	len = LEN(ansi$)
	outLen = len <<< 1
	IF #AUTONULL THEN outLen = outLen + 2
	wide$ = NULL$(outLen)
	address = &wide$
	
	FOR i = 0 TO len - 1
		USHORTAT(address,[i]) = ansi${i}
	NEXT i
	
END FUNCTION


FUNCTION UncConvertAnsiToUTF32(ansi$, ULONG u32[])
	IFZ ansi$ THEN DIM u32[]: RETURN
	
	len = LEN(ansi$) - 1
	DIM u32[len]
	
	FOR i = 0 TO len
		u32[i] = ansi${i}
	NEXT i
	
END FUNCTION


'UTF8  to >>>>
FUNCTION UncConvertUTF8ToAnsi(UBYTE u8[], ansi$)
'Convert UTF8 to Xblite string without regard to code pages
'UTF8 array must be well-formed

	IFZ u8[] THEN RETURN $$TRUE
	upper = UBOUND(u8[])
	
	ansi$ = NULL$(upper + 1)				'worst case is 1 byte out for each byte in	
	address = &u8[]									'start of byte sequence to decode
	last    = address + upper				'last byte in array

	i = 0
	DO WHILE address <= last 
		cp&& = UncGetCodepointFromUTF8(@address)
		IF cp&& < 256 THEN
			ansi${i} = cp&&
		ELSE
			ansi${i} = #SUB_ASCII
		ENDIF
		INC i
	LOOP
	
	ansi$ = LEFT$(ansi$,i)

END FUNCTION


FUNCTION UncConvertUTF8ToUTF16(UBYTE u8[], USHORT u16[])
'Convert UTF8 to UTF16 array
'UTF8 array must be well-formed

	IFZ u8[] THEN RETURN $$TRUE
	upper = UBOUND(u8[])
	
	DIM u16[upper]									'worst case is 1 word out for each byte in	
	address = &u8[]									'start of byte sequence to decode
	last    = address + upper				'last byte in array
	addressU16 = &u16[]
	
	DO WHILE address <= last 
		cp&& = UncGetCodepointFromUTF8(@address)
		IF cp&& < 65536 THEN
			USHORTAT(addressU16) = cp&&
			addressU16 = addressU16 + 2
		ELSE
			UncEmitCodepointAsUTF16 (cp&&, @addressU16)
		ENDIF
	LOOP
	
	cValues = (addressU16 - &u16[]) >>> 1
	REDIM u16[cValues - 1]
	
END FUNCTION


FUNCTION UncConvertUTF8ToWS(UBYTE u8[], wide$)
'Convert UTF8 to UTF16 WideString
'UTF8 array must be well-formed

	IFZ u8[] THEN RETURN $$TRUE
	upper = UBOUND(u8[])
	
	wide$ = NULL$((upper + 1) <<< 1)		'worst case is 2 bytes out for each byte in	
	address = &u8[]											'start of byte sequence to decode
	addressWS = &wide$
	last    = address + upper						'last byte in array

	DO WHILE address <= last 
		cp&& = UncGetCodepointFromUTF8(@address)
		IF cp&& < 65536 THEN
			USHORTAT(addressWS) = cp&&
			addressWS = addressWS + 2
		ELSE
			UncEmitCodepointAsUTF16 (cp&&, @addressWS)
		ENDIF
	LOOP

	wide$ = LEFT$(wide$,(addressWS - &wide$))
	
END FUNCTION


FUNCTION UncConvertUTF8ToUTF32( UBYTE u8[], ULONG u32[])
'Convert UTF8 to UTF32 array
'UTF8 array must be well-formed

	IFZ u8[] THEN RETURN $$TRUE
	upper = UBOUND(u8[])
	
	DIM u32[upper]									'worst case is 1 character out for each byte in	
	address = &u8[]									'start of byte sequence to decode
	last    = address + upper				'last byte in array
	outIndex = 0										'index for u32[] output array
	
	DO WHILE address <= last 
		u32[outIndex] = UncGetCodepointFromUTF8(@address)
		INC outIndex
	LOOP

	REDIM u32[outIndex - 1]
	
END FUNCTION


'UTF16 to >>>>
FUNCTION UncConvertUTF16ToAnsi(USHORT u16[], ansi$)
'Convert UTF16 to Xblite string 
'If encounter unconvertible unicode character then output substitute ansi character instead
'UTF16 array must be well-formed

	IFZ u16[] THEN RETURN $$TRUE
	upper = UBOUND(u16[])
	
	address = &u16[]
	last = address + (upper <<< 1)
	
	ansi$ = NULL$(upper + 1)				'worst case is 1 byte out for each word in
	i = 0
	
	DO WHILE address <= last
		cp&& = UncGetCodepointFromUTF16 (@address)
		IF cp&& < 256 THEN
			ansi${i} = cp&&
		ELSE
			ansi${i} = #SUB_ASCII
		ENDIF
		INC i
	LOOP

	ansi$ = LEFT$(ansi$,i)

END FUNCTION


FUNCTION UncConvertUTF16ToUTF8(USHORT u16[], UBYTE u8[])
'Convert UTF16 to UTF8 array
'UTF16 array must be well-formed

	IFZ u16[] THEN RETURN $$TRUE
	upper = UBOUND(u16[])
	
	address = &u16[]
	last = address + (upper <<< 1)
	
	DIM u8[(upper + 1) * 3]							'worst case is each word in produces 3 bytes out
	addressU8 = &u8[]
	
	DO WHILE address <= last
		cp&& = UncGetCodepointFromUTF16 (@address)
		UncEmitCodepointAsUTF8 (cp&&, @addressU8)
	LOOP
	
	cBytes = addressU8 - &u8[]
	REDIM u8[cBytes - 1]
	
END FUNCTION


FUNCTION UncConvertUTF16ToWS(USHORT u16[], wide$)
'Convert UTF16 array to UTF16 WideString
'This is a change of Xblite physical structure only

	IFZ u16[] THEN RETURN $$TRUE
	cBytes = (UBOUND(u16[]) + 1) <<< 1		
	
	wide$ = NULL$(cBytes)
	XstCopyMemory(&u16[], &wide$, cBytes)
	
END FUNCTION 


FUNCTION UncConvertUTF16ToUTF32(USHORT u16[], ULONG u32[])
'Convert UTF16 array to UTF32 array
'UTF16 array must be well-formed

	IFZ u16[] THEN RETURN $$TRUE
	upper = UBOUND(u16[])
	
	address = &u16[]
	last = address + (upper <<< 1)
	
	DIM u32[upper ]							'worst case is each word in produces 1 ULONG out
  i = 0
	
	DO WHILE address <= last
		u32[i] = UncGetCodepointFromUTF16 (@address): INC i
	LOOP
	
	REDIM u32[i - 1]
	
END FUNCTION


'WIDESTRING To >>>>  ********************************************************************************
FUNCTION UncConvertWSToAnsi(wide$, @ansi$)
'Convert UTF16 WideString to Xblite string
'If encounter unconvertible unicode character then output substitute ansi character instead
'WS must be well-formed

	IFZ wide$ THEN RETURN $$TRUE
	upper = (LEN(wide$) >>> 1)
	address = &wide$
	last = address + LEN(wide$) - 1
	
	ansi$ = NULL$(upper)								'worst case is each word in produces 1 byte out
	i = 0
	
	DO WHILE address <= last
		cp&& = UncGetCodepointFromUTF16 (@address)
		IF cp&& < 256 THEN
			ansi${i} = cp&&
		ELSE
			ansi${i} = #SUB_ASCII
		ENDIF
		INC i
	LOOP
	
	ansi$ = LEFT$(ansi$,i)
	
END FUNCTION


FUNCTION UncConvertWSToUTF8(wide$, UBYTE u8[])
'Convert UTF16 WideString to UTF8 array
'WS must be well-formed

	IFZ wide$ THEN RETURN $$TRUE
	upper = (LEN(wide$) >>> 1)
	address = &wide$
	last = address + LEN(wide$) - 1
	
	DIM u8[upper * 3]								'worst case is each word in produces 3 bytes out
	addressU8 = &u8[]
	
	DO WHILE address <= last
		cp&& = UncGetCodepointFromUTF16 (@address)
		UncEmitCodepointAsUTF8 (cp&&, @addressU8)
	LOOP
	
	cBytes = addressU8 - &u8[]
	REDIM u8[cBytes - 1]
	
END FUNCTION


FUNCTION UncConvertWSToUTF16(wide$, USHORT u16[])
'Convert UTF16 WideString to UTF16 array
'Just a simple copy

	IFZ wide$ THEN RETURN $$TRUE 	
	len = LEN(wide$)	
	IF ((len < 2) || (len AND 1))  THEN RETURN $$TRUE				'Must have at least 2 bytes and even number of bytes
	
	DIM u16[(len >>> 1) - 1]
	XstCopyMemory(&wide$, &u16[], len)
	
END FUNCTION 


FUNCTION  UncConvertWSToUTF32(wide$, ULONG u32[])
'Convert UTF16 WideString to UTF32 array
'WS must be well-formed

	IFZ wide$ THEN RETURN $$TRUE
	upper = (LEN(wide$) >>> 1)
	address = &wide$
	last = address + LEN(wide$) - 1
	
	DIM u32[upper - 1]								'worst case is each word in produces 1 ULONG out
	i = 0
	
	DO WHILE address <= last
		u32[i] = UncGetCodepointFromUTF16 (@address): INC i
	LOOP
	
	REDIM u32[i - 1]
	
END FUNCTION


'UTF32 to >>>>   ***************************************************************************************
FUNCTION UncConvertUTF32ToAnsi(ULONG u32[], @ansi$)
'Convert UTF32 array to Xblite string
'If encounter unconvertible unicode character then output substitute ansi character instead

	IFZ u32[] THEN ansi$ = "": RETURN
	
	upper = UBOUND(u32[])	
	ansi$ = NULL$(upper + 1)
	outP = 0
	
	FOR i = 0 TO upper 
		val&& = u32[i]
		IF val&& > 255 THEN
			ansi${outP} = #SUB_ASCII
		ELSE
			ansi${outP} = val&&
		ENDIF
		INC outP
	NEXT i		

END FUNCTION


FUNCTION UncConvertUTF32ToUTF8(ULONG u32[], UBYTE u8[])
'Convert UTF32 array to UTF8 array

	IFZ u32[] THEN RETURN $$TRUE 
	
	upper = UBOUND(u32[])	
	DIM u8[(upper + 1) <<< 2]		'Worst case is 4 bytes out per character	
	outIndex = &u8[]
	
	FOR i = 0 TO upper
		codepoint&& = u32[i]
		UncEmitCodepointAsUTF8 ( codepoint&& , @outIndex)
	NEXT i
	
	seqLen = (outIndex - &u8[]) - 1
	REDIM u8[seqLen]

END FUNCTION


FUNCTION UncConvertUTF32ToUTF16(ULONG u32[], USHORT u16[])
'Convert UTF32 array to UTF16 array

	IFZ u32[] THEN RETURN $$TRUE
	
	upper = UBOUND(u32[])
	DIM u16[(upper + 1) <<< 1]							'worst case is each input = 2 output
	
	address = &u16[]
	
	FOR i = 0 TO upper
		cp&& = u32[i]
		UncEmitCodepointAsUTF16 (cp&&, @address)
	NEXT i
	
	bytes = (address - &u16[])
	REDIM u16[(bytes >>> 1) - 1]		
	
END FUNCTION


FUNCTION UncConvertUTF32ToWS(ULONG u32[], wide$)
'Convert UTF32 array to UTF16 WideString

	IFZ u32[] THEN RETURN $$TRUE
	upper = UBOUND(u32[]) 
	
	wide$ = NULL$((upper + 1) <<< 2)
	address = &wide$
	startAddress = address

	FOR i = 0 TO upper
		cp&& = u32[i]
		UncEmitCodepointAsUTF16 (cp&&, @address)
	NEXT i
	
	size = (address - startAddress)			
	wide$ = LEFT$(wide$, size)		
END FUNCTION


'MAPPING FUNCTIONS*********************************************************************************************************************
'These may change the codepoint according to the required codePage

FUNCTION UncMapAnsiToUTF16(ansi$, codePage, USHORT u16[])
'Convert Xblite string to UTF16 array with relevant code page mapping

	IFZ ansi$ THEN RETURN $$TRUE
	
	IF codePage < 1 THEN
		codePage = GetACP()		'Use current active code page
	ELSE
		IFF IsValidCodePage(codePage) THEN RETURN $$TRUE
	ENDIF
	
	lpMultiByteString = &ansi$					'Pointer to source string
	cbMultiByte = LEN(ansi$)						'Number of source bytes

	'Output
	outLen = cbMultiByte <<< 1 					'Worst case is each input byte is 2 output words 							
	DIM u16[outLen]											'Output array
	lpWideCharStr = &u16[]							'Pointer to output array	

	'General
	dwFlags = 0													'Default and required for Vista
	
	outSize = MultiByteToWideChar(codePage, dwFlags, lpMultiByteString,  cbMultiByte, lpWideCharStr, outLen)
	'NOTE outSize is number of 16 bit words written not same as number of characters if surrogates are present
	
	'See if mapping failed
	IFZ outSize THEN RETURN $$TRUE
	
	REDIM u16[outSize - 1]						'Chop off unused buffer
	
END FUNCTION


FUNCTION UncMapUTF16ToAnsi(USHORT u16[], codePage, ansi$)
'Convert UTF16 array to Xblite string with relevant code page mapping

	IFZ u16[] THEN RETURN $$TRUE
	
	IF codePage < 1 THEN
		codePage = GetACP()		'Use current active code page
	ELSE
		IFF IsValidCodePage(codePage) THEN RETURN $$TRUE
	ENDIF
	
	lpWideCharStr = &u16[]						'Pointer to input array	
	cchWideChar = UBOUND(u16[]) + 1		'Number of source characters (actually words)
	sub$ = CHR$(#SUB_ASCII)
	flag = 0

	'Output
	ansi$ = NULL$(cchWideChar)				'Worst case is each input word becomes an ansi character
	lpMultiByteString = &ansi$				'Pointer to utput array

	'General
	dwFlags = 0												'Default and required for Vista
	
	outSize = WideCharToMultiByte(codePage, dwFlags, lpWideCharStr, cchWideChar, lpMultiByteString,  cchWideChar, &sub$, 0 )
	'NOTE outSize is number of bytes written 

	'See if mapping failed
	IFZ outSize THEN RETURN $$TRUE
	
	ansi$ = LEFT$(ansi$, outSize - 1)	'Chop off unused buffer and extra null added by Windows function
	
END FUNCTION

'***************************************************************************************************************************************
'LOW LEVEL FUNCTIONS********************************************************************************************************************
'Not all these functions fully validate their input.
'This is because some are primarily intended for internal use where the input is controlled and extra checks are omitted for speed
'***************************************************************************************************************************************

FUNCTION UncCodepointToSurrogatePair(codepoint&&, hiWord%%, loWord%%)
'UTF-16 Standard Encoding. Create surrogate pair from single codepoint
'Returns -1 if codepoint&& not in range. In this case, hiWord%% and loWord%% are left unchanged / undefined

	IF (codepoint&& < $$FIRST_PLANE1) || (codepoint&& > $$MAX_CODEPOINT) THEN RETURN $$TRUE		'Out of range for surrogate pair										
	
	'offset , extract Hi and Lo 10 bits from 20 bit value, bitwise OR with the fixed portions of hi / lo
	codepoint&& = codepoint&& - $$FIRST_PLANE1
	hiWord%% = $$HIGH_FIRST | EXTU(codepoint&&, 10, 10)
	loWord%% = $$LOW_FIRST  | EXTU(codepoint&&, 10, 0)

END FUNCTION


FUNCTION UncEmitCodepointAsUTF16(codepoint&&, address)
'UTF-16 Standard Encoding. 
'Write single USHORT or Surrogate Pair
'Update address ready for next write
'Return number of bytes written, 0 if codepoint&& is invalid

	IFF UncIsValidCodepoint (codepoint&&) THEN RETURN 0
	IF codepoint&& < 65536 THEN
		USHORTAT(address) = codepoint&&
		address = address + 2
		RETURN 2	
	ELSE
		codepoint&& = codepoint&& - $$FIRST_PLANE1	
		USHORTAT(address) = ($$HIGH_FIRST | EXTU(codepoint&&, 10, 10))
		USHORTAT(address + 2) = ($$LOW_FIRST  | EXTU(codepoint&&, 10, 0))
		address = address + 4
		RETURN 4
	ENDIF
END FUNCTION


FUNCTION ULONG UncSurrogatePairToCodepoint(hiWord%%, loWord%%)
'RETURN unicode codepoint for VALID surrogate pair - no checks made!!
'The constant 0xFCA02400 is derived as $$FIRST_PLANE1 - ($$HIGH_FIRST << 10) - $$LOW_FIRST 
	RETURN (ULONG(hiWord%%) << 10) + ULONG(loWord%%) + 0xFCA02400
END FUNCTION


FUNCTION UncEmitCodepointAsUTF8(codepoint&&, address)
'Convert codepoint to UTF8 sequence of 1 to 4 bytes and write these out starting at address
'Update address ready to write next sequence
'Return length of sequence written (can be 0 if codepoint&& not valid)
 
	SELECT CASE TRUE
		'ULONG so cannot be negative
		CASE codepoint&& < 0x80
			'Ascii character - 1 byte
			UBYTEAT(address) = codepoint&&:	INC address
			RETURN 1
		CASE codepoint&& < 0x800
			'2 bytes
			UBYTEAT(address) = 192 + (codepoint&& >> 6):						INC address
			UBYTEAT(address) = 128 + (codepoint&& AND 0b00111111):	INC address 
			RETURN 2
		CASE codepoint&& < 0x10000
			'3 bytes
			UBYTEAT(address) = 224 + (codepoint&& >> 12):									INC address
			UBYTEAT(address) = 128 + ((codepoint&& >> 6) AND 0b00111111):	INC address 
			UBYTEAT(address) = 128 + (codepoint&& AND 0b00111111):				INC address 
			RETURN 3  
		CASE codepoint&& <= $$MAX_CODEPOINT
			'4 bytes
			UBYTEAT(address) = 240 + (codepoint&& >> 18):										INC address
			UBYTEAT(address) = 128 + ((codepoint&& >> 12) AND 0b00111111):	INC address 
			UBYTEAT(address) = 128 + ((codepoint&& >> 6) AND 0b00111111):		INC address 
			UBYTEAT(address) = 128 + (codepoint&& AND 0b00111111):					INC address 
			RETURN 4 
		CASE $$TRUE
			'Invalid codepoint - ignore
			RETURN 0
	END SELECT
END FUNCTION


FUNCTION ULONG UncGetCodepointFromUTF8(address)
'Convert utf8 sequence of up to 4 bytes at address to its codepoint
'The sequence must start with a lead byte and then be followed by the requisite number of follow on bytes
'Return value is codepoint or #SUB_UTF if fails
'Address is updated by the length of the sequence ready for the next read

	IFZ address THEN RETURN 	
	byte1 = UBYTEAT(address): INC address
 
	SELECT CASE TRUE
		CASE byte1 < 128
			'1 byte encoding
			RETURN byte1

		CASE ((byte1 >= 192) && (byte1 <= 223))
			'2 bytes
			byte2 = UBYTEAT(address): INC address
			RETURN ((byte1 - 192) << 6) + byte2 - 128

		CASE ((byte1 >= 224) && (byte1 <= 239))
			'3 bytes
			byte2 = UBYTEAT(address): INC address
			byte3 = UBYTEAT(address): INC address
			RETURN ((byte1 - 224) << 12) + ((byte2 - 128) << 6) + byte3 - 128

		CASE ((byte1 >= 240) && (byte1 <= 244))
			'4 bytes
			byte2 = UBYTEAT(address): INC address
			byte3 = UBYTEAT(address): INC address
			byte4 = UBYTEAT(address): INC address
			codepoint&& = ((byte1 - 240) << 18) + ((byte2 -128) << 12) + ((byte3 - 128) << 6) + byte4 - 128
			IF codepoint&& <= $$MAX_CODEPOINT THEN
				RETURN codepoint&&
			ELSE
				'4 byte sequence can exceed maximum codepoint
				RETURN #SUB_UTF
			ENDIF
			
		CASE $$TRUE
			'Invalid or 5 , 6 byte encoding not unicode, or mal-formed sequence
			RETURN #SUB_UTF
			
	END SELECT
END FUNCTION


FUNCTION ULONG UncGetCodepointFromUTF16(address)
'address must point to a BMP character or the first of a surrogate pair
'returns codepoint or substitution character
'address is advanced by number of bytes read. 

	IFZ address THEN RETURN 
	word1%% = USHORTAT(address)
	
	IF (word1%% < $$HIGH_FIRST) || (word1%% > $$LOW_LAST) THEN
		'Normal single word value
		address = address + 2
		RETURN ULONG(word1%%)
	ELSE
		'Check for surrogate high word
		IF (word1%% >= $$HIGH_FIRST) && (word1%% <= $$HIGH_LAST) THEN
			word2%% = USHORTAT(address + 2)
			address = address + 4			
			RETURN (ULONG(word1%%) << 10) + ULONG(word2%%) + 0xFCA02400
		ENDIF
		'Surrogate low word or malformed
		address = address + 2
		RETURN #SUB_UTF
	ENDIF
END FUNCTION


FUNCTION UncIsValidCodepoint (codepoint&&)
'Return $$TRUE if codepoint&& is valid unicode character code, otherwise $$FALSE
'Non-characters and Private Use characters are valid
	IF codepoint&& > 0x10FFFF THEN RETURN $$FALSE																					'Exceeds maximum value
	IF (codepoint&& >= $$HIGH_FIRST) && (codepoint&& <= $$LOW_LAST) THEN RETURN $$FALSE		'Surrogates - not valid codepoints / characters in their own right
	RETURN $$TRUE		
END FUNCTION


FUNCTION UncIsNonCharacter (codepoint&&)
'Return $$TRUE if codepoint&& is a Non-character otherwise return $$FALSE
	IF (codepoint&& >= 0xFDD0) && (codepoint&& <= 0xFDEF) THEN RETURN $$TRUE				'Plane 0 Non-character block
	maskedVal = codepoint&& AND 0xFFFF
	IF (maskedVal = 0xFFFE) || (maskedVal = 0xFFFF) THEN RETURN $$TRUE							'Planes 0 to 16 Non-characters ( 2 per plane)	
END FUNCTION


FUNCTION UncIsPrivateUse (codepoint&&)
'Return $$TRUE if codepoint&& is Private Usage otherwise return $$FALSE
	'Check for PU range in plane 0
	IF (codepoint&& < 0xE000) THEN RETURN $$FALSE
	IF (codepoint&& <= 0xF8FF) THEN RETURN $$TRUE
	'Check for planes 15 and 16 which are PU in entirety - except for 2 Non-characters in each plane
	IF (codepoint&& >= 0xF0000) && (codepoint&& <= 0xFFFFD) THEN RETURN $$TRUE 
	IF (codepoint&& >= 0x100000) && (codepoint&& <= 0x10FFFD) THEN RETURN $$TRUE
END FUNCTION	


'***************************************************************************************************************************************
' INTERNAL FUNCTIONS NOT EXPORTED ******************************************************************************************************
'***************************************************************************************************************************************
FUNCTION StringToCodepoint(val$, codepoint&&)
'Convert standard Xblite integer numeric literal formats to a codepoint - "0x", "0o", "0b"
'Handle special "U+", "&name", "&#dddd" and "&#xhhhh" formats
'Returns $$TRUE with codepoint&& = 0 if val$ produces INVALID codepoint
'Will encode Non-characters

	first = val${0}
	'Handle specials	
	IF first = '&' THEN
		'HTML syntax
		IF val${1} = '#' THEN
			'HTML numeric hex or decimal
			IF val${2} = 'X' THEN val${2} = 'x'
			IF val${2} = 'x' THEN
				val$ = "0" + LCLIP$(val$,2)		'convert to Xblite HEX
			ELSE
				val$ = LCLIP$(val$,2)					'convert to Xblite DECIMAL
			ENDIF
		ELSE
			'HTML name - look up codepoint in table
			address = &val$
			index = (UBYTEAT(address + 1) OR 32) - 'a'			'first character of name , lowercased - 'a'
			IF ((index < 0) || (index > 26)) THEN codepoint&& = 0: RETURN $$TRUE
			
'Store search string value in 2 registers	
ASM mov esi, d[StringToCodepoint.address]			;esi = base of val$
ASM INC esi																		;skip over the '&'
ASM mov ebx, d[esi]														;move 1st 4 characters into ebx
ASM mov ecx, d[esi + 4]												;move 2nd 4 characters into ecx

'Locate table entries for first letter of search string
ASM mov eax, d[StringToCodepoint.index]						
ASM mov esi, d[NamePointers + eax * 4]				;index into array of pointers - get address of entries for first letter
ASM sub esi, 16																;this is reversed at top of loop!

'Search through table entries to find match
ASM SearchLoop:
ASM add esi, 16																;advance to next table entry for start letter
ASM mov edx, [esi]														;get table entry 1st 4 characters
ASM test edx,edx															;if 0 then end of table entries for this letter
ASM jz > NoMatch
ASM cmp edx, ebx															;compare 1st 4 characters with search value 1st 4
ASM jne < SearchLoop													;try next entry
ASM mov eax, d[esi + 4]												;1st 4 match so load 2nd 4																	
ASM cmp eax, ecx															;compare these
ASM jne < SearchLoop													;try next entry
ASM mov eax, d[esi + 8]												;full match on 8 bytes so get following codepoint value from the table
ASM mov d[StringToCodepoint.codepoint], eax		;update input codepoint&& 
RETURN 0																			'SUCCESSFUL MATCH

ASM NoMatch:																	;no entry matched search string 
ASM mov d[StringToCodepoint.codepoint], 0			;update input codepoint && to 0
RETURN $$TRUE																	'NO MATCHING ENTRY
			
		ENDIF
	ENDIF
	

	IF LEFT$(val$,2) = "U+" THEN val$ = "0x" + LCLIP$(val$,2)				'U+hhhh unicode codepoint - convert to standard hex
	'Now have 0xhhh, 0bbbb, 0oooo, ddddd formats
	
	code = XLONG(val$)													'Do XLONG first in case it is negative! 
	IF (code < 0) || (code > $$MAX_CODEPOINT) THEN codepoint&& = 0: RETURN $$TRUE								'Make sure it is in Unicode range	
	IF (code >= $$HIGH_FIRST) && (code <= $$LOW_LAST) THEN codepoint&& = 0: RETURN $$TRUE				'Surrogate range is not valid codepoint	
	codepoint&& = code			'Safe to make codepoint&&

END FUNCTION


FUNCTION DisplayCodepointRange(ULONG u32[], startChar, endChar, @report$)
'INTERNAL function called by UncShowCodepoints() and UncShowCodepointsWS()
'Shows codepoints 10 per line

	IFZ u32[] THEN report$ = " Array is empty": RETURN $$TRUE
	
	GOSUB Initialise
	GOSUB FirstLine 
	
	FOR i = startIndex TO endIndex
		char = i + 1
		IF (char MOD 10 = 0) THEN report$ = report$ + "\r\n" + RJUST$(STRING(char \ 10),10) + "    "
		report$ = report$ + HEX$(u32[i],6) + "  "
	NEXT i
	
	
SUB Initialise
	'StartChar 
	IF startChar < 1 THEN startChar = 1
	startIndex = startChar - 1

	'EndChar
	upper = UBOUND(u32[])
	IF endChar < 1 THEN
		endIndex = upper
	ELSE
		endIndex = MIN(endChar - 1,upper)
	ENDIF
	
	'Headings
	report$ = " Display Codepoints:\r\n\r\n   CharNum        0        1       2       3       4       5       6       7       8       9\r\n"
END SUB

SUB FirstLine
	IFZ startChar MOD 10 THEN EXIT SUB
	report$ = report$ + "\r\n" + RJUST$(STRING(startIndex \ 10), 10) + SPACE$(4 + (startChar MOD 10) * 8)
END SUB

END FUNCTION


FUNCTION FitToRange(start, end, upper)
	IF start < 1 THEN start = 1
	IF start > upper THEN start = upper
	IF end < 1 THEN end = upper
	IF end > upper THEN end = upper
	IF start > end THEN SWAP start, end
END FUNCTION


FUNCTION FromTo(fromChar,toChar,nChars)
'Constrains fromChar, toChar to range 1 to nChars
'returns 0 if both inputs were in range, returns $$TRUE if either was beyond nChars
	ret = 0
	
	SELECT CASE TRUE
		CASE fromChar < 0
			fromChar = nChars + fromChar + 1
			IF fromChar < 1 THEN fromChar = 1: ret = $$TRUE
		CASE fromChar = 0
			fromChar = 1
		CASE fromChar > 0
			IF fromChar > nChars THEN fromChar = nChars: ret = $$TRUE
	END SELECT
	
	SELECT CASE TRUE
	CASE toChar < 0
		toChar = nChars + toChar + 1
		IF toChar < 1 THEN toChar = 1: ret = $$TRUE
	CASE toChar = 0
		toChar = nChars
	CASE toChar > 0
		IF toChar > nChars THEN toChar = nChars: ret = $$TRUE
	END SELECT
	
	IF fromChar > toChar THEN SWAP fromChar, toChar	
	RETURN ret
END FUNCTION


'*******************************************************************************************************************************
' DETERMINE PROBABLE FORMAT ****************************************************************************************************
'*******************************************************************************************************************************

FUNCTION UncDetermineProbableFormat(fileName$, @endian, @BOM)
'This is the PROBABLE format - could be wrong 
'Returns 32, 16, 8, 1 for UTF32, UTF16, UTF8, Ansi / Ascii respectively
'endian is returned as 0 for Little Endian, 1 for Big Endian or -1 if undefined (UTF8 / Ansi / Ascii)

	IFZ fileName$ THEN RETURN $$TRUE
	IF XstLoadString (fileName$, @text$) THEN RETURN $$TRUE	
	IF LEN(text$) < 4 THEN RETURN $$TRUE
	address = &text$
	endian = -1 	'Default to unknown unless can determine it
	
	'FIRST - check for Byte Order Markers that indicate the format directly
	'Check for UTF32
		bom&& = ULONGAT(address)
		IF bom&& = 0x0000FEFF THEN endian = 0: BOM = $$TRUE: RETURN 32
		IF bom&& = 0xFFFE0000 THEN endian = 1: BOM = $$TRUE: RETURN 32
	'Check for UTF16
		bom%% = USHORTAT(address)
		IF bom%% = 0xFEFF THEN endian = 0: BOM = $$TRUE: RETURN 16
		IF bom%% = 0xFFFE THEN endian = 1: BOM = $$TRUE: RETURN 16
	'Check for UTF8
		IF (bom&& AND 0xFFFFFF00) = 0xEFBBBF00 THEN BOM = $$TRUE: RETURN 8
		
		BOM = $$FALSE
	'SECOND - Check for 4 / 2 byte terminating nulls
		upper = LEN(text$) - 1
		'Check for UTF32
		last4&& = ULONGAT(address + upper - 3)
		IFZ last4&& THEN
			'Probably is UTF32
			IFZ text${0} THEN
				endian = 1
			ELSE
				endian = 0
			ENDIF
			RETURN 32
		ENDIF
		
		'Check for UTF16
		last2%% = USHORTAT(address + upper - 1)
		IFZ last2%% THEN
			'Probably is UTF16 but could be UTF32LE - check for multiple nulls
			count = XstTally(text$,"\x00\x00") + XstTally(text$,"\x00\x00\x00")
			IF count < 3 THEN
				GOSUB Utf16Endian
				RETURN 16
			ENDIF
		ENDIF		
		
	'Cannot determine by BOM or TRAILING NULL
	'Analyse byte distributions / patterns
	count = XstTally(text$,"\x00\x00\x00")
	IFZ count THEN
		'UTF16 - check for every 2nd byte = 0
		'Characteristic of UTF16 holding ansi only
		byte0 = 0: byte1 = 0: i = 1
		DO WHILE i <= upper
			byte1 = byte1 + text${i}
			byte0 = byte0 + text${i - 1}
			i = i + 2
		LOOP
		IF byte0 = 0 THEN endian = 1: RETURN 16
		IF byte1 = 0 THEN endian = 0: RETURN 16
	ENDIF
	
	'UTF32 - check for every 4th byte = 0
	byte0 = 0: byte3 = 0: i = 3
	DO WHILE i <= upper
		byte3 = byte3 + text${i}
		byte0 = byte0 + text${i - 3}
		i = i + 4
	LOOP
	IF byte0 = 0 THEN endian = 1: RETURN 32
	IF byte3 = 0 THEN endian = 0: RETURN 32
	
	'UTF16 with high codepoints / utf8 / ansi
	'Analyse embedded null bytes
	cNulls = XstTally(text$, "\x00")	
	IF cNulls > 1 THEN
		'Probably UTF16
		GOSUB Utf16Endian
		RETURN 16
	ELSE
		'UTF8 or ANSI
		'See if it is valid UTF8
		DIM u8@@[upper]
		XstCopyMemory (address, &u8@@[], upper + 1)
		ret = UncValidateUTF8 (@u8@@[], @report$)
		IFZ ret THEN
		'Could be UTF8 or ASCII - assume UTF8
			RETURN 8
		ELSE
			'Must be ANSI
			RETURN 1
		ENDIF
	ENDIF
	
SUB Utf16Endian
'Determine endian by using the bias of values at the lower end of plane 0
'This means bytes 0,2,4,6... tend to be higher than bytes 1,3,5,7.. for Little Endian and vice versa
	odd$$ = 0: even$$ = 0: i = 0
	DO WHILE i <= upper
		IF i AND 1 THEN
			odd$$ = odd$$ + text${i}
		ELSE
			even$$ = even$$ + text${i}
		ENDIF
		INC i
	LOOP
	IF odd$$ > even$$ THEN
		endian = 1  'BE
	ELSE
		endian = 0  'LE
	ENDIF
END SUB
	
END FUNCTION

'*****************************************************************************************************************************
' EXTRACT FUNCTIONS **********************************************************************************************************
'*****************************************************************************************************************************

FUNCTION ULONG UncExtractCharacterUTF8(UBYTE u8[], charNum)
	offset = UncGetCharacterOffsetUTF8 (@u8[], charNum) 
	IF offset < 0 THEN RETURN 
	RETURN UncGetCodepointFromUTF8 (&u8[] + offset) 
END FUNCTION


FUNCTION ULONG UncExtractCharacterUTF16(USHORT u16[], charNum)
	offset = UncGetCharacterOffsetUTF16 (@u16[], charNum) 
	IF offset < 0 THEN RETURN 
	RETURN UncGetCodepointFromUTF16 (&u16[] + offset) 
END FUNCTION


FUNCTION ULONG UncExtractCharacterWS(wide$, charNum)
	offset = UncGetCharacterOffsetWS (wide$, charNum) 
	IF offset < 0 THEN RETURN 
	RETURN UncGetCodepointFromUTF16 (&wide$ + offset) 
END FUNCTION


FUNCTION ULONG UncExtractCharacterUTF32(ULONG u32[], charNum)
	IFZ u32[] RETURN 0
	upper = UBOUND(u32[]) 
	IF (charNum < 1) || (charNum > (upper + 1)) THEN RETURN 0
	RETURN u32[charNum - 1] 
END FUNCTION


'********************************************************************************************************************************
' SEQUENTIAL PARSE FUNCTIONS ****************************************************************************************************
'********************************************************************************************************************************

FUNCTION ULONG UncSequentialParseUTF8(UBYTE u8[], offset, bEnd)
'Return First / Next codepoint in u8[]
'Start with offset = 0 or that of nth character determined by UncGetCharacterOffsetUTF8 (@u8[], n)
'If offset does not point to start of a character sequence then returns substitute character until gets to start of a sequence 

	IFZ u8[] THEN bEnd = $$TRUE: RETURN
	upper = UBOUND(u8[])
	IF offset > upper THEN bEnd = $$TRUE: RETURN
	
	base = &u8[]
	address = base + offset
	cp&& = UncGetCodepointFromUTF8 (@address)
	offset = address - base
	
	IF offset > upper THEN bEnd = $$TRUE	
	RETURN cp&&
	
END FUNCTION


FUNCTION ULONG UncSequentialParseUTF16(USHORT u16[], offset, bEnd)
'Return First / Next codepoint in u16[]
'Start with offset = 0 or that of nth character determined by UncGetCharacterOffsetUTF16 (USHORT u16[], n)
'If offset does not point to start of a character sequence then returns substitute character until gets to start 

	IFZ u16[] THEN bEnd = $$TRUE: RETURN
	upper = UBOUND(u16[]) <<< 1
	IF offset > upper THEN bEnd = $$TRUE: RETURN
	
	base = &u16[]
	address = base + offset
	cp&& = UncGetCodepointFromUTF16 (@address)
	offset = address - base
	
	IF offset > upper THEN bEnd = $$TRUE	
	RETURN cp&&
	
END FUNCTION


FUNCTION ULONG UncSequentialParseWS(wide$, offset, bEnd)
'Return First / Next codepoint in wide$
'Start with offset = 0 or that of nth character determined by UncGetCharacterOffsetWS (wide$, n)
'If offset does not point to start of a character sequence then returns substitute character until gets to start 

	IFZ wide$ THEN bEnd = $$TRUE: RETURN
	upper = LEN(wide$) - 1
	IF offset > upper THEN bEnd = $$TRUE: RETURN
	
	base = &wide$
	address = base + offset
	cp&& = UncGetCodepointFromUTF16 (@address)
	offset = address - base
	
	IF offset > upper THEN bEnd = $$TRUE	
	RETURN cp&&
	
END FUNCTION


'********************************************************************************************************************************
' GET FUNCTIONS *****************************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncGetByteSignificanceUTF8(UBYTE value)
	RETURN #UTF8SIG${value AND 0xFF}
END FUNCTION


FUNCTION UncGetByteSignificance$()
	RETURN #UTF8SIG$
END FUNCTION


FUNCTION ULONG UncGetMaxCodepoint(u[])
'Returns the highest codepoint found in a UTF8, UTF16 or UTF32 array 

	IFZ u[] THEN RETURN 0
	type = TYPE(u[])
	upper = UBOUND(u[])
	maxCP&& = 0
	address = &u[]

	SELECT CASE type
		CASE $$UBYTE
			last = address + upper
			DO WHILE address <= last
				cp&& = UncGetCodepointFromUTF8 (@address)
				IF cp&& > maxCP&& THEN maxCP&& = cp&&
			LOOP
		
		CASE $$USHORT
			last = address + (upper <<< 1)
			DO WHILE address <= last
				cp&& = UncGetCodepointFromUTF16 (@address)
				IF cp&& > maxCP&& THEN maxCP&& = cp&&
			LOOP
	
		CASE $$ULONG
			FOR i = 0 TO UBOUND(u[])
				cp&& = u[i]
				IF cp&& > maxCP&& THEN maxCP&& = cp&&
			NEXT i					
			
	END SELECT
	
	RETURN maxCP&&
	
END FUNCTION 


FUNCTION ULONG UncGetMaxCodepointWS(@wide$)
	IFZ wide$ THEN RETURN 0
	
	address = &wide$
	last = &wide$ + LEN(wide$) - 1
	maxCP&& = 0
	
	DO WHILE address <= last
		cp&& = UncGetCodepointFromUTF16 (@address)
		IF cp&& > maxCP&& THEN maxCP&& = cp&&
	LOOP
	
	RETURN maxCP&&

END FUNCTION 


FUNCTION UncGetCharacterOffsetUTF8(UBYTE u8[], charNum)
'Return offset into u8[] of charNum-th character ( 1 based )
'Return -1 if charNum out of range or UTF8 malformed
 
	IFZ u8[] THEN RETURN -1
	IF charNum < 1 THEN RETURN -1
	IF charNum = 1 THEN RETURN 0			'1st character always has offset 0
	
	upper = UBOUND(u8[])
	base = &u8[]
	stop = base + upper								'stop address needed if charNum > number of characters
	
ASM xor eax, eax
ASM mov ebx, ADDR utf8ByteSignificance
ASM mov esi, d[UncGetCharacterOffsetUTF8.base]
ASM mov ecx, d[UncGetCharacterOffsetUTF8.charNum]
ASM dec ecx																			;ecx will always be 2 or more - no need to check for 0
ASM skip:
ASM mov al, b[esi]															;read lead byte
ASM xlatb																				;see if it is 1,2,3 or 4 byte sequence from table
ASM sub al, '0'																	;convert ascii code to digit
ASM cmp eax, 1																	;check range
ASM jl > bad
ASM cmp eax, 4
ASM jg > bad
ASM add esi, eax																;skip over to next lead byte
ASM cmp esi, d[UncGetCharacterOffsetUTF8.stop]	;stop if go past end before getting to charNum
ASM jg > bad
ASM dec ecx
ASM jne skip																		;stop when reach required charNum
'return offset
ASM mov eax, esi
ASM sub eax, d[UncGetCharacterOffsetUTF8.base]
ASM jmp end.UncGetCharacterOffsetUTF8.unc
ASM bad:
ASM mov eax, -1
ASM jmp end.UncGetCharacterOffsetUTF8.unc
END FUNCTION


FUNCTION UncGetCharacterOffsetUTF16(USHORT u16[], charNum)
'Return offset into u16[] of charNum-th character ( 1 based )
'Return -1 if charNum out of range
 
	IFZ u16[] THEN RETURN -1
	IF charNum < 1 THEN RETURN -1
	IF charNum = 1 THEN RETURN 0			'1st character always has offset 0
	
	upper = UBOUND(u16[])
	base = &u16[]
	stop = base + (upper <<< 1)				'stop address needed if charNum > number of characters
	
ASM mov esi, d[UncGetCharacterOffsetUTF16.base]
ASM mov ecx, d[UncGetCharacterOffsetUTF16.charNum]
ASM dec ecx																			;ecx will always be 2 or more - no need to check for 0
ASM skip16:
ASM mov ax, w[esi]															;read lead byte
ASM cmp ax, 0xD800															;check for high surrogate
ASM jl > normal
ASM cmp ax, 0xDBFF
ASM jg > normal
ASM add esi, 2																	;add extra 2 for surrogate pair
ASM normal:
ASM add esi, 2																	;add 2 normally													
ASM cmp esi, d[UncGetCharacterOffsetUTF16.stop]	;stop if go past end before getting to charNum
ASM jg > bad16
ASM dec ecx 
ASM jne skip16																	;stop when reach required charNum
'return offset if OK or -1
ASM mov eax, esi
ASM sub eax, d[UncGetCharacterOffsetUTF16.base]	;eax = offset
ASM jmp end.UncGetCharacterOffsetUTF16.unc
ASM bad16:
ASM mov eax, -1
ASM jmp end.UncGetCharacterOffsetUTF16.unc
END FUNCTION


FUNCTION UncGetCharacterOffsetWS(wide$, charNum)
'Return offset into wide$ of charNum-th character ( 1 based )
'Return -1 if charNum out of range
 
	IFZ wide$ THEN RETURN -1
	IF charNum < 1 THEN RETURN -1
	IF charNum = 1 THEN RETURN 0			'1st character always has offset 0
	
	base = &wide$
	stop = base + LEN(wide$) - 1			'stop address needed if charNum > number of characters
	
ASM mov esi, d[UncGetCharacterOffsetWS.base]
ASM mov ecx, d[UncGetCharacterOffsetWS.charNum]
ASM dec ecx																			;ecx will always be 2 or more - no need to check for 0
ASM skipWS:
ASM mov ax, w[esi]															;read lead byte
ASM cmp ax, 0xD800															;check for high surrogate
ASM jl > normalWS
ASM cmp ax, 0xDBFF
ASM jg > normalWS
ASM add esi, 2																	;add extra 2 for surrogate pair
ASM normalWS:
ASM add esi, 2																	;add 2 normally													
ASM cmp esi, d[UncGetCharacterOffsetWS.stop]		;stop if go past end before getting to charNum
ASM jg > badWS
ASM dec ecx 
ASM jne skipWS																	;stop when reach required charNum
'return offset if OK or -1
ASM mov eax, esi
ASM sub eax, d[UncGetCharacterOffsetWS.base]		;eax = offset
ASM jmp end.UncGetCharacterOffsetWS.unc
ASM badWS:
ASM mov eax, -1
ASM jmp end.UncGetCharacterOffsetWS.unc
END FUNCTION 

'********************************************************************************************************************************
' CONCAT FUNCTIONS **************************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncConcat(u1[], u2[])
	IFZ u2[] THEN RETURN
	type2 = TYPE(u2[])

	SELECT CASE type2
		CASE $$UBYTE elSize = 1
		CASE $$USHORT elSize = 2
		CASE $$ULONG elSize = 4
		CASE ELSE RETURN $$TRUE
	END SELECT
	upper2 = UBOUND(u2[])
	
	IF u1[] THEN
		'data in u1[]
		IF TYPE(u1[]) <> type2 THEN RETURN $$TRUE
		IF #CONCAT_MODE THEN UncTrailingNulls(@u1[],"LEAVE",0)
		upper1 = UBOUND(u1[])
		IF upper1 = -1 THEN
			'Array now empty
			XstCopyArray(@u2[],@u1[])
		ELSE
			'Still got data in u1[]
			REDIM u1[upper1 + upper2 + 1]
			destAddress = &u1[] + ((upper1 + 1) * elSize)
			XstCopyMemory (&u2[], destAddress, (upper2 + 1) * elSize)
		ENDIF	
	ELSE
		XstCopyArray(@u2[],@u1[])
	ENDIF
 
END FUNCTION


FUNCTION UncConcatWS(wide1$, wide2$)
	IFZ wide2$ THEN RETURN
	IFZ wide1$ THEN wide1$ = wide2$
	
	IF #CONCAT_MODE THEN UncTrailingNullsWS(@wide1$,"LEAVE",0)
	wide1$ = wide1$ + wide2$
 
END FUNCTION


'********************************************************************************************************************************
' OPEN and VIEW FUNCTIONS *******************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncOpenInApplication(u[], application$)

	IFZ u[] THEN RETURN $$TRUE
	IFZ application$ THEN RETURN $$TRUE
	SELECT CASE UCASE$(application$)
		CASE "NOTEPAD"
			appFile$ = "C:/Windows/system32/notepad.exe"
		CASE "WORDPAD"
			appFile$ = "C:/Program Files/Windows NT/Accessories/wordpad.exe"
		CASE ELSE
			'Allow application to be specified directly
			appFile$ = application$
	END SELECT
	
	SELECT CASE TYPE(u[])
		CASE $$UBYTE
			ATTACH u[] TO temp@@[]
			UncWriteUTF8 (@temp@@[], "Unc_temp_application.txt", $$TRUE)			'Need BOM to tell notepad it is UTF8
			ATTACH temp@@[] TO u[]
		CASE $$USHORT
			ATTACH u[] TO temp%%[]
			UncWriteUTF16 (@temp%%[], "Unc_temp_application.txt", "UTF16")		'Need BOM to tell notepad it is UTF16LE
			ATTACH temp%%[] TO u[]
		CASE $$ULONG
			UncConvertUTF32ToUTF16 (@u[], @temp%%[])
			UncWriteUTF16 (@temp%%[], "Unc_temp_application.txt", "UTF16")					'Need BOM to tell notepad it is UTF16LE
		CASE ELSE RETURN $$TRUE
	END SELECT
	
	'Open it NON -CONCURRENTLY
	SHELL(appFile$ + " Unc_temp_application.txt")
	'Clean up temporary file
	XstDeleteFile ("Unc_temp_application.txt")
	
END FUNCTION


FUNCTION UncOpenInApplicationWS(wide$, application$)

	IFZ wide$ THEN RETURN $$TRUE
	IFZ application$ THEN RETURN $$TRUE
	SELECT CASE application$
		CASE "NOTEPAD"
			appFile$ = "C:/Windows/system32/notepad.exe"
		CASE "WORDPAD"
			appFile$ = "C:/Program Files/Windows NT/Accessories/wordpad.exe"
		CASE ELSE
			'Allow application to be specified directly
			appFile$ = application$
	END SELECT
	
	UncWriteWS(wide$, "Unc_temp_application.txt", "UTF16")		'Need BOM to tell notepad it is UTF16LE
	
	'Open it
	SHELL(appFile$ + " Unc_temp_application.txt")
'	ShellExecuteA (0, &"open", &application$, &"Unc_temp_application.txt", NULL, 1)	
	XstDeleteFile ("Unc_temp_application.txt")
END FUNCTION
	
	
FUNCTION UncViewInConsole(u[])
	hConsole = XioGetStdOut()
	IFZ hConsole THEN RETURN $$TRUE	
	written = 0

	SELECT CASE TYPE(u[])
		CASE $$UBYTE
			ATTACH u[] TO temp@@[]
			IF UncConvertUTF8ToUTF16 (@temp@@[], @temp%%[]) THEN RETURN $$TRUE
			ATTACH temp@@[] TO u[]
			cChars = UncNumCharacters (@temp%%[])
			address = &temp%%[]
			
		CASE $$USHORT
			cChars = UncNumCharacters (@u[])
			address = &u[]
		
		CASE $$ULONG
			ATTACH u[] TO temp&&[]
			IF UncConvertUTF32ToUTF16 (@temp&&[], @temp%%[]) THEN RETURN $$TRUE
			ATTACH temp&&[] TO u[]
			cChars = UncNumCharacters (@temp%%[])
			address = &temp%%[]
			
		CASE ELSE RETURN $$TRUE
	END SELECT
	'Write it
	IFF WriteConsoleW(hConsole, address, cChars, &written, 0) THEN ? "Error writing to Console\r\n"
	zzz$ = INLINE$("\r\n\r\n UncViewInConsole: - Press any key to exit")

END FUNCTION


FUNCTION UncViewInConsoleWS(wide$)
	IFZ wide$ THEN RETURN $$TRUE
	hConsole = XioGetStdOut()
	IFZ hConsole THEN RETURN $$TRUE	
	written = 0

	cChars = UncNumCharactersWS (wide$)
	IFF WriteConsoleW(hConsole, &wide$, cChars, &written, 0) THEN ? "Error writing to Console\r\n"
	zzz$ = INLINE$("\r\n\r\n UncViewInConsoleWS: - Press any key to exit")

END FUNCTION

'********************************************************************************************************************************
' SHOW HEXCHAR FUNCTIONS ********************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncShowHexChar(u[], @report%%[])

	IFZ u[] THEN RETURN $$TRUE
	IF report%%[] THEN DIM report%%[]
	
	'check type and convert to UTF32
	SELECT CASE TYPE(u[])
		CASE $$UBYTE
			ATTACH u[] TO temp@@[]
				UncConvertUTF8ToUTF32(@temp@@[],@u32&&[])
			ATTACH temp@@[] TO u[]
		CASE $$USHORT
			ATTACH u[] TO temp%%[]
				UncConvertUTF16ToUTF32(@temp%%[],@u32&&[])
			ATTACH temp%%[] TO u[]
		CASE $$ULONG
				RETURN HexChar(@u[], @report%%[])
		CASE ELSE RETURN $$TRUE
	END SELECT
	RETURN HexChar(@u32&&[], @report%%[])
END FUNCTION


FUNCTION UncShowHexCharWS(wide$, @report%%[])

	IFZ wide$ THEN RETURN $$TRUE
	IF report%%[] THEN DIM report%%[]
	
	'convert to UTF32
	UncConvertWSToUTF32(wide$,@u32[])
	RETURN HexChar(@u32[], @report%%[])
END FUNCTION

	
FUNCTION HexChar(ULONG u32[], report%%[])
	
	upper = UBOUND(u32[])
	nEls = upper + 1
	nLines = nEls \ 16
	remainder = nEls MOD 16
	
	'Output the heading line
	UncMakeUTF16(@report%%[], "\r\n ShowHexChar:\r\n\r\n")
	
	charNum = 1	
	IF nLines THEN
		FOR line = 0 TO nLines - 1
			GOSUB InitLine			
			'build character and hex strings for line	
			lineIndex = line <<< 4
			FOR horPos = 0 TO 15				
				GOSUB DoCharacter
			NEXT horPos
			GOSUB Output
		NEXT line
	ENDIF
	
	IF remainder THEN
		lineIndex = nLines <<< 4
		GOSUB InitLine
		FOR horPos = 0 TO remainder - 1
			GOSUB DoCharacter
		NEXT horPos
		GOSUB Output
	ENDIF	

SUB InitLine
	'Initialise the top CHARACTER line in its own Unicode array
	DIM char%%[]: UncCharsUTF16(@char%%[]," ",94)
	charIndex = 13			'first character position
	
	'Initialise the bottom HEX line - build whole line in Ascii first
	hex$ = RJUST$(STRING(charNum),8) + "  "
END SUB


SUB DoCharacter
	cp&& = u32[lineIndex + horPos]
	IF horPos = 8 THEN
		'Do mid separator -
		hex$ = hex$ + "- "
		charIndex = charIndex + 2
	ENDIF
	IF cp&& < 65536 THEN
		IF cp&& < 32 THEN
			'replace C0 Control Codes
			char%%[charIndex] = #SUB_ASCII
		ELSE
			IF (cp&& >= 128) && (cp&& <= 159) THEN
				'replace C1 Control Codes
				char%%[charIndex] = #SUB_ASCII
			ELSE
				'Normal printable character
				char%%[charIndex] = cp&&
			ENDIF
		ENDIF
		hex$ = hex$ + HEX$(cp&&,4) + " "					
	ELSE
		'OUT OF RANGE
		char%%[charIndex] = #SUB_UTF
		hex$ = hex$ + "#### " 
	ENDIF
	charIndex = charIndex + 5		'Advance to next char position
END SUB

SUB Output	
	UncConcat(@report%%[], @char%%[])										'output the CHARACTER line
	UncMakeUTF16(@report%%[], "\r\n" + hex$ + "\r\n")		'output the HEX line
	charNum = charNum + 16
END SUB
END FUNCTION

'********************************************************************************************************************************
' SUBSTRING FUNCTIONS ***********************************************************************************************************
'********************************************************************************************************************************

FUNCTION UncSubstringWS(wide$, fromChar, toChar, subWide$)
'Makes substring of wide$ in subWide$

	IFZ wide$ THEN RETURN $$TRUE
	nChars = UncNumCharactersWS(@wide$)
	cNulls = 0
	IFF #SUBSTRING_NULLS THEN
		cNulls = UncNumNullsWS(@wide$)
		nChars = nChars - cNulls
	ENDIF
	IF nChars < 1 THEN RETURN $$TRUE
	
	ret = FromTo(@fromChar, @toChar, nChars)
	
	fromOffset = UncGetCharacterOffsetWS (wide$, fromChar)
	IF toChar < nChars THEN
		toOffset =   UncGetCharacterOffsetWS (wide$, toChar + 1)
	ELSE
		toOffset = LEN(wide$) - (cNulls <<< 1)
	ENDIF
	
	nBytes = toOffset - fromOffset
	subWide$ = NULL$(nBytes)
	
	IF nBytes = 2 THEN
		'single characters
		USHORTAT(&subWide$) = USHORTAT(&wide$ + fromOffset)
	ELSE
		'surrogate pairs and multiple characters
		XstCopyMemory(&wide$ + fromOffset, &subWide$, nBytes)
	ENDIF
	
	RETURN ret
END FUNCTION


FUNCTION UncSubstringUTF32(ULONG u32[], fromChar, toChar, ULONG u32Sub[])
'Makes substring of u32[] in u32Sub[]

	IFZ u32[] THEN RETURN $$TRUE
	nChars = UncNumCharacters(@u32[])
	cNulls = 0
	IFF #SUBSTRING_NULLS THEN
		cNulls = UncNumNulls(@u32[])
		nChars = nChars - cNulls
	ENDIF
	IF nChars < 1 THEN RETURN $$TRUE
	
	ret = FromTo(@fromChar, @toChar, nChars)
	
	fromIndex = fromChar - 1 
	IF toChar < nChars THEN
		toIndex =  toChar - 1
	ELSE
		toIndex = UBOUND(u32[]) - cNulls 
	ENDIF
	subUpper = toIndex - fromIndex
	DIM u32Sub[subUpper]
	
	FOR i = 0 TO subUpper
		u32Sub[i] = u32[fromIndex + i]
	NEXT i
	
	RETURN ret
	
END FUNCTION


FUNCTION UncSubstringUTF16(USHORT u16[], fromChar, toChar, USHORT u16Sub[])
'Makes substring of u16[] in u16Sub[]

	IFZ u16[] THEN RETURN $$TRUE
	nChars = UncNumCharacters(@u16[])
	cNulls = 0
	IFF #SUBSTRING_NULLS THEN
		cNulls = UncNumNulls(@u16[])
		nChars = nChars - cNulls
	ENDIF
	IF nChars < 1 THEN RETURN $$TRUE
	
	ret = FromTo(@fromChar, @toChar, nChars)
	
	fromOffset = UncGetCharacterOffsetUTF16 (@u16[], fromChar)
	IF toChar < nChars THEN
		toOffset =   UncGetCharacterOffsetUTF16 (@u16[], toChar + 1)
	ELSE
		toOffset = ((UBOUND(u16[]) <<< 1) + 2) - (cNulls <<< 1)
	ENDIF
	
	nBytes = toOffset - fromOffset
	DIM u16Sub[(nBytes >>> 1) - 1]
	
	IF nBytes = 2 THEN
		'single characters
		USHORTAT(&u16Sub[]) = USHORTAT(&u16[] + fromOffset)
	ELSE
		'surrogate pairs and multiple characters
		XstCopyMemory(&u16[] + fromOffset, &u16Sub[], nBytes)
	ENDIF
	
	RETURN ret
	
END FUNCTION


FUNCTION UncSubstringUTF8(UBYTE u8[], fromChar, toChar, UBYTE u8Sub[])
'Makes substring of u8[] in u8Sub[]

	IFZ u8[] THEN RETURN $$TRUE
	nChars = UncNumCharacters(@u8[])
	cNulls = 0
	IFF #SUBSTRING_NULLS THEN
		cNulls = UncNumNulls(@u8[])
		nChars = nChars - cNulls
	ENDIF
	IF nChars < 1 THEN RETURN $$TRUE
	
	ret = FromTo(@fromChar, @toChar, nChars)
	
	fromOffset = UncGetCharacterOffsetUTF8 (@u8[], fromChar)
	IF toChar < nChars THEN
		toOffset =   UncGetCharacterOffsetUTF8 (@u8[], toChar + 1)
	ELSE
		toOffset = UBOUND(u8[]) + 1 - cNulls
	ENDIF
	
	nBytes = toOffset - fromOffset
	DIM u8Sub[nBytes - 1]
	
	XstCopyMemory(&u8[] + fromOffset, &u8Sub[], nBytes)

	RETURN ret
END FUNCTION


'********************************************************************************************************************************
'TABLES - READ ONLY
'********************************************************************************************************************************
'TABLE FOR ASM UTF8 ROUTINES - also exposed internally as #UTF8SIG$ - COPY available externally through UncGetByteSignificance$()
'********************************************************************************************************************************
'The following table indicates the significance of bytes 0x00 to 0xFF in a UTF8 encoding
'1 = first ( and only ) byte of 1 byte sequence (ascii codes)
'2 = first byte of 2 byte sequence
'3 = first byte of 3 byte sequence
'4 = first byte of 4 byte sequence
'F = follow on byte of 2, 3 or 4 byte sequence
'L = Overlong encoding - 2 byte encoding could have been 1 byte - not allowed in unicode
'R = Restricted - indicates 5 or 6 byte sequence - not allowed in unicode
'I = Invalid - should never occur in ANY valid UTF8 encoding

ASM .const														;Make tables READ ONLY																								
ASM align 8
ASM DD 280,0,256,0x80130001						;make Xblite string header for use by #UTF8SIG$ created in Unc()
ASM utf8ByteSignificance:							;label for assembly language
ASM DB "1111111111111111"	;00 - 0F
ASM DB "1111111111111111"	;10 - 1F
ASM DB "1111111111111111"	;20 - 2F
ASM DB "1111111111111111"	;30 - 3F

ASM DB "1111111111111111"	;40 - 4F
ASM DB "1111111111111111"	;50 - 5F
ASM DB "1111111111111111"	;60 - 6F
ASM DB "1111111111111111"	;70 - 7F

ASM DB "FFFFFFFFFFFFFFFF"	;80 - 8F
ASM DB "FFFFFFFFFFFFFFFF"	;90 - 9F
ASM DB "FFFFFFFFFFFFFFFF"	;A0 - AF
ASM DB "FFFFFFFFFFFFFFFF"	;B0 - BF

ASM DB "LL22222222222222"	;C0 - CF
ASM DB "2222222222222222"	;D0 - DF
ASM DB "3333333333333333"	;E0 - EF
ASM DB "44444RRRRRRRRRII"	;F0 - FF
ASM DD 0,0								;terminating null and pad to 8 byte boundary

'********************************************************************************************************************************
'TABLE FOR HTML &name style lookup
'********************************************************************************************************************************
'Name string is held without & or ; and padded with nulls to be fixed length of 8 bytes because defined with DQ
'Codepoint value is also held as a GIANT because of the DQ but is read + returned as a ULONG. The total entry for a name is always 16 bytes
'Entries for a given first letter are indexed via the XLONG pointer array labelled NamePointers below
'Entries for a given first letter are terminated with a name of 8 nulls ( which is read as GIANT 0 )
'Contains all character entities defined in HTML 4.0 plus a few more proposed but not yet ISO approved. Also &comma and &semicol
'Codepoint values are in decimal
ASM align 8
ASM &A DQ "amp",38,"acute",180,"and",8743,"ang",8736,"Aacute",193,"aacute",225,"acirc",226,"Acirc",194
ASM    DQ "aelig",230,"Aelig",198,"Agrave",192,"agrave",224,"alefsym",8501,"Alpha",913,"alpha",945
ASM    DQ "aring",229,"Aring",197,"asymp",8776,"Atilde",195,"atilde",227,"Auml",196,"auml",228,"ap",8773,0
ASM &B DQ "brvbar",166,"bdquo",8222,"bull",8226,"Beta",914,"beta",946,"breve",728,0
ASM &C DQ "comma",44,"cent",162,"curren",164,"copy",169,"cedil",184,"cap",8745,"Ccedil",199,"ccedil",231,"chi",967,"Chi",935,"circ",710,"clubs",9827   
ASM    DQ "cong",8773,"crarr",8629,"cup",8746,"caron",711,0
ASM &D DQ "deg",176,"dagger",8224,"Dagger",8225,"dArr",8659,"darr",8595,"Delta",916,"delta",948,"diams",9830,"divide",247,"dot",729,"dblac",733,0
ASM &E DQ "ensp",8194,"emsp",8195,"euro",8364,"eacute",233,"Eacute",201,"Ecirc",202,"ecirc",234,"egrave",232,"Egrave",200,"empty",8709
ASM    DQ "epsilon",949,"Epsilon",917,"equiv",8801,"Eta",919,"eta",951,"eth",240,"ETH",208,"euml",235,"Euml",203,"exist",8707,0
ASM &F DQ "frac14",188,"frac12",189,"frac34",190,"frasl",8260,"fnof",402,"forall",8704,0
ASM &G DQ "gt",62,"ge",8805,"Gamma",915,"gamma",947,0
ASM &H DQ "hArr",8660,"harr",8596,"hearts",9829,"hellip",8230,0
ASM &I DQ "iacute",237,"Iacute",205,"icirc",238,"Icirc",206,"iexcl",161,"Igrave",204,"igrave",236,"image",8465,"infin",8734,"int",8747
ASM    DQ "Iota",921,"iota",953,"iquest",191,"isin",8712,"Iuml",207,"iuml",239,"inodot",305,0
ASM &J DQ 0
ASM &K DQ "Kappa",922,"kappa",954,0
ASM &L DQ "lamda",955,"Lamda",923,"lang",9001,"laquo",171,"larr",8592,"lArr",8656,"lceil",8968,"ldquo",8220,"le",8804,"lfloor",8970,"lowast",8727
ASM    DQ "loz",9674,"lrm",8206,"lsaquo",8249,"lsquo",8216,"lt",60,"lsquor",8218,"ldquor",8222,0
ASM &M DQ "macr",175,"mdash",8212,"micro",181,"middot",183,"minus",8722,"Mu",924,"mu",956,0
ASM &N DQ "nbsp",160,"ndash",8211,"ne",8800,"ni",8715,"not",172,"notin",8713,"nsub",8836,"ntilde",241,"Ntilde",209,"Nu",925,"nu",957,"nabla",8711,0
ASM &O DQ "oacute",243,"Oacute",211,"Ocirc",212,"ocirc",244,"OElig",338,"oelig",339,"ograve",242,"Ograve",210,"oline",8254,"omega",969
ASM    DQ "Omega",937,"Omicron",927,"omicron",959,"oplus",8853,"or",8744,"ordf",170,"ordm",186,"Oslash",216,"oslash",248,"Otilde",213,"otilde",245
ASM    DQ "otimes",8855,"Ouml",214,"ouml",246,"ogon",731,0
ASM &P DQ "part",8706,"perp",8869,"phi",966,"Phi",934,"Pi",928,"pi",960,"piv",982,"pound",163,"plusmn",177,"para",182,"permil",8240,"prime",8242,"Prime",8243
ASM    DQ "prod",8719,"prop",8733,"psi",968,"Psi",936,0
ASM &Q DQ "quot",34,0
ASM &R DQ "radic",8730,"rang",9002,"raquo",187,"rArr",8658,"rarr",8594,"rceil",8969,"rdquo",8221,"real",8476,"reg",174,"rfloor",8971,"Rho",929,"rho",961
ASM    DQ "rlm",8207,"rsaquo",8250,"rsquo",8217,"ring",730,0
ASM &S DQ "semicol",59,"sbquo",8218,"Scaron",352,"scaron",353,"sdot",8901,"sect",167,"shy",173,"Sigma",931,"sigma",963,"sigmaf",962,"sim",8764,"spades",9824
ASM    DQ "sub",8834,"sube",8838,"sum",8721,"sup","8835","sup1",185,"sup2",178,"sup3",179,"supe",8839,"szlig",223,0
ASM &T DQ "Tau",932,"tau",964,"there4",8756,"Theta",920,"theta",952,"thetasym",977,"thinsp",8201,"THORN",222,"thorn",254,"tilde",732,"times",215,"trade",8482,0
ASM &U DQ "uacute",250,"Uacute",218,"uArr",8657,"uarr",8593,"ucirc",251,"Ucirc",219,"Ugrave",217,"ugrave",249,"uml",168,"upsih",978
ASM    DQ "upsilon",965,"Upsilon",933,"uuml",252,"Uuml",220,0
ASM &V DQ 0
ASM &W DQ "weierp",8472,0
ASM &X DQ "xi",958,"Xi",926,0
ASM &Y DQ "yacute",253,"Yacute",221,"yen",165,"yuml",255,"Yuml",376,0
ASM &Z DQ "Zeta",918,"zeta",950,"zwj",8205,"zwnj",8204,0
ASM NamePointers: DD &A,&B,&C,&D,&E,&F,&G,&H,&I,&J,&K,&L,&M,&N,&O,&P,&Q,&R,&S,&T,&U,&V,&W,&X,&Y,&Z

'***************************************************************************************************************************************
'END OF TABLES
'***************************************************************************************************************************************
END PROGRAM