'
' ####################
' #####  PROLOG  #####
' ####################
'
' A console program template
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "unc"
	IMPORT "xsx"				' Extended standard library
	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

 IMPORT "gdi32"			' gdi32.dll
	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

'
DECLARE FUNCTION Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

'***************************************************************************************************************************************************
' IMPORTANT - the console must have Lucida Console font selected. The default Raster font will not display all characters correctly
' To change it, click on console top left icon and select properties / font / Lucida Console
' For best results choose a size of 18 or more
'***************************************************************************************************************************************************
	hStdOut = XioGetStdOut()

? "Make some UTF16 text in a USHORT array\r\n"
	UncMakeUTF16(@a%%[],"This string will be converted to UTF16\r\n")
	UncMakeUTF16(@a%%[],"Each subsequent string appends to the existing text\r\n")
	UncMakeUTF16(@a%%[],"You can use ansi with Xblite \\ notation; hex; binary; octal; html decimal; html hex; html names; unicode U+hhhhhh notation\r\n")
	UncMakeUTF16(@a%%[],"provided each different type of input or individual character is separated by a comma\r\n")
	UncMakeUTF16(@a%%[],"spaces are not allowed except within ansi string\r\n")
	UncMakeUTF16(@a%%[],"ansi text \t xxxx,0x41,0b1111110,0o123,   more ansi with spaces    zzz,&#67,&#x56,&#XCC,&Delta,123456789,U+01FF,\r\n")
	
? "Display it in the console\r\n"
	UncViewInConsole(@a%%[])
	XioClearConsole(hStdOut)
	
? "Build UTF8 in a UBYTE array\r\n"
 
	UncMakeUTF8(@b@@[],"0xF,0xF0,0xF12,0xF008,0xF103A,0x10FFFF,&#99,&Upsilon")
	
? "Show details of UTF8 built above\r\n"
	UncShowUTF8(@b@@[],0,0,@report$): ? : ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
	
? "Get number of characters"
	nChars = UncNumCharacters(@b@@[]): ? : ? "\r\n Number of characters = "; nChars
	
? "And the number of bytes"
	len = UncLength(@b@@[]): ? : ? "\r\n Number of bytes = "; len
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
	
? "Convert the UTF8 to UTF16 - show same codepoints but different encoding\r\n"
	UncConvertUTF8ToUTF16(@b@@[],@c%%[])
	UncShowUTF16(@c%%[],0,0,@report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)

? "Select substring from UTF8\r\n"
	UncSubstringUTF8(@b@@[],3,5,@d@@[])
? "Same substring from UTF16\r\n"
	UncSubstringUTF16(@c%%[],3,5,@e%%[])
? "Show they are the same\r\n"
	UncShowUTF8(@d@@[],0,0,@report$): ? : ? report$
	UncShowUTF16(@e%%[],0,0,@report$): ? : ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)

? "Make UTF32 in a ULONG array\r\n"
	UncMakeUTF32(@f&&[],"&Alpha,&alpha,&Beta,&beta,&Gamma,&gamma,&Delta,&delta,&Dagger,&copy")
	UncShowUTF32Glyphs(@f&&[],0,0,@report%%[]): UncViewInConsole(@report%%[])
	XioClearConsole(hStdOut)
	
? "Make some UTF8 and open it in notepad\r\n"
'If this does not work for you, replace "NOTEPAD" with the full pathname e.g."C:/Windows/system32/notepad.exe" for your set-up
	UncMakeUTF8(@g@@[],"ABCD,&alpha,&beta,&ouml,CDEF,&Aacute,\r\nClose Notepad to continue\0")
	UncOpenInApplication(@g@@[],"NOTEPAD")
	XioClearConsole(hStdOut)
	
? "Make a Wide String for Windows\r\n"
	UncMakeWS(@w$,"This can be passed to a Windows Wide function like so\r\nPress OK to continue\0")
	MessageBoxW(0,&w$,3,0)
	UncMakeUTF16(@h%%[],"You can also pass UTF16 in an array\r\nPress OK to continue\0") 
	MessageBoxW(0,&h%%[],3,0)
	XioClearConsole(hStdOut)
	
? "You can make sure your WideStrings and UTF16 arrays always have a terminating null by setting AutoNull ON\r\n"
	UncSetAutoNull($$TRUE)
	UncMakeWS(@x$,"abc")
	UncShowWS(@x$,0,0,@report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
	
? "add some more text - still got a null\r\n"
	UncMakeWS(@x$,"def")
	UncShowWS(@x$,0,0,@report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
	
? "Nulls can be added and removed easily\r\n"
	UncTrailingNullsWS(@x$,"ADD",3):	UncShowWS(@x$,0,0,@report$): ? report$
	
	UncTrailingNullsWS(@x$,"LEAVE",0):	UncShowWS(@x$,0,0,@report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
		
? "Invalid encoding can be detected\r\n"
	XstLoadData (@j@@[],"0xF1,0x55,0x56,0x87,0xF0,0x87,0x87,0x87,0x77", $$UBYTE)  'make some duff UTF8
	UncValidateUTF8 (@j@@[], @report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")

? "\r\nThen repaired by removing bad code leaving only valid sequences\r\n"	
	UncRepairUTF8 (@j@@[], @jcopy@@[], "REMOVE", $$TRUE, @report$): ? report$	
	UncShowUTF8(@jcopy@@[],0,0,@report$): ? report$
	UncValidateUTF8 (@jcopy@@[], @report$): ? report$
  a$ = INLINE$ ("\r\nPress Enter to continue >")
	XioClearConsole(hStdOut)
	
? "Alternatively, replace offending code with a substitution character\r\n"
	UncRepairUTF8 (@j@@[], @jcopyb@@[], "REPLACE", $$TRUE, @report$): ? report$
	UncValidateUTF8 (@jcopyb@@[], @report$): ? report$
	UncShowUTF8(@jcopyb@@[],0,0,@report$): ? report$

	
  a$ = INLINE$ ("\r\nEnd of Demo ---- Press Enter to quit >")

END FUNCTION
END PROGRAM